#include <cstdio>

typedef long long i64;

i64 solve(i64 n) {
    auto arr = new char[n];
    for (i64 i = 0; i < n; i++) {
        arr[i] = 1;
    }

    for (i64 p = 2; p <= n; p++) {
        if (n % p == 0) {
            for (i64 i = p; i < n; i += p) {
                arr[i] = 0;
            }
        }
    }
    #ifdef DEBUG
    for (i64 _i = 0; _i < n; _i++) {
        printf("%lld ", arr[_i]);
        if (_i % 10 == 9) puts("");
    }
    #endif

    i64 res2 = 0;
    for (i64 i = 1; i < n; i++) {
        res2 += arr[i] == 1;
    }
    res2 = (res2 + 1) / 2;
    #ifdef DEBUG
    printf("res2: %lld\n", res2);
    #endif

    for (i64 i = 1; i < n; i++) {
        if (arr[i] == 1) {
            res2--;
            if (res2 == 0) {
                return i;
            }
        }
    }
    return -1;
}
  
int main() {
    i64 t, n;
    scanf("%lld", &t);
    while (t-- > 0) {
        scanf("%lld", &n);
        printf("%lld\n", solve(n));
    }
}