#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <cstring>
#include <iomanip>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    long long n, m, c;
    cin >> n >> m >> c;

    long long minDiff = 100000000000, bestMCount, bestCCount;
    for (long long mCount = 1; mCount * m <= n + m; mCount++) {
        long long cCount = max((n - mCount * m) / c, 0ll);
        long long currentDiff = abs(n - mCount * m - c * cCount);

        if (currentDiff < minDiff) {
            minDiff = currentDiff;
            bestMCount = mCount;
            bestCCount = cCount;
        }
    }

    for (long long cCount = 1; cCount * c <= n + c; cCount++) {
        long long mCount = max((n - cCount * c) / m, 0ll);
        long long currentDiff = abs(n - mCount * m - c * cCount);

        if (currentDiff < minDiff) {
            minDiff = currentDiff;
            bestMCount = mCount;
            bestCCount = cCount;
        }
    }

    cout << bestMCount << " " << bestCCount << endl;
}
