#include <iostream>
using namespace std;
int a[1000002];
long double n, l, v;

double f(double t) {

    long double ans = 0;
    for (int i = 0; i < n; i++) {
        long double  cur;
        if (t * a[i] >= l) {
            cur = 0;
        } else {
            long double nl = l - t * a[i];
            cur = 1.0L * nl / (v + a[i]) + 1.0L * (nl * v / (v + a[i])) / v;
        }
        cur += t;
        ans += cur / n;
    }
    return ans;
}
int main() {
    cin >> n >> l >> v;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    long double lt = 0;
    long double l = 0, r = 1000000000, EPS = 1e-12; // входные данные
    while (r - l > EPS) {
        double m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
        if (f (m1) > f (m2))
            l = m1;
        else
            r = m2;
    }
    long double ans = (f(l) + f(r)) / 2;
    printf("%.12Lf\n", ans);
    return 0;
}