/*
DavitMarg
In a honky-tonk,
Down in Mexico
*/
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <random>
#include <bitset>
#include <stack>
#include <cassert>
#include <iterator>
#define mod 998244353ll
#define LL long long
#define LD long double
#define MP make_pair    
#define PB push_back
#define all(v) v.begin(), v.end()
#define fastIO ios::sync_with_stdio(false); cin.tie(0)
using namespace std;

const int N = 500005;

int n, m, used[N], lastMn[N][2], lastMx[N][2], d[N][2];
pair<LL, LL> a[N][2];
vector<pair<int,LL>> g[N];

pair<LL, LL> merge(pair<LL, LL> a, LL val)
{
	a.first = min(a.first, val);
	a.second = max(a.second, val);
	return a;
}

pair<LL, LL> merge(pair<LL, LL> a, pair<LL, LL> b)
{
	a.first = min(a.first, b.first);
	a.second = max(a.second, b.second);
	return a;
}

void bfs(int start,int f)
{
	queue<int> q;
	for (int i = 1; i <= n; i++)
	{
		a[i][f] = MP(mod * mod, -mod * mod);
		d[i][f] = mod;
		used[i] = 0;
	}

	q.push(start);
	used[start] = 1;
	d[start][f] = 0;
	while (!q.empty())
	{
		int v = q.front();
		q.pop();
		for (int i = 0; i < g[v].size(); i++)
		{
			int to = g[v][i].first;
			int w = g[v][i].second;
			if (d[to] < d[v] + 1)
				continue;
			d[to][f] = d[v][f] + 1;
			pair<LL,LL> val = merge(a[v][f], w);


			if (val.first < a[to][f].first)
				lastMn[to][f] = v;

			if (val.second > a[to][f].second)
				lastMx[to][f] = v;

			a[to][f] = merge(val, a[to][f]);

			if (!used[to])
			{
				used[to] = 1;
				q.push(to);
			}
		}
	}
}

LL getVal(int i)
{
	return max(a[i][0].second - a[i][1].first, a[i][1].second - a[i][0].first);
}

void solve()
{
	cin >> n >> m;
	while (m--)
	{
		int a, b, w;
		cin >> a >> b >> w;
		g[a].push_back(MP(b, w));
		g[b].push_back(MP(a, w));
	}

	bfs(1, 0);
	bfs(n, 1);

	int best = 1;

	for (int i = 1; i <= n; i++)
	{
		if (d[i][0] + d[i][1] == d[n][0] && getVal(i) > getVal(best))
			best = i;
	}
	
	vector<int> st,en;

	if (a[best][0].second - a[best][1].first > a[best][1].second - a[best][0].first)
	{
		int v;
		v = best;
		while (v != 1)
		{
			st.push_back(v);
			v = lastMx[v][0];
		}
		v = best;
		while (v != n)
		{
			en.push_back(v);
			v = lastMn[v][1];
		}
	}
	else
	{
		int v;
		v = best;
		while (v != 1)
		{
			st.push_back(v);
			v = lastMn[v][0];
		}
		v = best;
		while (v != n)
		{
			en.push_back(v);
			v = lastMx[v][1];
		}
	}

	st.push_back(1);
	en.push_back(n);
	reverse(all(st));
	st.pop_back();

	cout << d[n][0] << endl;
	for (int i = 0; i < st.size(); i++)
		cout << st[i] << " ";
	for (int i = 0; i < en.size(); i++)
		cout << en[i] << " ";
	cout << endl;

}

int main()
{
	fastIO;
	int t = 1;
	//cin >> t;
	while (t--)
		solve();

	return 0;
}

/*

6 8
1 5 2
5 2 5
3 5 4
1 3 10
3 4 6
4 5 7
4 6 8		
2 6 1


4 4
1 2 10
2 4 5
1 3 10
3 4 10


*/