#include <bits/stdc++.h>

using namespace std;

string to_string(string s) {
  return '"' + s + '"';
}
string to_string(const char* s) {
  return to_string((string) s);
}
string to_string(bool b) {
  return (b ? "true" : "false");
}
template <typename A, typename B>
string to_string(pair<A, B> p) {
  return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}
template <typename A>
string to_string(A v) {
  bool first = true;
  string res = "{";
  for (const auto &x : v) {
    if (!first) {
      res += ", ";
    }
    first = false;
    res += to_string(x);
  }
  res += "}";
  return res;
}
void debug_out() { cerr << endl; }
template <typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
  cerr << " " << to_string(H);
  debug_out(T...);
}
#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...) 42
#endif

int main() {
  cin.tie(0);
  ios_base::sync_with_stdio(false);
  long long n, m, c;
  cin >> n >> m >> c;
  long long mn = 1LL << 60LL;
  long long a = -1, b = -1;
  for (long long M = 0; M * m <= n; ++M) {
    long long C = (n - M * m) / c;
    for (long long CC = C; CC <= C + 10; ++CC) { 
      debug(M, C, CC);
      if (llabs(M * m + CC * c - n) < mn) {
        mn = llabs(M * m + CC * c - n);
        a = M;
        b = CC;
      }
    }
  }
  long long M = n / m + 1;
  if (llabs(M * m - n) < mn) {
    a = M;
    b = 0;
  }
  cout << a << ' ' << b << '\n';
  return 0;
}

