#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>


int n, m, c;
struct min_t {
	int m, c;
};

bool operator<(const min_t& m1, const min_t& m2) {
	return abs(n - m1.m * m - m1.c * c) < abs(n - m2.m * m - m2.c * c);
}

bool operator>(const min_t& m1, const min_t& m2) {
	return m2 < m1;
}
int main(){
	std::cin >> n >> m >> c;
	int a = n / m;
	int b = n / c;
	if (a==0 || n % a > a / 2) a++;
	if (b==0 || n % b > b / 2) b++;
	std::vector<min_t> mins(a*m + b*c, { 0, 0 });
	min_t ans = mins[m] > mins[c] ? mins[m] : mins[c];
	for(int i = 1;i * m < mins.size();++i){
		mins[i * m].m += mins[(i - 1)*m].m + 1;
		for (int j = 0; i * m + j * c < mins.size(); ++j) {
			mins[i * m + j * c].m = mins[i * m + (j - 1) * c].m;
			mins[i * m + j * c].c += mins[i * m + (j - 1) * c].c + 1;
			if (mins[i * m + j * c] < ans) {
				ans = mins[i * m + j * c];
			}
		}
	}
	std::cout << ans.m << ' ' << ans.c;
}