#ifdef ONPC
    #define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define sz(a) ((int)((a).size()))
#define char unsigned char

using namespace std;
// mt19937 rnd(239);
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;

int solve() {
    int n, k;
    if (!(cin >> n >> k)) {
        return 1;
    }
    vector<vector<int>> g(1, vector<int>(26, -1));
    vector<int> good(1, 0);
    int cnt = 1;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        int v = 0;
        for (int j = 0; j < sz(s); j++) {
            int x = s[j] - 'a';
            if (g[v][x] == -1) {
                g[v][x] = cnt++;
                g.push_back(vector<int>(26, -1));
                good.push_back(0);
            }
            v = g[v][x];
        }
        good[v]++;
    }
    vector<int> siz(cnt, 0);
    vector<int> pr(cnt, -1);
    vector<int> dl(cnt, 0);

    function<void(int)> dfs = [&](int v) {
        siz[v] = good[v];
        for (int u : g[v]) {
            if (u == -1) {
                continue;
            }
            pr[u] = v;
            dfs(u);
            siz[v] += siz[u];
        }
    };
    dfs(0);
    vector<int> used(cnt, 0);
    int ans = 0;
    priority_queue<pair<int, int>> q;
    for (int i = 0; i < cnt; i++) {
        //cout << i << ' ' << siz[i] << endl;
        if (siz[i] <= k && (pr[i] == -1 || siz[pr[i]] > k)) {
            q.push(make_pair(siz[i], -i));
        }
    }
    function<void(int)> dfs2 = [&](int v) {
        used[v] = true;
        for (int u : g[v]) {
            if (u == -1 || used[u]) {
                continue;
            }
            dfs2(u);
        }
    };
    auto upd = [&](int v) {
        dl[v] = 0;
        for (int u : g[v]) {
            if (u != -1) {
                dl[v] += dl[u];
            }
        }
    };
    while (!used[0]) {
        int v = -q.top().second;
        q.pop();
        if (used[v]) {
            continue;
        }
        //cout << v << endl;
        dfs2(v);
        ans++;
        dl[v] = siz[v];
        int u = pr[v];
        if (u == -1) {
            continue;
        }
        //dl[u] += dl[v];
        upd(u);
        //cout << u << ' ' << siz[u] << ' ' << dl[u] << endl;
        if (siz[u] - dl[u] > k) {
            continue;
        }
        while (pr[u] != -1 && siz[pr[u]] - dl[pr[u]] - dl[u] <= k) {
            //dl[pr[u]] += dl[u];
            u = pr[u];
            upd(u);
        }
        //cout << v << ' ' << u << endl;
        q.push(make_pair(siz[u] - dl[u], -u));
    }
    cout << ans << '\n';
    return 0;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int TET = 1e9;
    //cin >> TET;
    for (int i = 1; i <= TET; i++) {
        if (solve()) {
            break;
        }
        #ifdef ONPC
            cout << "__________________________" << endl;
        #endif
    }
    #ifdef ONPC
        cerr << endl << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
    #endif
}
