//  Copyright 2021 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
    #define debug(x) cerr << (#x) << ":\t" << (x) << endl
#else
    #define debug(x) 238;
#endif

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int mask[3];

  string s;
  for (int i = 0; i < 3; ++i) {
    getline(cin, s, '\n');
    mask[i] = (s.back() == 's');
  }

  string ans;

  if (mask[0] == 0 && mask[1] == 0) {
    ans = "x y +";
  } else if (mask[0] == 0 && mask[1] == 1) {
    ans = "x 4 ^ x 2 ^ 2 * - y 2 ^ +";
  } else if (mask[0] == 1 && mask[1] == 0) {
    ans = "x 4 ^ -1 * x 2 ^ 2 * + y 2 ^ -";
  } else {
    ans = "x 4 ^ x 2 ^ 2 * - y 4 ^ - y 2 ^ 2 * +";
  }

  if (mask[2] == 1) {
    ans += " x 5 - 2 ^ * y 5 - 2 ^ *";
  }

  cout << ans << '\n';

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
