#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple
#define x first
#define y second
#define int ll

const int N = 1 << 20;
const int A = 26;

int n, k;
int go[N][A];
int dp[N][2];
int sz[N], here[N];
int ff = 2;

void add(string s) {
	int v = 1;
	for (char ch : s) {
		int c = ch - 'a';
		++sz[v];
		if (!go[v][c]) {
			go[v][c] = ff++;
		}
		v = go[v][c];
	}
	++sz[v];
	++here[v];
}

pair<int, int> solve(int v) {
	if (sz[v] <= k) {
		return {0, sz[v]};
	}
	vector<int> sons;
	int answer = 0;
	for (int i = 0; i < A; ++i) {
		int u = go[v][i];
		if (!sz[u]) {
			continue;
		}
		auto p = solve(u);
		sons.push_back(p.y);
		answer += p.x;
	}
	int sons_sum = here[v] + accumulate(all(sons), 0LL);
	sort(all(sons));
	while (sons_sum > k) {
		sons_sum -= sons.back();
		sons.pop_back();
		++answer;
	}
	// cout << sz[v] << " " << answer << " " << sons_sum << endl;
	return {answer, sons_sum};
}

signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n >> k;
	string s;
	while (cin >> s) {
		add(s);
	}
	auto p = solve(1);
	cout << p.x + (int)(p.y > 0) << "\n";
	return 0;
}