#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define mp make_pair
#ifndef MY
    #define endl '\n'
#endif
#define int long long
#define sz(x) (int)x.size()

typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair < int, int > pii;



const int inf = 1e9 + 7;
const int N = 1<<18;
const int M = 2 * N + 5;
int lst[M];
pii tom[M];
int val[M], prf[M], suf[M], sum[M];
int m, n;

int day(int x) {
    return x / m;
}

void update(int i) {
    int l = i * 2, r = i * 2 + 1;
    val[i] = max({val[l], val[r], suf[l] + prf[r]});
    suf[i] = max(suf[r], sum[r] + suf[l]);
    prf[i] = max(prf[l], sum[l] + prf[r]);
    sum[i] = sum[l] + sum[r];
}

void update(int i, int v) {
//    cout << v <<  ' ';
    i += N;
    val[i] = prf[i] = suf[i] = sum[i] = v;
    for (i /= 2; i > 0; i /= 2) {
        update(i);
    }
}

void add(int l, int r, int t) {
    int dl = day(lst[l] + t), dr = day(lst[r] + t);
    if (dl == dr) {
        update(l, 0);
    } else if (dl + 1 == dr) {
        update(l, 1);
    } else {
        update(l, -inf);
    }
}

void add(int i, int t) {
    if (i + 1 < n) {
        add(i, i + 1, t);
    }
    if (i) {
        add(i - 1, i, t);
    }
}

int f(int x) {
    if (x < 0) {
        return 1;
    }
    return x + 1;
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> lst[i];
        tom[i] = {m - lst[i] % m, i};
    }
    for (int i = 0; i < n - 1; i++) {
        add(i, i + 1, 0);
    }
//    cout << endl;
    update(n - 1, -inf);
    sort(tom, tom + n);
//    for (int i = 0; i < n; i++) {
//        cout << lst[i] / m << ' ';
//    }cout << endl;
    int ans = f(val[1]), anst = 0;
    for (int i = 0; i < n; i++) {
        int t = tom[i].F;
        add(tom[i].S, t);
        if (tom[i].F != tom[i + 1].F) {
            int cur = f(val[1]);
            if (ans < cur) {
                ans = cur;
                anst = t;
            }
        }
    }
    cout << ans << ' ' << anst << endl;
    for (int i = 0; i < n; i++) {
        update(i, 0);
    }
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
    //freopen("f.out", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    fill(val, val + M, -inf);
    fill(prf, prf + M, -inf);
    fill(suf, suf + M, -inf);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
