#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple
#define x first
#define y second
#define int ll

const int N = 1 << 18;
const int INF = 1e18;

struct info {
	int dist = INF;
	int pr = -1;
	int minl = INF;
	int maxr = 0;
	int answer = -1;
	void upd(int c) {
		++dist;
		answer = max(answer, c - minl);
		answer = max(answer, maxr - c);
		minl = min(minl, c);
		maxr = max(maxr, c);
	}
};

ostream &operator<<(ostream &out, info a) {
	return out << a.dist << " " << a.pr << " " << a.minl << " " << a.maxr << " " << a.answer;
}

bool umin(info &a, info b) {
	if (a.dist != b.dist) {
		if (a.dist < b.dist) {
			return false;
		} else {
			a = b;
			return true;
		}
	}
	a.minl = min(a.minl, b.minl);
	a.maxr = max(a.maxr, b.maxr);
	a.answer = max(a.answer, b.answer);
	return false;
}

info add(info a, int v, int c) {
	a.upd(c);
	a.pr = v;
	return a;
}

vector<pair<int, int>> g[N];
info a[N];
queue<int> q;

signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0); cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int v, u, c; cin >> v >> u >> c; ) {
		--v, --u;
		g[v].emplace_back(u, c);
		g[u].emplace_back(v, c);
	}
	q.push(0);
	a[0].dist = 0;
	a[0].answer = 0;
	while (q.size()) {
		int v = q.front(); q.pop();
		// cout << v + 1 << " " << a[v] << endl;
		for (auto e : g[v]) {
			int u, c;
			tie(u, c) = e;
			info cnd = add(a[v], v, c);
			if (umin(a[u], cnd)) {
				q.push(u);
			}
		}
	}
	int v = n - 1;
	cout << a[v].dist << "\n";
// #ifdef LC
// 	cout << a[v].answer << endl;
// #endif
	vector<int> path;
	for (; v != -1; v = a[v].pr) {
		path.push_back(v);
	}
	reverse(all(path));
	for (int e : path) {
		cout << e + 1 << " ";
	}
	cout << "\n";
	return 0;
}