#include <bits/stdc++.h>
#pragma GCC optimize("-O3")
#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("avx2")
//#include "testlib.h"
#include <random>
#include <time.h>
#include <math.h>
#define ll long long
#define ull unsigned long long
#define mp make_pair
#define pb push_back
#define all(v) v.begin(),v.end()
#define fi first
#define se second
#define pll pair<ll,ll>
#define pii pair<int,int>
#define ld long double
#define sqr(x) ((x)*(x))

using namespace std;

mt19937_64 rnd(time(0));

const ld E=5e-7;
//const ld PI=M_PI;

ll n, m;
vector<pll> c[200001], g[200001], q[200001];
ll dist[200001];
pair<pll,pll> m1[200001], m2[200001];
vector<pair<pll, ll> > edges;

void solve()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        ll x, y, h;
        cin >> x >> y >> h;
        c[x].pb(mp(y, h));
        c[y].pb(mp(x, h));
        edges.pb(mp(mp(x, y), h));
    }
    set<pll> s;
    for (int i = 1; i <= n; i++) {
        dist[i]=1e18;
    }
    dist[1]=0;
    queue<ll> qq;
    qq.push(1);
    vector<pll> vv;
    while (!qq.empty()) {
        ll h = qq.front();
        qq.pop();
        vv.pb(mp(dist[h], h));
        for (int i = 0; i < c[h].size(); i++) {
            if (dist[c[h][i].fi] > dist[h] + 1) {
                dist[c[h][i].fi] = dist[h] + 1;
                qq.push(c[h][i].fi);
            }
        }
    }

    if (dist[n]==1) {
        cout << "1\n1 " << n << "\n";
        return;
    }

    for (int i = 0; i < edges.size(); i++) {
        ll x = edges[i].fi.fi;
        ll y = edges[i].fi.se;
        ll h = edges[i].se;
        //cout << x << " " << y << " : " << dist[x] << " " << dist[y] << "\n";
        if (dist[x] + 1 == dist[y]) {
            g[x].pb(mp(y, h));
            q[y].pb(mp(x, h));
            //cout << "+ " << x << " " << y << "\n";
        }
        if (dist[y] + 1 == dist[x]) {
            g[y].pb(mp(x, h));
            q[x].pb(mp(y, h));
            //cout << "+ " << y << " " << x << "\n";
        }
    }

    for (int i = 1; i <= n; i++) {
        m1[i]=mp(mp(1e18, 0), mp(-1e18, 0));
        m2[i]=mp(mp(1e18, 0), mp(-1e18, 0));
    }

    for (int i = 0; i < vv.size(); i++) {
        ll h = vv[i].se;
        //cout << h << "\n";
        for (int j = 0; j < q[h].size(); j++) {
            //cout << "- " << q[h][j].fi << "\n";
            if (m1[h].fi.fi > min(q[h][j].se, m1[q[h][j].fi].fi.fi)) {
                //cout << " " << min(q[h][j].se, m1[q[h][j].fi].fi.fi) << "\n";
                m1[h].fi.fi = min(q[h][j].se, m1[q[h][j].fi].fi.fi);
                m1[h].fi.se = q[h][j].fi;
            }
            if (m1[h].se.fi < max(q[h][j].se, m1[q[h][j].fi].se.fi)) {
                m1[h].se.fi = max(q[h][j].se, m1[q[h][j].fi].se.fi);
                m1[h].se.se = q[h][j].fi;
            }
        }
    }

    for (int i = vv.size()-1; i > -1; i--) {
        ll h = vv[i].se;
        for (int j = 0; j < g[h].size(); j++) {
            if (m2[h].fi.fi > min(g[h][j].se, m2[g[h][j].fi].fi.fi)) {
                m2[h].fi.fi = min(g[h][j].se, m2[g[h][j].fi].fi.fi);
                m2[h].fi.se = g[h][j].fi;
            }
            if (m2[h].se.fi < max(g[h][j].se, m2[g[h][j].fi].se.fi)) {
                m2[h].se.fi = max(g[h][j].se, m2[g[h][j].fi].se.fi);
                m2[h].se.se = g[h][j].fi;
            }
        }
    }

    ll ans1 = -1, ans2 = -1, p1 = 0, p2 = 0;

    for (int i = 2; i <= n-1; i++) {
        //cout << i << " : " << m1[i].fi.fi << " " << m2[i].fi.fi << " " << m1[i].se.fi << " " << m2[i].se.fi << "\n";
        if (ans1 < -(m1[i].fi.fi - m2[i].se.fi)) {
            ans1 = -(m1[i].fi.fi - m2[i].se.fi);
            p1 = i;
        }
        if (ans2 < (m1[i].se.fi - m2[i].fi.fi)) {
            ans2 = (m1[i].se.fi - m2[i].fi.fi);
            p2 = i;
        }
    }

    //cout << ans1 << " " << ans2 << " " << p1 << " " << p2 << "\n";

    vector<ll> an;
    if (ans1 < ans2) {
        vector<ll> z1, z2;
        ll x;
        x = p2;
        while (x>1) {
            x=m1[x].se.se;
            z1.pb(x);
        }
        while (!z1.empty()) {
            an.pb(z1.back());
            z1.pop_back();
        }
        an.pb(p2);
        x = p2;
        while (x<n) {
            x=m2[x].fi.se;
            z2.pb(x);
        }
        for (int i = 0; i < z2.size(); i++) an.pb(z2[i]);
    } else {
        vector<ll> z1, z2;
        ll x;
        //cout << p1 << " " << m1[p1].fi.se << "\n";
        x = p1;
        while (x>1) {
            x=m1[x].fi.se;
            z1.pb(x);
            //cout << x << "\n";
        }
        while (!z1.empty()) {
            an.pb(z1.back());
            z1.pop_back();
        }
        an.pb(p1);
        x = p1;
        while (x<n) {
            x=m2[x].se.se;
            z2.pb(x);
        }
        for (int i = 0; i < z2.size(); i++) an.pb(z2[i]);
    }
    cout << an.size()-1 << "\n";
    for (int i = 0; i < an.size(); i++) {
        cout << an[i] << " ";
    }
    cout << "\n";
}


int main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    //freopen("input.txt","r",stdin);
    //freopen("output.txt","w",stdout);
    ll t=1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}
/*
1
101101010111101
2
01100110010101111101

2
01100111010101111101
*/
