#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using cd = complex<ld>;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  int h, w;
  cin >> h >> w;
  vector<string> a(h);
  for (int i = 0; i < h; i++) {
    cin >> a[i];
  }

  vector<vector<bool>> used(h, vector<bool>(w));
  auto isF = [&](int i, int j) {
    for (int k = 0; k <= 2; k++) {
      if (a[i][j + k] != '#') {
        return false;
      }
    }
    return a[i + 1][j] == '#' && a[i + 2][j] == '#' && a[i + 2][j + 1] == '#' && a[i + 3][j] == '#' &&
           a[i + 4][j] == '#' && a[i + 1][j + 1] == '.';
  };
  auto isQ = [&](int i, int j) {
    for (int k = 0; k <= 2; k++) {
      if (a[i][j + k] != '#') {
        return false;
      }
    }
    if (a[i + 1][j] != '#'|| a[i + 1][j + 1] != '.' || a[i + 1][j + 2] != '#') {
      return false;
    }
    for (int k = 0; k <= 2; k++) {
      if (a[i + 2][j + k] != '#') {
        return false;
      }
    }
    return a[i + 3][j + 2] == '#' && a[i + 4][j + 2] == '#';
  };
  int f = 0, q = 0;
  for (int i = 0; i + 4 < h; i++) {
    for (int j = 0; j + 2 < w; j++) {
      if (isF(i, j)) {
        f++;
        a[i][j] = '.';
        a[i][j + 1] = '.';
        a[i][j + 2] = '.';
        a[i + 1][j] = '.';
        a[i + 2][j] = '.';
        a[i + 2][j + 1] = '.';
        a[i + 3][j] = '.';
        a[i + 4][j] = '.';
        used[i][j] = true;
      }
    }
  }
  for (int i = 0; i + 4 < h; i++) {
    for (int j = 0; j + 2 < w; j++) {
      if (!used[i][j] && isQ(i, j)) {
        q++;
        a[i][j] = '.';
        a[i][j + 1] = '.';
        a[i][j + 2] = '.';
        a[i + 1][j] = '.';
        a[i + 1][j + 2] = '.';
        a[i + 2][j] = '.';
        a[i + 2][j + 1] = '.';
        a[i + 2][j + 2] = '.';
        a[i + 3][j + 2] = '.';
        a[i + 4][j + 2] = '.';
//        cout << i + 1 << " " << j + 1 << endl;
      }
    }
  }
  cout << q << " " << f;
  return 0;
}
