#include <bits/stdc++.h>
using namespace std;

// #define constexpr(...) (__VA_ARGS__)  
using ll = long long;
using ld = long double;
const ld eps = 1e-8;
// for matching the kactl notes
#define sz(x) ((int)x.size())
#define rep(i,a,b) for (int i = (int)(a); i < (int)(b); ++i) 
#define all(a) (a).begin(), (a).end()
#define print_op(...) ostream& operator<<(ostream& out, const __VA_ARGS__& u)
// DEBUGING TEMPLETE ////////////////////////////////////////////////////////////////////////{{{
// What? You wanted to see how this template works?  Check this out:
// https://quangloc99.github.io/2021/07/30/my-CP-debugging-template.html
#define db(val) "["#val" = "<<(val)<<"] "
#define CONCAT_(x, y) x##y
#define CONCAT(x, y) CONCAT_(x, y)
#ifdef LOCAL_DEBUG   
#   define clog cerr << setw(__db_level * 2) << setfill(' ') << "" << setw(0)
#   define DB() debug_block CONCAT(dbbl, __LINE__)
    int __db_level = 0;
    struct debug_block {
        debug_block() { clog << "{" << endl; ++__db_level; }
        ~debug_block() { --__db_level; clog << "}" << endl; }
    };
#else
#   define clog if (0) cerr
#   define DB(...)
#endif

template<class U, class V> print_op(pair<U, V>) {
    return out << "(" << u.first << ", " << u.second << ")";
}
template<class Con, class = decltype(begin(declval<Con>()))>
typename enable_if<!is_same<Con, string>::value, ostream&>::type
operator<<(ostream& out, const Con& con) { 
    out << "{";
    for (auto beg = con.begin(), it = beg; it != con.end(); ++it)
        out << (it == beg ? "" : ", ") << *it;
    return out << "}";
}
template<size_t i, class T> ostream& print_tuple_utils(ostream& out, const T& tup) {
    if constexpr(i == tuple_size<T>::value) return out << ")"; 
    else return print_tuple_utils<i + 1, T>(out << (i ? ", " : "(") << get<i>(tup), tup); 
}
template<class ...U> print_op(tuple<U...>) {
    return print_tuple_utils<0, tuple<U...>>(out, u);
}
// ACTUAL SOLUTION START HERE ////////////////////////////////////////////////////////////////}}}

const int maxn = 301010;
int n;
int w[maxn], b[maxn];

struct Edge {
    int u, v;
    char color;
    Edge(int u_, int v_, char c): u(u_), v(v_), color(c) {}
    friend print_op(Edge) {
        return out << "(" << u.u << ", " << u.v << ", " << u.color << ")";
    }
};

vector<Edge> gans;
struct DSU {
    vector<int> par;
    vector<list<int>> b_pos;
    DSU(int len, int* b_arr): par(len + 1, -1), b_pos(len + 1) {
        rep(i, 0, len + 1) {
            rep(cnt, 0, b_arr[i])
                b_pos[i].push_back(i);
        }
    }
    
    int find_set(int u) {
        return par[u] < 0 ? u : par[u] = find_set(par[u]);
    }
    
    void join(int u, int v) {
        u = find_set(u);
        v = find_set(v);
        if (u == v) return ;
        if (-par[u] < -par[v]) swap(u, v);
        par[u] += par[v];
        par[v] = u;
        b_pos[u].splice(b_pos[u].end(), b_pos[v]);
    }
    
    bool is_same(int u, int v) {
        return find_set(u) == find_set(v);
    }
};

optional<vector<Edge>> solve() {
    DB();
    if (n == 1) {
        if (w[1] or b[1]) return {};
        return {{}};
    }
    gans.clear();
    vector<int> all_black, all_white;
    vector<int> bleaves, wleaves;
    vector<int> neural;
    int sum_b = 0, sum_w = 0;
    rep(i, 1, n + 1) {
        sum_b += b[i];
        sum_w += w[i];
        if (w[i] == 0 and b[i] == 0) return {};
        if (w[i] == 0) {
            if (b[i] > 1) all_black.push_back(i);
            else bleaves.push_back(i);
        }
        if (b[i] == 0) {
            if (w[i] > 1) all_white.push_back(i);
            else wleaves.push_back(i);
        }
        if (w[i] >= 1 and b[i] >= 1) {
            neural.push_back(i);
        }
    }
    clog << db(sum_b) << db(sum_w) << endl;
    clog << db(sum_b + sum_w) << endl;
    if (sum_b % 2 or sum_w % 2) return {};
    if ((sum_b + sum_w) != 2 * n - 2) return {};
    
    int xb = all_black.empty() ? -1 : all_black[0];
    int xw = all_white.empty() ? -1 : all_white[0];
    clog << db(all_black) << db(all_white) << endl;
    rep(i, 1, sz(all_black)) {
        int u = all_black[i];
        gans.emplace_back(xb, u, 'B');
        b[xb] += b[u];
        b[xb] -= 2;
    }
    rep(i, 1, sz(all_white)) {
        int u = all_white[i];
        gans.emplace_back(xw, u, 'W');
        w[xw] += w[u];
        w[xw] -= 2;
    }
    
    if (xb != -1) {
        while (b[xb] > 1) {
            if (bleaves.empty()) return {};
            int u = bleaves.back();
            bleaves.pop_back();
            --b[xb];
            --b[u];
            gans.emplace_back(xb, u, 'B');
        }
        bleaves.push_back(xb);
    }
    if (xw != -1) {
        while (w[xw] > 1) {
            if (wleaves.empty()) return {};
            int u = wleaves.back();
            wleaves.pop_back();
            --w[xw];
            --w[u];
            gans.emplace_back(xw, u, 'W');
        }
        wleaves.push_back(xw);
    }
    
    clog << db(neural) << db(bleaves) << db(wleaves) << endl;
    sum_w = 0;
    sum_b = 0;
    for (auto u: neural) {
        sum_w += w[u];
        sum_b += b[u];
    }
    clog << db(sum_w) << db(sum_b) << endl;
    if (!neural.size()) {
        if (bleaves.size() == 2) {
            if (wleaves.size() > 0) return {};
            int u = bleaves[0], v = bleaves[1];
            gans.emplace_back(u, v, 'B');
            return {gans};
        }
        if (wleaves.size() == 2) {
            if (bleaves.size() > 0) return {};
            int u = wleaves[0], v = wleaves[1];
            gans.emplace_back(u, v, 'W');
            return {gans};
        }
        return {};
    }
    sort(all(neural), [](int u, int v) {
            return w[u] > w[v];
            });
    int root = neural[0];
    queue<int> bqu, wqu;
    wqu.push(root);
    bqu.push(root);
    int i = 1;
    for (; i < sz(neural); ++i) {
        int u = neural[i];
        if (sum_w > sz(wleaves)) {
            if (wqu.empty()) return {};
            int v = wqu.front();
            wqu.pop();
            gans.emplace_back(u, v, 'W');
            --w[u];
            --w[v];
            if (w[u]) wqu.push(u);
            if (w[v]) wqu.push(v);
            sum_w -= 2;
        } else break;
        bqu.push(u);
    }
    sort(neural.begin() + i, neural.end(), [](int u, int v) { return b[u] > b[v]; });
    for (; i < sz(neural); ++i) {
        int u = neural[i];
        if (sum_b > sz(bleaves)) {
           if (bqu.empty()) return {};
           int v = bqu.front();
           bqu.pop();
           gans.emplace_back(u, v, 'B');
           --b[u];
           --b[v];
           if (b[u]) bqu.push(u);
           if (b[v]) bqu.push(v);
           sum_b -= 2;
        } else break;
    }
    if (sum_w != sz(wleaves) or sum_b != sz(bleaves)) return {};
    clog << db(sum_w) << db(sum_b) << endl;
    clog << db(gans) << endl;
    
    int p = 0;
    for (auto u: bleaves) {
        while (p < sz(neural) and b[neural[p]] == 0) ++p;
        if (p == sz(neural)) return {};
        int x = neural[p];
        gans.emplace_back(x, u, 'B');
        --b[x];
        --b[u];
    }
    p = 0;
    for (auto u: wleaves) {
        while (p < sz(neural) and w[neural[p]] == 0) ++p;
        if (p == sz(neural)) return {};
        int x = neural[p];
        gans.emplace_back(x, u, 'W');
        --w[x];
        --w[u];
    }
    return {gans};
}

int main() {
#ifdef LOCAL
    freopen("main.inp", "r", stdin); 
    freopen("main.out", "w", stdout);  
    freopen(".log", "w", stderr);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    int ntest;
    cin >> ntest;
    while (ntest--) {
        cin >> n;
        rep(i, 1, n + 1) {
            cin >> w[i] >> b[i];
        }
        auto ans = solve();
        if (!ans) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
            for (auto [u, v, c]: *ans) {
                cout << u << ' ' << v << ' ' << c << '\n';
            }
        }
    }
    
    return 0;
}

// vim: foldmethod=marker

