#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

const int N = DEB ? 100 : 3e5 + 7;
const int A = 26;

int t_sz = 1;
int t[N][A];
int term[N];

int n, k;
vector<int> g[N];

void scan() {
  cin >> n >> k;
  for (int i = 0; i < n; ++i) {
    string s;
    cin >> s;
    int v = 0;
    for (char c : s) {
      c -= 'a';
      if (t[v][c] == 0) {
        t[v][c] = t_sz++;
        g[v].push_back(t[v][c]);
      }
      v = t[v][c];
    }
    ++term[v];
  }
  n = t_sz;
}

int sz[N];

void dfs_init(int v) {
  sz[v] = term[v];
  for (int u : g[v]) {
    dfs_init(u);
    sz[v] += sz[u];
  }
}

int dfs(int v) {
  int bu = g[v][0];
  for (int u : g[v]) {
    if (sz[u] > k) {
      int res = dfs(u);
      sz[v] -= res;
      return res;
    }
    if (sz[u] > sz[bu]) {
      bu = u;
    }
  }
  int res = sz[bu];
  sz[bu] = 0;
  sz[v] -= res;
  return res;
}

void run_solve() {
  scan();
  dfs_init(0);
  int ans = 0;
  while (sz[0]) {
    if (sz[0] <= k) {
      sz[0] = 0;
    } else {
      dfs(0);
    }
    ++ans;
  }
  cout << ans << '\n';
}