#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

const int N = 307;

int n, m;
char f[N][N];
int cnt_f = 0, cnt_q = 0;

int fdx[8] = {0, 1, 2, 3, 4, 0, 2, 0};
int fdy[8] = {0, 0, 0, 0, 0, 1, 1, 2};

void add_f(int i, int j) {
  for (int k = 0; k < 8; ++k) {
    int x = i + fdx[k];
    int y = j + fdy[k];
    f[x][y] = '.';
  }
  ++cnt_f;
}

int qdx[10] = {0, 1, 2, 0, 2, 0, 1, 2, 3, 4};
int qdy[10] = {0, 0, 0, 1, 1, 2, 2, 2, 2, 2};

void add_q(int i, int j) {
  for (int k = 0; k < 10; ++k) {
    int x = i + qdx[k];
    int y = j + qdy[k];
    f[x][y] = '.';
  }
  ++cnt_q;
}

void run_solve() {
  cin >> n >> m;
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      cin >> f[i][j];
    }
  }
  for (int j = 0; j < m; ++j) {
    for (int i = 0; i < n; ++i) {
      if (f[i][j] == '#') {
        if (f[i + 3][j] == '#' && f[i + 4][j] == '#') {
          add_f(i, j);
        } else {
          add_q(i, j);
        }
      }
    }
  }
  cout << cnt_q << ' ' << cnt_f << '\n';
}
