// #pragma GCC optimize("Ofast,no-stack-protector,unroll-all-loops,unroll-loops")
// #pragma GCC target("abm,mmx,sse,sse2,sse3,ssse3,sse4a,popcnt,tune=native")
 
#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <ctime>

#define prev asldasd
 
using namespace std;

typedef long long ll;
typedef long double dbl;


const int maxn = 1e5 + 7;

const int inf = 1e9 + 7;

 
void solve(){
    int n;
    cin >> n;
    vector<int> black(n), white(n);
    vector<pair<int, int>> order;
    set<tuple<int, int, int>> blacks, whites;
    int summa = 0;
    bool ok = true;
    for (int i = 0; i < n; i++){
        cin >> white[i] >> black[i];
        if (white[i] + black[i] == 0 && n > 1)
            ok = false;
        summa += white[i] + black[i];
        if (white[i] + black[i] == 1)
            order.push_back({i, black[i] ? 1 : 0});
        blacks.insert({black[i], white[i], i});
        whites.insert({white[i], black[i], i});
    }
    if (summa != 2 * (n - 1) || !ok){
        cout << "No\n";
        return;
    }
    int cur = 0;
    vector<tuple<int, int, char>> answer;
    // return;
    while (cur < order.size() && answer.size() < n - 1){
        auto[v, is_black] = order[cur++];
        blacks.erase({black[v], white[v], v});
        whites.erase({white[v], black[v], v});
        int u;
        if (is_black)
            u = get<2>(*blacks.rbegin());
        else
            u = get<2>(*whites.rbegin());     
        if ((is_black && !black[u]) || (!is_black && !white[u])){
            cout << "No\n";
            return;
        }
        answer.push_back({v, u, is_black ? 'B' : 'W'});
        blacks.erase({black[u], white[u], u});
        whites.erase({white[u], black[u], u}); 
        if (is_black)
            black[u]--;
        else
            white[u]--;
        if (black[u] + white[u] == 1)
            order.push_back({u, black[u] ? 'B' : 'W'});
        if (black[u] + white[u] > 0) {
            blacks.insert({black[u], white[u], u});
            whites.insert({white[u], black[u], u});
        }
    }
    if (answer.size() != n - 1){
        cout << "No" << '\n';
        return;
    }
    cout << "Yes\n";
    for (auto[v, u, c] : answer)
        cout << v + 1 << ' ' << u + 1 << ' ' << c << '\n';
}

 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}