﻿#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <unordered_map>
#include <random>
#include <chrono>
using namespace std;

#define X real()
#define Y imag()
#define endl '\n'
#define int long long
#define all(X) (X).begin(), (X).end()
#define rall(X) (X).rbegin(), (X).rend()
mt19937_64 rnd(chrono::system_clock::now().time_since_epoch().count());
int gcd(int a, int b) { return b ? gcd(b, a % b) : a; }
int lcm(int a, int b) { return a * b / gcd(a, b); }

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
//#ifndef ONLINE_JUDGE
//	freopen("input.txt", "r", stdin);
//#endif

	int t; cin >> t;
	int ops = 0;
	vector<vector<pair<int, int>>> threads;
	vector<pair<int, int>> result;
	vector<int> need;

	auto inp = [&t, &ops, &threads, &result, &need]() {
		auto _split = [](string &s) {
			int bord = find(all(s), '=') - s.begin();
			string var = "", val = "";
			for (int q = 0; q < bord; q++)
				var.push_back(s[q]);
			for (int q = bord + 1; q < s.size(); q++)
				val.push_back(s[q]);
			return make_pair(var, stoll(val));
		};

		vector<vector<pair<string, int>>> a(t);
		for (int i = 0; i < t; i++) {
			int n; cin >> n;
			ops += n;
			a[i].resize(n);
			for (int j = 0; j < n; j++) {
				string s; cin >> s;
				a[i][j] = _split(s);
			}
		}
		vector<string> order;
		int k; cin >> k;
		vector<pair<string, int>> res(k);
		for (int i = 0; i < k; i++) {
			string var; cin >> var;
			order.push_back(var);
			int val; cin >> val;
			res[i] = make_pair(var, val);
		}
		sort(all(order));

		threads.resize(t);
		for (int i = 0; i < t; i++) {
			threads[i].resize(a[i].size());
			for (int j = 0; j < a[i].size(); j++)
				threads[i][j] = make_pair(find(all(order), a[i][j].first) - order.begin(), a[i][j].second);
		}
		result.resize(k);
		for (int i = 0; i < k; i++)
			result[i] = make_pair(find(all(order), res[i].first) - order.begin(), res[i].second);
		need.resize(k);
		for (int i = 0; i < k; i++)
			need[result[i].first] = result[i].second;
	};
	inp();
	
	vector<int> ans;
	vector<bool> used(result.size());
	while (ans.size() < ops) {
		int thread_num = -1;
		for (int i = 0; i < t; i++) 
			if (!threads[i].empty() && threads[i].back().second == need[threads[i].back().first]) 
				thread_num = i;
			
		if (thread_num == -1) {
			cout << "No";
			return 0;
		}

		ans.push_back(thread_num);
		used[threads[thread_num].back().first] = 1;
		threads[thread_num].pop_back();
		
		for (int i = 0; i < t; i++) {
			while (!threads[i].empty() && used[threads[i].back().first]) {
				ans.push_back(i);
				threads[i].pop_back();
			}
		}
	}

	cout << "Yes" << endl;
	reverse(all(ans));
	for (auto &i : ans)
		cout << i + 1 << " ";
	return 0;
}