#include <bits/stdc++.h>

using namespace std;

#define len(x) (int)(x).size()
#define all(x) x.begin(), x.end()

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    cout.setf(ios::fixed), cout.precision(20);
}

constexpr int mod = 1000000007;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> arr(n, vector<int>(m, 0));
    for (int i = 0; i < n; i++) {
        string str;
        cin >> str;
        for (int j = 0; j < m; j++) {
            if (str[j] == '#')arr[i][j] = 1;
        }
    }
    int cntQ = 0, cntF = 0;
    auto isQ = [&](int i, int j) {
        set<array<int, 2>> falses{{i+1, j+1}, {i+3, j}, {i+3, j+1}, {i+4, j}, {i+4, j+1}};
        for(int ii = i; ii <= i + 4; ii++){
            for (int jj = j ; jj <= j + 2; jj++) {

                if (falses.count(array<int,2>{ii, jj})) {
                }
                else {
                    if (!arr[ii][jj]) return false;
                }
            }
        }
        for(int ii = i; ii <= i + 4; ii++){
            for (int jj = j ; jj <= j + 2; jj++) {

                if (falses.count(array<int,2>{ii, jj})) {
                }
                else {
                    if (!arr[ii][jj]) return false;
                    arr[ii][jj] = 0;
                }
            }
        }
        return true;
    };
    auto isF = [&](int i, int j) {

        set<array<int, 2>> falses{{i+1, j+1}, {i+1, j+2}, {i+2,j+2}, {i+3, j+1}, {i+3, j+2}, {i+4, j+1}, {i+4, j + 2}};
        for(int ii = i; ii <= i + 4; ii++){
            for (int jj = j ; jj <= j + 2; jj++) {

                if (falses.count(array<int,2>{ii, jj})) {
//                    if (arr[ii][jj]) return false;
                }
                else {
                    if (!arr[ii][jj]) return false;
                }
            }
        }
        for(int ii = i; ii <= i + 4; ii++){
            for (int jj = j ; jj <= j + 2; jj++) {

                if (falses.count(array<int,2>{ii, jj})) {
//                    if (arr[ii][jj]) return false;
                }
                else {
                    if (!arr[ii][jj]) return false;
                    arr[ii][jj] = 0;
                }
            }
        }
        return true;
    };
    for (int j = 0; j + 2 < m; j++) {
        for (int i = 0; i + 4 < n; i++) {
            if (arr[i][j]) {
                cntF += isF(i, j);

                cntQ += isQ(i, j);
            }
        }
    }
    cout << cntQ << " " << cntF << "\n";
}

int main() {
#ifdef SIGUSR1
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    fastio();

    int cases = 1;
//    cin >> cases;
    for (int case_i = 1; case_i <= cases; ++case_i) {
        solve();
    }

    return 0;
}
