#include <locale.h>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <numeric>
#include <iterator>
#include <sstream>
#include <map>
#include <math.h>
#include <stdio.h>
#include <stack>
#include <random>  
#include <ctime>  
#include <queue>
#include <set>
using namespace std;
using ld = long double;
using ll = long long;

ll mod = 1e9 + 7;
int const N = 3e5 + 100;

mt19937 rnd;

ll  random(ll  limit)
{
	uniform_int_distribution <ll > uniform_dist(0, limit);
	return uniform_dist(rnd);
}


ll bpow(ll a, ll p) {
	ll res = 1;
	while (p > 0) {
		if (p % 2) {
			res = res * a % mod;
		}
		a = a * a % mod;
		p /= 2;
	}
	return res;
} 


ll inv(ll a) {
	return bpow(a, mod - 2);
}


ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

void solve() {
	ll n;
	cin >> n;
	ll st = (n - 1) / 2;

	while (gcd(st, n) > 1) st--;
	cout << st << '\n';
}



int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	rnd = mt19937(956231);
	int t = 1;
	cin >> t;

	while (t--) {
		solve();
	}

}

/*

*/