#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cmath>
#include <set>
#include <utility>
#include <iterator>
#include <unordered_set>
#include <map>
#include <random>
#include <climits>
#include <cassert>
#include <queue>
#include <unordered_map>
const int MAXN = 3e5 + 1;
int n,k;
int rm[MAXN], K[MAXN];
struct node {
    int son[26];
    int term = 0;
    int p = -1;
    int prevCh = -1;
    node() {
        for (int i = 0; i < 26; ++i) {
            son[i] = -1;
        }
    }
    node(int _p, int _prevCh) {
        for (int i = 0; i < 26; ++i) {
            son[i] = -1;
        }
        p = _p;
        prevCh = _prevCh;
    }
};
int it = 1;
node mas[MAXN];
int newNode(int p, int prevCh) {
    mas[it] = node(p, prevCh);
    it++;
    return it - 1;
}
void add(std::string &s) {
    int n = s.size();
    int cur = 0;
    for (int i = 0; i < n; ++i) {
        int c = s[i] - 'a';
        if (mas[cur].son[c] == -1) {
            mas[cur].son[c] = newNode(cur, c);
        }
        cur = mas[cur].son[c];
    }
    mas[cur].term++;
}
void dfs(int v){
    bool f = false;
    auto cur = mas[v];
    std::vector<int> item, titem;
    std::multiset<int> can_del;
    if (cur.term > 0)
    titem.push_back(cur.term);
    K[v] += cur.term;
    for (int c = 0; c < 26; ++c){
        int sn = cur.son[c];
        if (sn == -1) continue;
        f = true;
        dfs(sn);
        K[v] += K[sn];
        if (K[sn] >= k) {
            rm[v] += rm[sn];
            can_del.insert((k - (K[sn] % k)) % k);
        } else{
            titem.push_back(K[sn]);
        }
    }
    if (!f){
        K[v] = cur.term;
        rm[v] = (cur.term + k - 1) / k;
        return;
    }
    std::sort(titem.rbegin(), titem.rend());
    for (auto &x : titem){
        auto kek = can_del.lower_bound(x);
        if (kek == can_del.end()) {
            item.push_back(x);
        } else{
            can_del.erase(kek);
        }
    }
    std::sort(item.begin(), item.end());
    int cursum = 0;
    for (auto &x : item){
        if (cursum + x > k){
            rm[v]++;
        } else cursum += x;
    }
    if (cursum <= k && cursum > 0) rm[v]++;
}
void solve() {
    std::cin >> n >> k;
    for (int i = 0; i < n; ++i){
        std::string s;
        std::cin >> s;
        add(s);
    }
    dfs(0);
    std::cout << rm[0];
}
signed main(){
    std::ios_base::sync_with_stdio(0); std::cin.tie(0);
    int t = 1;
    while (t--) solve();
    return 0;
}
