#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e6;

struct Border {
    int m, idx, type;
};

bool cmp(const Border &a, const Border &b) {
    if (a.m != b.m) return a.m < b.m;
    return a.type <= b.type;
}

int main() {
    int t;
    cin >> t;
    for (int tt = 0; tt < t; tt++) {
        int n, m;
        cin >> n >> m;
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        vector<Border> borders;
        for (int i = 1; i < n; i++) {
            int diff = a[i] - a[i - 1];
            if (diff < m) {
                int in_one = (m - a[i - 1] % m) % m, sep = (m - a[i] % m) % m;
                borders.push_back({in_one, i - 1, 0});
                borders.push_back({sep, i - 1, 1});
                if (a[i] / m == a[i - 1] / m) {
                    borders.push_back({0, i - 1, 0});
                } else {
                    borders.push_back({0, i - 1, 1});
                }
            }
            if (m <= diff && diff < 2 * m) {
                int too_much = (m - a[i] % m) % m, sep = (m - a[i - 1] % m) % m;
                borders.push_back({too_much, i - 1, -1});
                borders.push_back({sep, i - 1, 1});
                if (a[i] / m == a[i - 1] / m + 1) {
                    borders.push_back({0, i - 1, 1});
                } else {
                    borders.push_back({0, i - 1, -1});
                }
            }
            if (2 * m <= diff) {
                borders.push_back({0, i - 1, -1});
            }
        }
        stable_sort(borders.begin(), borders.end(), cmp);
        vector<int> tmp(n, 0);
        int sz = borders.size(), all_time_max = 0, mm = 0;
        for (int i = 0; i < sz; i++) {
            int idx = borders[i].idx, type = borders[i].type;
            if (type == 0) {
                tmp[idx] = 0;
            }
            if (type == 1) {
                tmp[idx] = 1;
            }
            if (type == -1) {
                tmp[idx] = -INF;
            }
            int mx = 0;
            int cur = 0;
            for (int k = n - 1; k >= 0; k--) {
                if (tmp[k] < 0) {
                    cur = 0;
                    continue;
                }
                cur += tmp[k];
                mx = max(mx, cur);
            }
            if (mx + 1 > all_time_max) {
                all_time_max = mx + 1;
                mm = borders[i].m;
            }
        }
        cout << all_time_max << ' ' << mm << '\n';
    }
    return 0;
}