#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define f first
#define s second
#define pii pair<int,int>

using namespace std;

int n, m;

vector<vector<pair<int, int>>> g(n);
vector<int> p;
int path=-1;

vector<pii> bfs(int v, int to) {
	queue<int> q;
	q.push(v);
	vector<int> d(n, -1);
	vector<pair<int, int>> mn(n, {1e9, 0});
	vector<int> tp(n, -1);
	d[v] = 0;
	// cerr << v << "-----\n";
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto i : g[v]) {
			if (d[i.f] == -1) {
				q.push(i.f);
				d[i.f] = d[v] + 1;
				tp[i.f] = v;
			}	
		}
	}
	vector<bool> used(n);
	q.push(v);
	used[v] = 1;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		// cerr << v << "\n";
		for(auto i : g[v]) {
			if (d[v] == d[i.f]-1) {
				mn[i.f].f = min(mn[i.f].f, min(mn[v].f, i.s));
				mn[i.f].s = max(mn[i.f].s, max(mn[v].s, i.s));
			}
			if (!used[i.f]) {
				q.push(i.f);
				used[i.f] = 1;
			}
		}
	}
	// cerr << "----\n";
	p = tp;
	path = d[to];
	return mn;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	g.resize(n);
	for (int i = 0; i<m; i++) {
		int l, r, c;
		cin >> l >> r >> c;
		l--;
		r--;
		g[l].pb({r, c});
		g[r].pb({l, c});
	}
	vector<pii> mn1 = bfs(0, n-1);
	vector<int> p1 = p; 
	vector<pii> mn2 = bfs(n-1, 0);
	vector<int> p2 = p;
	// for (int i = 0; i<n; i++) {
	// 	cerr << "{ " << mn1[i].f << " " << mn1[i].s << "} ";
 // 	}
 // 	cerr << "\n";
 // 	for (int i = 0; i<n; i++) {
	// 	cerr << "{ " << mn2[i].f << " " << mn2[i].s << "} ";
 // 	}
 // 	cerr << "\n";
 	
	int ans = 0;
	int ansq = 0;
	for (int i = 1; i<n-1; i++) {
		if (abs(mn1[i].f-mn2[i].s) > ansq) {
			ans = i;
			ansq = abs(mn1[i].f-mn2[i].s);
		}
		if (abs(mn1[i].s-mn2[i].f) > ansq) {
			ans = i;
			ansq = abs(mn1[i].s-mn2[i].f);
		}
	}
	vector<int> path;
	int tec = ans;
	while (p1[tec] != -1) {
		path.pb(tec);
		tec = p1[tec];
	} 
	path.pb(0);
	reverse(all(path));
	tec = ans;
	while (p2[tec] != -1) {
		tec = p2[tec];
		path.pb(tec);

	} 
	cout << path.size()-1 << "\n";
	for (int i : path) {
		cout << i+1 << " ";
	}

	return 0;		
}