//#include <bits/stdc++.h>
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

int inf = 2147483647;

class Program{};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;

    vector<vector<pair<string, int>>> programs(t);

    int cnt = 0;
    for (int i = 0; i < t; ++i) {
        int l;
        cin >> l;
        for (int j = 0; j < l; ++j) {
            string s;
            cin >> s;
            string key = s.substr(0, s.find("="));
            int val = stoi(s.substr(s.find("=") + 1));
            programs[i].push_back({key, val});
            cnt += 1;
        }
    }


    set<string> used;
    map<string, int> targets;
    int k;
    cin >> k;

    for (int i = 0; i < k; ++i) {
        string key;
        int val;
        cin >> key >> val;
        targets[key] = val;
    }

    vector<int> ans;

    while (cnt > 0) {
        bool hasMove = false;
        for (int i = 0; i < programs.size(); ++i) {
            auto program = programs[i];
            if (program.empty()) continue;
            string cur_key = program.back().first;
            int cur_val = program.back().second;
            if (targets.count(cur_key) > 0 && targets.at(cur_key) == cur_val) {
                programs[i].pop_back();
                cnt -= 1;
                targets.erase(cur_key);
                used.insert(cur_key);
                ans.push_back(i + 1);
                hasMove = true;
                continue;
            }
            if (used.count(cur_key)) {
                programs[i].pop_back();
                cnt -= 1;
                ans.push_back(i + 1);
                hasMove = true;
                continue;
            }
        }
        if (!hasMove) {
            cout << "No\n";
            return 0;
        }
    }

    reverse(ans.begin(), ans.end());

    cout << "Yes\n";
    for (const auto x : ans) {
        cout << x << " ";
    }

    return 0;
}
