#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
#include <set>
#include <cmath>
#include <unordered_map>
#include <cstring>

using namespace std;

typedef long long ll;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '#') {
                cnt++;
            }
        }
    }
    int ansq = 0, ansf = 0;
    vector<int> qdi = {0, 1, 2, 0, 2, 0, 1, 2, 3, 4};
    vector<int> qdj = {0, 0, 0, 1, 1, 2, 2, 2, 2, 2};
    vector<int> fdi = {0, 1, 2, 3, 4, 0, 0, 2};
    vector<int> fdj = {0, 0, 0, 0, 0, 1, 2, 1};
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i + 2 < n; ++i) {
            if (a[i][j] == '#' && a[i + 1][j] == '#' && a[i + 2][j] == '#') {
                if (i + 3 == n || a[i + 3][j] == '.') {
                    ansq++;
                    for (int k = 0; k < 10; ++k) {
                        a[i + qdi[k]][j + qdj[k]] = '.';
                    }
                } else {
                    ansf++;
                    for (int k = 0; k < 8; ++k) {
                        a[i + fdi[k]][j + fdj[k]] = '.';
                    }
                }
            }
        }
    }
//    for (int i = 0; i < n; ++i) {
//        cout << a[i] << '\n';
//    }
    cout << ansq << ' ' << ansf << '\n';
}

bool multitest = false;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //cout.precision(10);
    size_t number_of_tests = 1;
    if (multitest) {
        cin >> number_of_tests;
    }
    for (size_t _ = 0; _ < number_of_tests; ++_) {
        solve();
    }
    return 0;
}