#include <cassert>
#include <utility>
#include <tuple>
#include <iostream>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <set>
#include <sstream>

using namespace std;
using ll = long long;

//#define int ll

#define pb push_back
#define eb emplace_back
#define agn assign
#define DEBUG(x) cerr << #x << ": " << x << "\n";
#define F first
#define S second

#define BOUNDS_1(x, n) (x >= 0 && x < n)
#define BOUNDS_2(x, n) (x > 0 && x <= n)
#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define FOR(i, a, b) for (int i = a; i < b; ++i)

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<double, int> pdi;
typedef vector<int> vi;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<ll> vll;
typedef vector<pii> vpii;
typedef vector<pll> vpll;

const int INF = 1000 * 1000 * 1000 + 10;
//const int M = 1000 * 1000 * 1000 + 7;
const ll INFLL = 1000ll * 1000 * 1000 * 1000 * 1000 * 1000;

const int MOD = 998244353;

void solve() {
    ll n;
    cin >> n;
    for (ll i = n / 2; i >= 0; --i) {
        if (gcd(i, n) == 1) {
            cout << i << "\n";
            break;
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int T;
    cin >> T;
    while (T--)
        solve();
}

