#include <iostream>
#include <climits>
#include <cstddef>
#include <cmath>
#include <vector>
#include <iomanip>
#include <cassert>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef HOME
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        clock_t start_clock = clock();
    // #else
    //  freopen(".in", "r", stdin);
    //  freopen(".out", "w", stdout);
    #endif
    
    solve();

    #ifdef HOME
        // system("pause");
        printf("\n\nfinished in %.3f sec", static_cast<float>(clock() - start_clock) / CLOCKS_PER_SEC);
    #endif
}

void solve() {
    int64_t n, m, c;
    cin >> n >> m >> c;

    pair<int64_t, int64_t> ans;
    int64_t best = numeric_limits<int64_t>::max();
    for (int64_t i = 0; i <= 3'000'000; ++i) {
        int64_t rem = m * i - n;
        int64_t c1 = abs(rem / c);
        int64_t check = abs(i * m + c * c1 - n);
        if (check < best) {
            best = check;
            ans = {i, c1};
        }
        ++c1;
        check = abs(i * m + c * c1 - n);
        if (check < best) {
            best = check;
            ans = {i, c1};
        }
    }

    cout << ans.first << ' ' << ans.second;
}
