#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <string>
#include <math.h>
#include <map>
#include <queue>
#include <stack>
#include <unistd.h>
using namespace std;
#define ll long long
#define ld long double
#define sz(x) (int)(x).size()


const int MAXN = 300001;

int g[MAXN][28];
ll t = 0;
void add(int v, string s){
    for(int i = 0; i < s.size(); i++){
        g[v][26] ++;
        int cur = int(s[i] - 'a');

        if(g[v][cur] == -1){
            t++;
            g[v][cur] = t;
            g[t][27] = v;
            v = t;
        }else{
            v = g[v][cur];
        }
    }
    g[v][26]++;
//    cout << s << ' ' << v << ' ' << g[v][26] << ' ' << g[v][27] << endl;
}

void solve(){
    for(int i = 0; i < MAXN; i++){
        for(int j = 0; j < 26; j++)
            g[i][j] = -1;
        g[i][26] = 0;
        g[i][27] = -1;
    }
    ll n, k;
    cin >> n >> k;
    for(int i = 0; i < n; i++){
        string s;
        cin >> s;
        add(0, s);
    }
    
    set<pair<ll, ll>> s;
    for(int i = MAXN - 1; i >= 0; i--){
        if(g[i][26] <= k){
            s.insert({g[i][26], i});
            for(int j = 0; j < 26; j++)
                if(g[i][j] != -1)
                    s.erase({g[g[i][j]][26], g[i][j]});
        }
    }

    ll ans = 0;

    ll col = g[0][26];
    while(true){
        ans ++;
        auto x = *s.rbegin();
        s.erase(x);
        ll v = x.second;
        for(int i = 0; i < 26; i++)
            if(g[v][i] != -1)
                s.erase({g[g[v][i]][26], g[v][i]});

        ll val = x.first;
        col -= val;
//        cout << v << ' ' << val << ' ' << g[v][27] << endl;

        g[v][26] = 0;
        
        while(g[v][27] != -1){
            ll p = g[v][27];
            g[p][26] -= val;
            if(g[p][26] <= k){
                s.insert({g[p][26], p});
                s.erase({g[v][26], v});
            }
            v = p;
            
        }
        if(col == 0){
            cout << ans << endl;
            return;
        }
    }
}


int main(){
    ios::sync_with_stdio(0);cin.tie(0);
    int t = 1;
//    cin >> t;
    while(t--)
        solve();
}
/*
4 2
 a
 abc
 abd
 b
 
 
 
4 2
d
c
ab
a
 
 
5 3
please
remove
all
these
files

 
5 2
aa
bb
bc
dd
de
4


5 2
a
b
b
c
c



*/