#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <string>
#include <math.h>
#include <map>
#include <queue>
#include <stack>
#include <unistd.h>
using namespace std;
#define ll long long
#define ld long double
#define sz(x) (int)(x).size()


const int MAXN = 300001;

int g[MAXN][29];
ll t = 0;
void add(int v, string s){
    ll h = 0;
    for(int i = 0; i < s.size(); i++){
        g[v][28] = h;
        h++;
        g[v][26] ++;
        int cur = int(s[i] - 'a');

        if(g[v][cur] == -1){
            t++;
            g[v][cur] = t;
            g[t][27] = v;
            v = t;
        }else{
            v = g[v][cur];
        }
    }
    g[v][26]++;
    g[v][28] = h;
//    cout << s << ' ' << v << ' ' << g[v][26] << ' ' << g[v][27] << endl;
}

void solve(){
    for(int i = 0; i < MAXN; i++){
        for(int j = 0; j < 26; j++)
            g[i][j] = -1;
        g[i][26] = 0;
        g[i][27] = -1;
        g[i][28] = 0;
    }
    ll n, k;
    cin >> n >> k;
    for(int i = 0; i < n; i++){
        string s;
        cin >> s;
        add(0, s);
    }
    
    set<pair<pair<ll, ll>, ll>> s;
    for(int i = MAXN - 1; i >= 0; i--){
        if(g[i][26] <= k){
            s.insert({{g[i][26], g[i][28]}, i});
            for(int j = 0; j < 26; j++)
                if(g[i][j] != -1)
                    s.erase({{g[g[i][j]][26], g[g[i][j]][28]}, g[i][j]});
        }
    }
//    for (auto &p : s) {
//        cout << p.first << ' ' << p.second << endl;
//    }

    ll ans = 0;

    ll col = g[0][26];
    while(true){
        ans ++;
        auto x = *s.rbegin();
        s.erase(x);
        ll v = x.second;
        ll val = x.first.first;
        ll h = x.first.second;
//        cout << v << ' ' << val << ' ' << g[v][27] << endl;
        g[v][26] = 0;
        
        while(g[v][27] != -1){
            ll p = g[v][27];
            g[p][26] -= val;
            if(g[p][26] <= k){
                s.insert({{g[p][26], g[p][28]}, p});
                for(int i = 0; i < 26; i++)
                    if(g[p][i] != -1)
                        s.erase({{g[g[p][i]][26], g[g[p][i]][28]}, g[p][i]});
            }
            v = p;
        }

        
        col -= val;
        
        if(col == 0){
            cout << ans << endl;
            return;
        }
    }
}


int main(){
    ios::sync_with_stdio(0);cin.tie(0);
    int t = 1;
//    cin >> t;
    while(t--)
        solve();
}
/*
 *
 10 3 a aa aaa aaaa aaaaa aaaaaa aaaaaaa aaaaaaaa aaaaaaaaa aaaaaaaaaa


8 3
kek
kekk
kekkk
mem
memm
memmm
memmmm
a


4 2
 a
 abc
 abd
 b
 
 
 
4 2
d
c
ab
a
 
 
5 3
please
remove
all
these
files

 
5 2
aa
bb
bc
dd
de
4


5 2
a
b
b
c
c



*/