#include <bits/stdc++.h>
using namespace std;

#define int long long
#define double long double

pair<int, int> gcd(int a, int b) {
  if (b == 0) {
    return pair{1, 0};
  }
  auto [x, y] = gcd(b, a % b);
  return {y, x - (a / b) * y};
}

int a, b, x, y, g;

void solve(int n) {
  if (n % g) {
    return;
  }
  int X = x * n / g, Y = y * n / g;
  if ((X < 0 && Y <= 0) || (X <= 0 && Y < 0)) {
    return;
  } else if (x >= 0 && Y >= 0) {
    cout << X << ' ' << Y << '\n';
    exit(0);
  } else if (X > 0) {
    int k = X / b;
    X -= k * b;
    Y += k * a;
    if (Y < 0) {
      return;
    } else {
      cout << X << ' ' << Y << '\n';
      exit(0);
    }
  } else if (Y > 0) {
    int k = Y / a;
    X += k * b;
    Y -= k * a;
    if (X < 0) {
      return;
    } else {
      cout << X << ' ' << Y << '\n';
      exit(0);
    }
  } else {
    assert(false);
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout << fixed << setprecision(20);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  int n;
  cin >> n >> a >> b;

  auto p = gcd(a, b);
  x = p.first, y = p.second;
  g = a * x + b * y;
  a /= g, b /= g;
  for (int diff = 0;; ++diff) {
    solve(n + diff);
    solve(n - diff);
  }
}