#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#define USE_MINGW_ANSI_STDIO 0
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include<stdio.h>
#include<iomanip>
#include<set>
#include<string>
#include<map>
#include <math.h>
#include<queue>
#include<complex>
#include<ctime>
#include<list>
#include<stack>
#include<random>
#include<chrono>
#include<unordered_map>
#define ll  long long
#define lll __int128
#define fi first
#define ld long double
#define se second
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define vi vector<int>
#define vll vector<ll>
#define vii vector<vector<ll>>
#define vvld vector<vector<ld>>
#define vvll vector<vector<ll>>
const ll MAXN = 1e6+10;
const int INF  = 1e9+10;
const ll mod  =  1000000007;
const ld eps = 1e-12;
using namespace std;
auto seed = chrono::high_resolution_clock :: now().time_since_epoch().count();
mt19937_64 mt_rand(seed);
int n;
ll w[300001];
ll b[300001];
vector<int> g[300001];
bool comp(int a, int b){
	return w[a] < w[b];
}
int l[300001];
pii tree[1200001];

vector<pii> e,e1;
vector<int> a,bb;
void update(int v, int l, int r, int pos ,int val){
	if( l == r ){
		tree[v]= make_pair(val,l);
		return;
	}
	int m = (l+r)/2;
	if(pos <= m)
		update(2*v,l,m,pos,val);
	else
		update(2*v+1,m+1,r,pos,val);
	tree[v] = (b[tree[2*v].fi] < b[tree[2*v+1].fi] ? tree[2*v] : tree[2*v+1]);
}
pii get(int v , int l , int r, int L, int R){
	if(L > R)
		return {0,1};
	if(l == L && r == R)
		return tree[v];
	int m= (l+r)/2;
	pii tl = get(2*v,l,m,L,min(m,R));
	pii tr = get(2*v+1,m+1,r,max(m+1,L),R);
	return b[tl.fi] < b[tr.fi] ? tl : tr;
}
void del(int c , int d, int v, bool l = false){
	for(int i =0 ;i < c;i++){
		e.pb({v,a.back()});
		a.pop_back();
	}
	for(int i =0;i < d;i++){
		e1.pb({v,bb.back()});
		bb.pop_back();
	}
	if(l)
		bb.pb(v);
	else
		a.pb(v);
}
void solve(ll tta){
   cin >> n;
   e.clear();
   e1.clear();
   a.clear();
   bb.clear();
   for(int i = 0; i <= n ;i++)
   		l[i] = 0;
   for(int i = 1;i <= 4*n;i++)
   		tree[i] = make_pair(0,1);
   ll sumw =0 ;
   ll sumb =0; 
   for(int i =1  ;i <= n;i++){
   		cin >> w[i] >> b[i];
   		sumw+=w[i];
   		sumb+=b[i];
   	}
   	if(n == 1){
   		if(!w[1] && !b[1])
   			cout <<"Yes\n";
   		else
   			cout <<"No\n";
   		return;
   	}
   	for(int i =1 ;i<= n;i++){
   		if((!w[i] && !b[i]) || w[i]+b[i] >=n){
   			cout <<"No\n";
   			return;
   		}
   	}
   	if(sumw%2 != 0  ||  sumb%2 != 0  || (sumb+sumw)!= 2*n -2){
   		cout << "No\n";
   		return;
   	}
   	vi t;
   	b[0] = w[0] =INF;
   	for(int i = 1;i <= n;i++)
   		t.pb(i);
   sort(t.begin(),t.end(),comp);
   for(int i =  0 ;i < t.size();i++){
   		l[w[t[i]]] = i+1;
   		update(1,1,n,i+1,t[i]); 
   }
   for(int i = 1 ;i <= n;i++)
   		l[i] = max(l[i],l[i-1]);
   for(int i =0 ;i < n;i++){
   //		cout << i << endl;
   	//	cout <<"a = \n";
   	//	for(int i =0 ;i < a.size();i++)
   	//		cout << a[i]  <<" ";
   	//	cout <<"\nb = \n";
   	//	for(int i =0 ;i< bb.size();i++)
   	//		cout << bb[i] <<" ";
   	//	cout << endl;
   		int v;
   	//	cout <<"i = " << i << endl;
   		if(i == n-1){
   			pii q = get(1,1,n,1,n);
   			v = q.fi;
   	//		cout <<"root = "<< v << endl;
   			if(w[v]!= a.size() ||  b[v]!= bb.size()){
   				cout << "No\n";
   				return;
   			}
   			for(int i =0 ;i < a.size();i++){
   				e.pb({a[i],v});
   			}
   			for(int i =0 ;i < bb.size();i++){
   				e1.pb({bb[i],v});
   			}
   			break;
   		}
   		pii q = get(1,1,n,1,l[(int)a.size() + 1]);
   		 v = q.fi;
   	//	 cout <<"v = "<< v << endl;
   		if(w[v] >= a.size()+1 && b[v] >= bb.size()+1){
   			cout <<"No\n";
   			return;
   		}
   		if((b[v] == 1 && !bb.size())|| (!w[v])){
   			del(w[v],b[v]- 1,v,1);
   		}
   		else{
   			del(w[v]  -1 ,b[v],v);
   		}
   		update(1,1,n,q.se,0);
   }
   cout <<"Yes\n";
   for(int i = 0 ; i < e.size();i++){
   		cout << e[i].fi <<" "<< e[i].se <<" "<< "W\n";
   } 
   for(int i = 0 ;i < e1.size();i++){
   		cout << e1[i].fi <<" "<< e1[i].se <<" "<<"B\n";
   }
}   
 
signed main(){
    srand(time(NULL));
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(10);

    int t = 1;
	cin >> t;
    for(ll i = 0; i < t; i++)
        solve(i+1);
    return 0;
}