n, k = map(int, input().split())


class Node:

    def __init__(self, letter):
        self.letter = letter
        self.childs = {}
        self.childs_count = 0

    def add(self, word):
        if len(word) == 0:
            return
        if word[0] not in self.childs:
            self.childs[word[0]] = Node(word[0])

        self.childs[word[0]].add(word[1:])

    def find_counts(self):
        self.childs_count = 0
        for k, v in self.childs.items():
            self.childs_count += v.find_counts()
        if len(self.childs) == 0:
            return 1
        return self.childs_count

    def find_best(self, s, k):
        if self.childs_count <= k:
            return self.childs_count, s + self.letter
        best = 0
        best_s = None
        for k_, v in self.childs.items():
            sc, s_ = v.find_best(s + self.letter, k)
            if best < sc <= k:
                best = sc
                best_s = s_
        return best, best_s

    def delete(self, s):
        if len(s) == 1:
            del self.childs[s]
            return
        self.childs[s[0]].delete(s[1:])

root = Node('')

for i in range(n):
    root.add(input() + "$")

ans = 1
root.find_counts()
while root.childs_count > k:
    s, ss = root.find_best('', k)
    root.delete(ss)
    root.find_counts()
    ans += 1
print(ans)