#include <iostream>
#include <fstream>
#include <chrono>
#include <algorithm>
#include <numeric>
#include <map>
#include <set>
#include <vector>
#include <map>
#include <cmath>
#include <queue>
#include <cstring>
#include <functional>
#include <unordered_map>

struct node {
    int sz = 0;
    node* next[26]{};
    int cnt[26]{};
};

int main() {
#ifdef local
std::freopen("in", "r", stdin);
std::freopen("out", "w", stdout);
#endif
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);

    node* root = new node;
    int n, k;
    std::cin >> n >> k;
    std::string s;
    std::function<void(node*, int)> add = [&] (node* v, int pos) {
        if (pos == (int)s.size()) {
            ++v->sz;
            return;
        }
        int i = s[pos] - 'a';
        ++v->sz;
        ++v->cnt[i];
        if (v->next[i] == nullptr)
            v->next[i] = new node;
        add(v->next[i], pos + 1);
    };
    while (n--) {
        std::cin >> s;
        add(root, 0);
    }
    int ans = 0;
    std::function<int(node*)> rm = [&] (node* v) {
        // std::cout << v->sz << std::endl;
        if (v->sz <= k) {
            ++ans;
            int res = v->sz;
            v->sz = 0;
            return res;
        }
        int to = 0;
        int max = v->cnt[0];
        for (int i = 1; i < 26; ++i)
            if (v->cnt[i] > max) {
                max = v->cnt[i];
                to = i;
            }
        int res = rm(v->next[to]);
        v->sz -= res;
        v->cnt[to] -= res;
        return res;
    };
    while (root->sz) rm(root);
    std::cout << ans;
}