#include <bits/stdc++.h>
#include <regex>
#include <array>
#include <unordered_set>
#include <future>
#include <optional>
#include <any>
#include <variant>
#include <stdlib.h>
#include <cmath>
#include <random>
#include <functional>
#include <climits>

#ifdef LOCAL_UTILITS
#include "Utilits/Timer.h"
#endif

using namespace std;

using li = long long;
using vi = vector<li>;
using pi = pair<li, li>;
using vpi = vector<pi>;
using vvi = vector<vector<li>>;
using vvpi = vector<vpi>;
using ld = long double;

#define forn(i,n) for (li i = 0;i < li(n);i++)
#define ford(i,n) for (li i = li(n)-1;i >=0;i--)
#define fore(i,l,r) for (li i = li(l);i < li(r);i++)
#define forv(v,arr) for (auto& v : (arr))
#define all(a) (a).begin(),(a).end()

using Point = complex<li>;

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    forv(v, a)
        in >> v;
    return in;
}

ostream& operator<<(ostream& out, vi& a)
{
    for (auto v : a)
    {
        out << v;
        out.put(' ');
    }
    return out;
}

ostream& operator<<(ostream& out, vi&& a)
{
    for (auto v : a)
    {
        out << v;
        out.put(' ');
    }
    return out;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for (auto& s : a)
        cin >> s;
    map<char, li> res = { {'f', 0},{'q',0 } };
    auto remove_letter = [&](int i0, int j0, char c)
    {
        map<char, vvi> mp = {
            {'f', {
                {1,1,1},
                {1,0,0},
                {1,1,0},
                {1,0,0},
                {1,0,0},
            }
            },
            {'q',{
                {1,1,1},
                {1,0,1},
                {1,1,1},
                {0,0,1},
                {0,0,1},
            }}
        };
        res[c]++;
        vvi d = mp[c];
        forn(i, 5) forn(j, 3)
        {
            if (d[i][j])
                a[i0 + i][j0 + j] = '.';
        }
    };

    ford(j, m) forn(i, n - 4)
    {
        if (a[i][j] != '#')
            continue;
        remove_letter(i, j - 2,
            a[i + 1][j] == '#' ? 'q' : 'f');
    }
    cout << res['f'] << " " << res['q'] << endl;
};