#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <math.h>
#include <vector>

using namespace std;

#define log(d) for (int _i(0); _i < d.size(); _i++) {for (int _j(0); _j < d[_i].size(); _j++) {cout << (d[_i][_j] ? '#' : '.');} cout << '\n'; } cout << '\n';

using line = vector <int>;
using matrix = vector <line>;

int f, q;
matrix d, p;

void readQ(int i, int j) {
    int a0  = d[i + 0][j + 0];
    int a1  = d[i + 0][j + 1];
    int a2  = d[i + 0][j + 2];
    int a3  = d[i + 1][j + 0];
    int a5  = d[i + 1][j + 2];
    int a6  = d[i + 2][j + 0];
    int a7  = d[i + 2][j + 1];
    int a8  = d[i + 2][j + 2];
    int a11 = d[i + 3][j + 2];
    int a14 = d[i + 4][j + 2];

    if (a0 && a1 && a2 && a3 && a5 && a6 && a7 && a8 && a11 && a14) {
        q++;

        d[i + 0][j + 0] = 0;
        d[i + 0][j + 1] = 0;
        d[i + 0][j + 2] = 0;
        d[i + 1][j + 0] = 0;
        d[i + 1][j + 2] = 0;
        d[i + 2][j + 0] = 0;
        d[i + 2][j + 1] = 0;
        d[i + 2][j + 2] = 0;
        d[i + 3][j + 2] = 0;
        d[i + 4][j + 2] = 0;

        //cout << "q\n";
        //log(d);
    }
}

void readF(int i, int j) {
    int a0  = d[i + 0][j + 0];
    int a1  = d[i + 0][j + 1];
    int a2  = d[i + 0][j + 2];
    int a3  = d[i + 1][j + 0];
    int a6  = d[i + 2][j + 0];
    int a7  = d[i + 2][j + 1];
    int a9  = d[i + 3][j + 0];
    int a12 = d[i + 4][j + 0];

    if (a0 && a1 && a2 && a3 && a6 && a7 && a9 && a12) {
        f++;

        d[i + 0][j + 0] = 0;
        d[i + 0][j + 1] = 0;
        d[i + 0][j + 2] = 0;
        d[i + 1][j + 0] = 0;
        d[i + 2][j + 0] = 0;
        d[i + 2][j + 1] = 0;
        d[i + 3][j + 0] = 0;
        d[i + 4][j + 0] = 0;

        //cout << "f\n";
        //log(d);
    }
}

int main() {
    // ...
    ios::sync_with_stdio(false);

    int n, m;
    cin >> n >> m;

    d.resize(n, line(m));
    for (int i(0); i < n; i++) {
        for (int j(0); j < m; j++) {
            char c;
            cin >> c;

            d[i][j] = (c == '#');
        }
    }
    p = d;

    // F -> Q
    for (int i(0); i < n - 4; i++) {
        for (int j(0); j < m - 2; j++) {
            readF(i, j);
        }
    }

    for (int i(0); i < n - 4; i++) {
        for (int j(0); j < m - 2; j++) {
            readQ(i, j);
        }
    }

    bool is = true;
    for (int i(0); i < n; i++) {
        for (int j(0); j < m; j++) {
            if (d[i][j]) {
                is = false;
            }
        }
    }

    if (is) {
        cout << q << " " << f;
        return 0;
    }

    f = 0, q = 0;
    d = p;

    // F -> Q
    for (int i(0); i < n - 4; i++) {
        for (int j(0); j < m - 2; j++) {
            readQ(i, j);
        }
    }

    for (int i(0); i < n - 4; i++) {
        for (int j(0); j < m - 2; j++) {
            readF(i, j);
        }
    }


    return 0;
}