#include <iostream>
#include <queue>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;
struct Vert{
    int to,w;
    Vert(){}
    Vert(int to,int w):to(to),w(w){}
};
struct Node{
    int v,mi,ma,cc;
    Node(){}
    Node(int v,int cc):v(v),cc(cc),mi(1e9),ma(-1e9){}
};
int main(){
    int n,m;
    cin>>n>>m;
    vector<vector<Vert>> g(n);
    for(int i=0;i<m;++i){
        int v,u,w;
        cin>>v>>u>>w;
        --v;
        --u;
        g[v].push_back(Vert(u,w));
        g[u].push_back(Vert(v,w));
    }
    queue<Node> q;
    vector<int> dist(n,1e9);
    dist[0]=0;
    vector<int> c(n, 0),d(n),p(n,-1);
    for(auto u:g[0]){
        auto to=Node(u.to,0);
        to.mi=to.ma=u.w;
        dist[to.v]=1;
        p[u.to]=0;
        q.push(to);
    }
    while(!q.empty()){
        auto v=q.front();
        q.pop();
        if(c[v.v]!=v.cc){
            continue;
        }
        for(auto u:g[v.v]){
            auto to=Node(u.to,0);
            to.mi=min(v.mi,u.w);
            to.ma=max(v.ma,u.w);
            if(dist[v.v]+1<dist[u.to]){
                dist[u.to]=dist[v.v]+1;
                d[u.to]=to.ma-to.mi;
                q.push(to);
                p[u.to]=v.v;
            }else if(dist[v.v]+1==dist[u.to]){
                to.cc=++c[u.to];
                d[u.to]=to.ma-to.mi;
                q.push(to);
                p[u.to]=v.v;
            }
        }
    }
    vector<int> ans;
    int cur=n-1;
    while(cur!=-1){
        ans.push_back(cur);
        cur=p[cur];
    }
    reverse(ans.begin(),ans.end());
    cout<<ans.size()-1<<endl;
    for(int i:ans){
        cout<<i+1<<' ';
    }
    cout<<endl;
    return 0;
}
