#define _USE_MATH_DEFINES
#include<iostream>
#include<fstream>
#include<string>
#include<vector>
#include<utility>
#include<algorithm>
#include<climits>
#include<set>
#include<map>
#include<cmath>
#include<iomanip>
#include<iterator>
#include<queue>
#include<stack>
#include<cctype>
#include<deque>
#include<time.h>
#include<bitset>
#include<random>
#include<functional>
#include<unordered_set>
#include<unordered_map>
#include<random>
#include<numeric>
#include<sstream>
#include<cassert>
#include<chrono>
#include<complex>

//by DimaSidorenko

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#pragma warning(disable : 4996)
#pragma comment(linker, "/STACK:16777216")
#define pb push_back
#define en '\n'
#define forn(i,n) for(int i = 0;i<n;i++)
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define vec vector
#define pii pair<int,int>
#define pll pair<ll,ll>
#define szof(x) int(x.size())

using namespace std;

const int INF = 1000000000 + 1e8;
const ll LINF = 2000000000000000000;


template<typename T> void print(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
	{
		for (int j = 0; j < a[i].size(); j++)
			cout << a[i][j] << ' ';
		cout << en;
	}
}

template <typename T> void input(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
		for (int j = 0; j < a[i].size(); j++)
			cin >> a[i][j];
}

const ld EPS = 1e-8;
const ll mod = 1e9 + 7;
const int N = 400;


char dt[N][N];


vector<int> dxf = { 0, 1, 2, 0, 0, 1, 0, 0 };
vector<int> dyf = { 0, 0, 0, 1, 2, 2, 3, 4 };

vector<int> dxq = { 0, 1, 2, 0, 2, 0, 1, 2, 2, 2};
vector<int> dyq = { 0, 0, 0, 1, 1, 2, 2, 2, 3, 4 };


bool checkf(int y, int x) {
	bool ok = 1;
	for (int i = 0; i < szof(dxf); i++) {
		int nx = x + dxf[i];
		int ny = y + dyf[i];
		
		ok &= (dt[ny][nx] == '#');
		if (!ok) {
			int kek = 1;
		}

	}

	return ok;
}

void deletef(int y, int x) {
	bool ok = 1;
	for (int i = 0; i < szof(dxf); i++) {
		int nx = x + dxf[i];
		int ny = y + dyf[i];

		dt[ny][nx] = '.';
	}
}


bool checkq(int y, int x) {
	bool ok = 1;
	for (int i = 0; i < szof(dxq); i++) {
		int nx = x + dxq[i];
		int ny = y + dyq[i];

		ok &= (dt[ny][nx] == '#');
		if (!ok) {
			int kek = 1;
		}

	}

	return ok;
}

void deleteq(int y, int x) {
	bool ok = 1;
	for (int i = 0; i < szof(dxq); i++) {
		int nx = x + dxq[i];
		int ny = y + dyq[i];

		dt[ny][nx] = '.';
	}
}



void solve() {
	int n, m;
	cin >> n >> m;

	int f = 0, q = 0;

	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < m; j++) {
			dt[i][j] = s[j];
		}
	}

	//cout << checkf(0, 5) << en;;


	for (int j = m - 1; j >= 0; j--) {
		for (int i = 0; i < n; i++) {
			if (checkq(i, j)) {
				q++;
				deleteq(i, j);
			}
			if (checkf(i, j)) {
				f++;
				deletef(i, j);
			}
		}
	}

	cout << q << ' ' << f << en;
}


int main() {
	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);


#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	int tst = 1;
	//cin >> tst;

	while (tst--) {
		solve();
	}

}