n, m = map(int, input().split())

field = [[False] * (m + 1) for _ in range(n + 1)]
fs, qs = 0, 0

def find_up_right():
    x, y = 1, m
    
    while not field[x][y]:
        x += 1
        if x > n:
            x = 1
            y -= 1
        if y < 1:
            return None
    return x, y
    

def remove_letter(x, y):
    global qs, fs
    if field[x+1][y]:
        qs += 1
        field[x][y] = False
        field[x][y - 1] = False
        field[x][y - 2] = False
        field[x + 1][y] = False
        field[x + 1][y - 2] = False
        field[x + 2][y] = False
        field[x+2][y - 1] = False
        field[x+2][y - 2] = False
        field[x + 3][y] = False
        field[x + 4][y] = False
        return
    fs += 1
    field[x][y] = False
    field[x][y - 1] = False
    field[x][y - 2] = False
    field[x + 1][y - 2] = False
    field[x+2][y - 1] = False
    field[x+2][y - 2] = False
    field[x + 3][y - 2] = False
    field[x + 4][y - 2] = False

for i in range(n):
    s = input()
    for k in range(m):
        field[i + 1][k + 1] = (s[k] == "#")


res = find_up_right()
while res:
    remove_letter(*res)
    res = find_up_right()

print(qs, fs)

