from collections import defaultdict, deque
inf = int(1e6)

def bfs(g, s, n):
    p = defaultdict(list)
    paths = defaultdict(list)
    d = [int(1e6 + 1)] * n
    q = deque()
    q.append(s)
    d[s - 1] = 0
    while q:
        u = q.popleft()
        for v, l in g[u]:
            if d[v - 1] > inf:
                p[v].append(u)
                d[v - 1] = d[u - 1] + 1
                q.append(v)
            elif d[v - 1] == d[u - 1] + 1:
                p[v].append(u)
    return p

paths = []
import copy
def f(g, node, path):
    if node != 1:
        for v in g[node]:
            _path = copy.copy(path)
            _path.append(v)
            _path = f(g, v, _path)
    if 1 in path:
        paths.append(path)
    return path

def length(g, u, v):
    for i in g[u]:
        if i[0] == v:
            return i[1]

g = defaultdict(list)
n, m = map(int, input().split())
for i in range(m):
    u, v, l = map(int, input().split())
    g[u].append((v, l))
    g[v].append((u, l))
p = bfs(g, 1, n)
print(p)
t = n
path = [6]
print(f(p, n, path))
ans = None
ans_m = None
for pa in paths:
    m = [100000000, 0]
    s = pa[0]
    for j in pa[1:]:
        m = [min(m[0], length(g, s, j)), max(m[0], length(g, s, j))]
        s = j
    dif = m[1] - m[0]
    if not ans_m:
        ans_m = dif
        ans = reversed(pa)
    elif ans_m < dif:
        ans_m = dif
        ans = reversed(pa)
ans = list(ans)
print(len(ans) - 1)
print(' '.join(map(str, ans)))
