#include <bits/stdc++.h>
using namespace std;

int n, k;
int ans = 0;

struct node {
	node* nextNode[26] = {NULL};
	int counted = 0;
};

node* root = new node;

void addRoot(node* curr, string& s, int ind) {
	curr->counted++;
	if(ind == s.size()) {
		return; 
	}

	if(curr->nextNode[s[ind]-'a'] == NULL) {
		curr->nextNode[s[ind]-'a'] = new node;
	} 

	addRoot(curr->nextNode[s[ind]-'a'], s, ind+1);
}

int removeRoot(node* curr) {
	if(curr->counted <= k) {
		int t = curr->counted;
		curr->counted = 0;
		ans++;
		return t;
	}

	vector<pair<int,int>> countFreq;
	int t = 0;

	for(int i = 0; i < 26; i++) {
		if(curr->nextNode[i] != NULL) 
			countFreq.push_back({curr->nextNode[i]->counted, i});
	}

	sort(countFreq.rbegin(), countFreq.rend());

	for(auto& el : countFreq) {
		if(curr->counted <= k) {
			int currval = curr->counted;
			curr->counted = 0;
			ans++;
			return t+currval;
		} else {
			int currval = removeRoot(curr->nextNode[el.second]);
			curr->counted -= currval;
			t += currval;
		}
	}

	return t;
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	cin >> n >> k;
	string in;

	for(int i = 0; i < n; i++) {
		cin >> in;
		addRoot(root, in, 0);
	}

	removeRoot(root);

	cout << ans << '\n';
}
