#include <bits/stdc++.h>
using namespace std;

vector<vector<pair<int,int>>> g;
vector<int> lvl;
int ans = -1;
int n;
vector<int> curr;
vector<int> path;

void bfs(int v) {
	queue<int> q;
	lvl[v] = 0;
	q.push(v);

	while(!q.empty()) {
		v = q.front();
		q.pop();

		for(auto [to, dis] : g[v]) {
			if(lvl[to] == -1) {
				lvl[to] = lvl[v]+1;
				q.push(to);
			}
		}
	}
}

void dfs(int v, int lvlV, int minv, int maxv) {
	if(v == n-1) {
		if(maxv-minv > ans) {
			path = curr;
			ans = maxv-minv;
		}
		return;
	}

	for(auto [to, dist] : g[v]) {
		if(lvl[to] == lvlV+1) {
			curr.push_back(to);
			dfs(to, lvlV+1, min(minv, dist), max(maxv, dist));
			curr.pop_back();
		}
	}
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	int m;
	int l, r, c;
	cin >> n >> m;

	g.resize(n);
	lvl.resize(n, -1);

	while(m--) {
		cin >> l >> r >> c;
		l--; r--;
		g[l].push_back({r,c});
		g[r].push_back({l,c});
	}

	bfs(0);
	curr.push_back(0);
	dfs(0,0,1e9+1,-1);

	cout << path.size()-1 << '\n';
	for(auto& el : path) cout << el+1 << ' ';
	cout << '\n';
}
