import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.*;

public class Main {

    public static void main(String[] args) throws Exception {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        String[] numbers = br.readLine().split(" ");
        int n = Integer.parseInt(numbers[0]);
        int wordsCount = n;
        int k = Integer.parseInt(numbers[1]);
        List<String> words = new ArrayList<>();
        HashMap<String, Integer> prefixes = new HashMap<>();
        int entries = 0;

        while(wordsCount != 0) {
            words.add(br.readLine());
            wordsCount--;
        }

        for(String word : words) {
            for(int i = 1; i < word.length(); i++) {
                String prefix = word.substring(0, i);
                int count = 0;

                for(String c : words) {
                    if(c.startsWith(prefix)) count++;
                }

                if(count <= k && count != 1) prefixes.put(prefix, count);
            }
        }

        for(Map.Entry<String, Integer> prefix : prefixes.entrySet()) {
            n -= prefix.getValue();
        }

        entries += prefixes.size();

        while (n > k) {
            n--;
            entries++;
        }

        System.out.println(++entries);
        br.close();
    }
}