package com.company;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) {

        Scanner sc = new Scanner(System.in);
        long t = sc.nextInt();

        while (t >= 1) {
            long n = sc.nextInt();
            if (n >= 2 && n <= Math.pow(10, 18)) {

                ArrayList<Long> list = new ArrayList<>();

                for (long i = 1; i <= n - 1; i++) {
                    if (coPrime(i, n) == 1) {
                        list.add(i);
                    }
                }

                System.out.println(getMedian(list, list.size()));

                --t;
            }
        }
    }

    public static Long getMedian(ArrayList<Long> a, int size) {

        if (size % 2 == 0) {
            return a.get((size / 2) - 1);
        }
        return  a.get(((size + 1) / 2) - 1);
    }

    public static long coPrime(long index, long currentNum) {
        long temp;
        if (currentNum > index) {
            temp = currentNum;
            currentNum = index;
            index = temp;
        }
        long r = -1;
        while (r != 0) {
            r = index % currentNum;
            index = currentNum;
            currentNum = r;
        }

        return index;
    }
}