#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

bool is_q(vector<vector<bool> > &map, int y, int x) {
    if (y < 4 || x < 2) {
        return false;
    }

    return map[y][x] && map[y - 1][x] && map[y - 2][x] && map[y - 3][x] && map[y - 4][x]
        && map[y - 2][x - 1] && map[y - 4][x - 1]
        && map[y - 2][x - 2] && map[y - 3][x - 2] && map[y - 4][x - 2]
        && !map[y - 3][x - 1];
}

void paint_q(vector<vector<bool> > &map, int y, int x) {
    map[y][x] = map[y - 1][x] = map[y - 2][x] = map[y - 3][x] = map[y - 4][x]
    = map[y - 2][x - 1] = map[y - 4][x - 1]
    = map[y - 2][x - 2] = map[y - 3][x - 2] = map[y - 4][x - 2] = false;
}

void paint_f(vector<vector<bool> > &map, int y, int x) {
    map[y][x] = map[y - 1][x] = map[y - 2][x] = map[y - 3][x] = map[y - 4][x]
    = map[y - 2][x + 1] = map[y - 4][x + 1]
    = map[y - 4][x + 2] = false;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<vector<bool> > map(n);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (char j : s) {
            map[i].push_back(j == '#');
        }
    }

    int p, q;
    p = q = 0;
    for (int i = map.size() - 1; i >= 0; i--) {
        for (int j = map[i].size() - 1; j >= 0; j--) {
            if (!map[i][j]) {
                continue;
            }

            if (is_q(map, i, j)) {
                paint_q(map, i, j);
                q++;
            } else {
                paint_f(map, i, j);
                p++;
            }
        }
    }

    cout << q << " " << p << "\n";
    return 0;
}