#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

#define int long long
#define float long double

bool check_F(const vector<vector<int>>& v, int i, int j) {
    return v[i  ][j] > 0 && v[i  ][j+1] >  0 && v[i][j+2] > 0 &&
           v[i+1][j] > 0 && v[i+1][j+1] <= 0 &&
           v[i+2][j] > 0 && v[i+2][j+1] >  0 &&
           v[i+3][j] > 0 &&
           v[i+4][j] > 0;
}

bool check_Q(const vector<vector<int>>& v, int i, int j) {
    return v[i  ][j] > 0 && v[i  ][j+1] >  0 && v[i  ][j+2] > 0 &&
           v[i+1][j] > 0 && v[i+1][j+1] <= 0 && v[i+1][j+2] > 0 &&
           v[i+2][j] > 0 && v[i+2][j+1] >  0 && v[i+2][j+2] > 0 &&
                                                v[i+3][j+2] > 0 &&
                                                v[i+4][j+2] > 0;
}

signed main() {
    //freopen("input.txt", "r", stdin);

    int n, m, k=0;
    cin >> n >> m;

    vector<vector<int>> v(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char ch;
            cin >> ch;
            if (ch == '#') {
                v[i][j] = 1;
                ++k;
            }
        }
    }

    vector<pair<int, int>> f, q;
    for (int i = 0; i < n - 4; ++i) {
        for (int j = 0; j < m - 2; ++j) {
            if (check_F(v, i, j)) {
                f.push_back({i, j});
            }
            if (check_Q(v, i, j)) {
                q.push_back({i, j});
            }
        }
    }

    //cout << k << endl << q.size() << ' ' << f.size();
    //
    
    for (int i = 0; i <= q.size(); ++i) {
        if ((k - i*10) % 8 == 0 && (k - i*10) / 8 <= f.size()) {
            cout << i << ' ' << (k - i*10) / 8 << '\n';
        }
    }


    /*for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << v[i][j];
        }
        cout << endl;
    }*/

    return 0;
}