﻿using System;
using System.Collections.Generic;

namespace Turnir
{
    class Program
    {
        static int Min(int x, int y)
        {
            return x < y ? x : y;
        }

        static int Max(int x, int y)
        {
            return x > y ? x : y;
        }

        static int GCD(int a, int b)
        {
            if (a == 0)
            {
                return b;
            }
            else
            {
                var min = Min(a, b);
                var max = Max(a, b);

                return GCD(max - min, min);
            }
        }

        static void Main(string[] args)
        {
            int t = Convert.ToInt32(Console.ReadLine());
            List<int> medians = new List<int>();


            for (int i = 0; i < t; i++)
            {
                int n = Convert.ToInt32(Console.ReadLine());
                int median = 1;
                List<int> listNum = new List<int>();

                for (int numIndex = 1; numIndex < n; numIndex++)
                {
                    var gcd = GCD(n, numIndex);
                    if (gcd == 1)
                    {
                        listNum.Add(numIndex);
                    }
                }

                if (listNum.Count % 2 == 0)
                {
                    median = listNum[(listNum.Count - 1) / 2];
                }
                else
                {
                    median = listNum[(listNum.Count) / 2];
                }

                medians.Add(median);
            }

            foreach(var median in medians)
                Console.WriteLine(median);
        }
    }
}
