#define _CRT_SECURE_NO_WARNINGS
#define All(x) x.begin(), x.end()
#define ln '\n'
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <assert.h>
#include <set>
#include <fstream>
#include <map>
#include <string>
#include <conio.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;

class String
{
public:
	static vector<ll> Z_foo(string& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = n;
		for (ll i = 1, l = 0, r = 0; i < n; i++)
		{
			if (i <= r)
				res[i] = min(r - i + 1, res[i - l]);
			while (i + res[i] < n && s[res[i]] == s[i + res[i]])
				res[i]++;
			if (i + res[i] - 1 > r)
			{
				l = i;
				r = i + res[i] - 1;
			}
		}
		return res;
	}
	template <typename T>
	static vector<ll> Z_foo(vector<T>& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = n;
		for (ll i = 1, l = 0, r = 0; i < n; i++)
		{
			if (i <= r)
				res[i] = min(r - i + 1, res[i - l]);
			while (i + res[i] < n && s[res[i]] == s[i + res[i]])
				res[i]++;
			if (i + res[i] - 1 > r)
			{
				l = i;
				r = i + res[i] - 1;
			}
		}
		return res;
	}

	static vector<ll> PI_foo(string& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = 0;
		for (ll i = 1; i < n; i++)
		{
			ll j = res[i - 1];
			while (j > 0 && s[i] != s[j])
				j = res[j - 1];
			if (s[i] == s[j])
				j++;
			res[i] = j;
		}
		return res;
	}
	template<typename T>
	static vector<ll> PI_foo(vector<T>& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = 0;
		for (ll i = 1; i < n; i++)
		{
			ll j = res[i - 1];
			while (j > 0 && s[i] != s[j])
				j = res[j - 1];
			if (s[i] == s[j])
				j++;
			res[i] = j;
		}
		return res;
	}
};

class Math
{
public:
	static long long gcd(ll a, ll b)
	{
		return b ? gcd(b, a % b) : a;
	}
	static long long fast_pow(ll a, ll n)
	{
		if (n == 0)
			return 1;
		if (n == 1)
			return a;
		ll res = fast_pow(a, n / 2);
		res *= res;
		if (n % 2 == 0)
			return res;
		return res * a;
	}
};
void ask()
{

	cout.flush();
}

void answer()
{

	cout.flush();
}

void solve()
{
	ll n;
	cin >> n;
	if (n % 2 == 1)
	{
		cout << (n + 2) / 2 - 1 << ln;
		return;
	}
	if (n <= 6)
	{
		cout << 1 << ln;
		return;
	}
	if ((n - 8) % 4 == 0)
	{
		cout << (n - 2) / 2 << ln;
	}
	if ((n - 10) % 4 == 0)
	{
		cout << (n - 4) / 2 << ln;
		return;
	}
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--)
	{
		solve();
	}
}