#define _CRT_SECURE_NO_WARNINGS

#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize(/*"Ofast",*/"O3","omit-frame-pointer")
//#pragma GCC target("sse","sse2",/*"sse3","ssse3","sse4","popcnt"*/,"abm",/*"mmx","avx",*/"tune=native","arch=native"")

#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <stdlib.h>
#include <iostream>
#include <time.h>
#include <algorithm>
#include <math.h>
#include <numeric>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <string>
#include <cstring>
#include <cassert>
#include <fstream>
#include <map>
#include <unordered_map>
#include <deque>
#include <unordered_set>
#include <functional>

using namespace std;

#define sqr(x) ((x)*(x))

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int inf = 1'000'000'007;
const ll llinf = 1'000'000'000'000'000'007LL;
const ld eps = 1e-7;
const ld pi = acos(-1.);

string p, t;
int dp[1024][1024];

void solve() {
    cin >> p >> t;
    dp[0][0] = 1;
    for (int i = 0; i <= p.size(); i++) {
        for (int j = 0; j <= t.size(); j++) {
            if (i < p.size()) {
                if (isalpha(p[i])) {
                    if (dp[i][j] && j < t.size() && p[i] == t[j]) {
                        dp[i + 1][j + 1] = 1;
                    }
                } else if (p[i] == '+') {
                    if ((!dp[i][j] && !dp[i - 1][j]) || j == t.size() || p[i - 1] != t[j]) {
                        continue;
                    }
                    for (int k = j; k < t.size() && p[i - 1] == t[k]; k++) {
                        dp[i + 1][k + 1] = 1;
                    }
                } else if (p[i] == '*') {
                    if (!dp[i][j] && !dp[i - 1][j]) {
                        continue;
                    }
                    dp[i + 1][j] = 1;
                    for (int k = j; k < t.size() && p[i - 1] == t[k]; k++) {
                        dp[i + 1][k + 1] = 1;
                    }
                }
            }
        }
    }
    if (dp[p.size()][t.size()]) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);
    srand(time(0));
    cout.precision(10);
    ll n;
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {

        cin >> n;
        ll mid = n / 2;

        if (n == 2) {
            cout << 1 << "\n";
            continue;
        }

        for (int j = 0; j < 100000; j++) {
            if ((gcd(mid, n)) == 1) {
                cout << mid << '\n';
                break;
            } else {
                --mid;
            }
        }
    }

}