#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <fstream>
#include <stdio.h>
#include <numeric>

#define all(a) (a).begin(), (a).end()
#define from(i, n) for (long long i=0; i<n;i++)

using namespace std;

typedef long long ll;
typedef long double ld;

ll Gcd(ll a, ll b) {
    if (abs(a-b)==1)
        return 1;
    if (b == 0)
        return a;
    return Gcd(b, a % b);
}
bool isPrime(ll x) {
    if (x<2)
        return false;
    for (ll i=2;i*i<=x;i++)
        if (x%i==0)
            return false;
    return true;
}
void Solve() {
    ll test;
    cin >> test;
    while (test--) {
        vector <ll> v{1};
        ll n;
        cin >> n;
        if (n==2) {
            cout << 1 << endl;
            continue;
        }
        if (isPrime(n)) {
            cout << (n-1)/2 << endl;
            continue;
        }
        if (n%2==0) {
            for (ll i=3;i<n;i+=2) {
                if (Gcd(i,n)==1)
                    v.push_back(i);
            }
        }
        else {
            for (ll i=2;i<n;i++) {
                if (Gcd(i,n)==1)
                    v.push_back(i);
            }
        }
        ll len = v.size();
        if (len%2==0)
            cout << v[(len/2)-1] << endl;
        else
            cout <<  v[((len+1)/2)-1]<< endl;
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    Solve();
    return 0;
}