import java.util.ArrayList;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {


        Scanner scanner = new Scanner(System.in);
        int rows = Integer.parseInt(scanner.nextLine());

        ArrayList<Long> numbers = new ArrayList<>();

        for (int i = 0; i < rows; i++) {
            long n = Long.parseLong(scanner.nextLine());

            for (long k = 1; k < n; k++) {

                if (isNumberCoprime(k, n)) {
                    numbers.add(k);
                }

            }

            int index = numbers.size() % 2 == 0 ? numbers.size() / 2 : (numbers.size() + 1) / 2;

            System.out.println(numbers.get(index - 1));
            numbers.clear();
        }
    }

    private static boolean isNumberCoprime(long a, long b) {
        if (a > b) {
            return gcd(a, b) == 1;
        } else {
            return gcd(b, a) == 1;
        }
    }

    private static long gcd(long a, long b) {

        while (a != b) {
            if (a > b) {
                a = a - b;
            } else {
                b = b - a;
            }
        }
        return a;
    }
}

//import java.util.Scanner;
//
//public class Main {
//    public static void main(String[] args) {
//        Scanner scanner = new Scanner(System.in);
//
//        int rows = Integer.parseInt(scanner.nextLine());
//
//        for (int i = 0; i < rows; i++) {
//            int n = Integer.parseInt(scanner.nextLine());
//            System.out.println(solve(n, n));
//        }
//
//    }
//
//    private static int solve(int n, int mainN) {
//        int l = n - 1;
//        int value = l % 2 == 0 ? l / 2 : (l + 1) / 2;
//
//        if (isNumberCoprime(value, mainN)) {
//            return value;
//        } else {
//            return solve(value + 1, mainN);
//        }
//    }
//
//    private static boolean isNumberCoprime(int a, int b) {
//        if (a > b) {
//            return gcd(a, b) == 1;
//        } else  {
//            return gcd(b, a) == 1;
//        }
//    }
//
//    private static int gcd(int a, int b) {
//
//        while (a != b) {
//            if (a > b) {
//                a = a - b;
//            } else {
//                b = b - a;
//            }
//        }
//        return a;
//    }
//}