﻿#include <iostream>
#include <ctime>
#include <cstdlib>
using namespace std;

struct spisok
{
    long long D;
    spisok* Next;
};
long long gcd(long long a, long long b);
long long pows(long long a, long long b, long long m);
bool ferma(long long x) {
    if (x == 2)
        return true;
    srand(time(NULL));
    for (int i = 0; i < 100; i++) {
        long long a = (rand() % (x - 2)) + 2;
        if (gcd(a, x) != 1)
            return false;
        if (pows(a, x - 1, x) != 1)
            return false;
    }
    return true;
}
long long gcd(long long a, long long b) {
    while (a && b)
        if (a > b) a %= b;
        else b %= a;
    return a + b;
}
long long mul(long long a, long long b, long long m) {
    if (b == 1)
        return a;
    if (b % 2 == 0) {
        long long t = mul(a, b / 2, m);
        return (2 * t) % m;
    }
    return (mul(a, b - 1, m) + a) % m;
}

long long pows(long long a, long long b, long long m) {
    if (b == 0)
        return 1;
    if (b % 2 == 0) {
        long long t = pows(a, b / 2, m);
        return mul(t, t, m) % m;
    }
    return (mul(pows(a, b - 1, m), a, m)) % m;
}
void addsp(spisok* one, long long d)
{
    spisok* t = NULL; //создаем доп указатель, и указываем на нулевую область памяти
    t = new(spisok); //выделяем область динамической памяти для нового элемента списка, и адрес записываем в t
    (*t).Next = NULL;//заземляем новый элемент
    (*t).D = d;//записываем в его информационную часть информацию
    spisok* t1;
    for (t1 = one; (*t1).Next != NULL; t1 = (*t1).Next);//поиск последнего эл-а списка
    (*t1).Next = t;
}

int main()
{
    int count;
    cin >> count;
    for (int i = 0; i < count; i++)
    {
        long long n;
        cin >> n;
        if (ferma(n))
        {
            cout << (n - 1) / 2;
        }
        else
        {
        
            spisok* sp = NULL;
            spisok* t = NULL; //доп указатель
            t = new(spisok); //выделяем память
            (*t).Next = NULL; //заземляем первый элемент
            (*t).D = 1;
            sp = t;
            if (n % 2 == 0)
            {
                for (long long j = 3; j < n; j++)
                {
                    if (ferma(j))
                        addsp(sp, j);
                }
                int m = 0;
                for (spisok* t1 = sp; t1 != NULL; t1 = (*t1).Next)
                    m++;
                if (m % 2 == 0)
                    m = m / 2;
                else
                    m = m / 2 + 1;
                int k = 0;
                spisok* t1 = sp;
                while (k != m - 1)
                {
                    t1 = (*t1).Next;
                    k++;
                }
                cout << (*t1).D << '\n';
            }
            else
            {
                for (int j = 2; j <= n/2; j++)
                    if (gcd(j, n) == 1)
                    {
                        addsp(sp, j);
                    }
                /*int m = 0;
                for (spisok* t1 = sp; t1 != NULL; t1 = (*t1).Next)
                    m++;*/
                /*if (m % 2 == 0)
                    m = m / 2;*/
                /*else
                    m = m / 2 + 1;*/
                /*int k = 0;*/
                spisok* t1 = sp;
                while ((*t1).Next != NULL)
                    t1 = (*t1).Next;
                   
                cout << (*t1).D << '\n';
            }
            
        }
        
    }
    return 0;
}

