﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <sstream>
#include <climits>
#include <string>
#include <queue>
#include <deque>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <fstream>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef pair<ll, ll> pii;

//#pragma warning(disable : 4996)

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	ll n, m, c;
	cin >> n >> m >> c;

	ll diff = n;
	ll minM = 0, minC = 0;
	for (ll M = n / m; M >= 0; --M)
	{
		ll C = (n - M * m) / c;
		ll cur = (M * m + C * c - n);
		if (abs(cur) < diff)
		{
			diff = abs(cur);
			minM = M;
			minC = C;
		}
		if (abs(cur + c) < diff)
		{
			diff = abs(cur + c);
			minM = M;
			minC = C + 1;
		}
	}

	if (abs((n / m + 1) * m - n) < diff)
	{
		minM = n / m + 1;
		minC = 0;
	}

	cout << minM << " " << minC;
}
