package com.company;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;

public class Main {

    public static void main(String[] args) {
        solveB();
    }

//    solveC(){
//
//    }

    public static void solveB() {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int k = sc.nextInt();
        sc.nextLine();
        List<String> list = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            list.add(sc.nextLine());
        }
        list.sort(new MyStringComparator());
        boolean wildcardUsed = false;
        int i = 0;
        int sum = 0;
        List<Integer> groups = new ArrayList<>();
        while (list.size() > 0) {
            String prefix = "";
            while (list.size() > k && list.get(k).startsWith(prefix)) {
                prefix += String.valueOf(list.get(0).charAt(prefix.length()));
            }

            String finalPrefix = prefix;
            int j = (int) list.stream().filter(x -> x.startsWith(finalPrefix)).count();
            sum +=j;
            groups.add(j);
            if(prefix.equals("")){
                if(list.get(0).charAt(0) != list.get(list.size() - 1).charAt(0))
                    wildcardUsed = true;
            }
            list.removeAll(
                    list.stream().filter(x -> x.startsWith(finalPrefix)).collect(Collectors.toList())
            );

        }
        groups.sort(Integer::compareTo);
        while(groups.stream().reduce(0, Integer::sum) > k){
            int cur = groups.remove(groups.size() - 1);
            n -= cur;
            i++;
        }
        if(!wildcardUsed && groups.size() > 0)
            i++;
        else if(wildcardUsed && groups.size() > 0)
            i+= groups.size();
        System.out.println(i);
    }

    private static void printList(List<String> list) {
        for(String str : list){
            System.out.println(str);
        }
        System.out.println("END");
    }

    private static class MyStringComparator
            implements Comparator<String> {
        public int compare(String s1, String s2) {
            char[] firstChars = s1.toCharArray();
            char[] secondChars = s2.toCharArray();
            int i = 0;
            while (i < firstChars.length && i < secondChars.length) {
                if (firstChars[i] < secondChars[i])
                    return -1;
                if (secondChars[i] < firstChars[i])
                    return 1;
                i++;
            }
            return secondChars.length - firstChars.length;
        }

    }

}