#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <cmath>
#define endl '\n'
#define intt long long
#define F first
#define S second
using namespace std;
#define MAX 101
const long double eps = 1e-18;
int arr[1000000];
string findSum(string str1, string str2)
{
   
    if (str1.length() > str2.length())
        swap(str1, str2);
 
    
    string str = "";
 
   
    int n1 = str1.length(), n2 = str2.length();
 
    
    reverse(str1.begin(), str1.end());
    reverse(str2.begin(), str2.end());
 
    int carry = 0;
    for (int i=0; i<n1; i++)
    {
        
        int sum = ((str1[i]-'0')+(str2[i]-'0')+carry);
        str.push_back(sum%10 + '0');
 
        
        carry = sum/10;
    }
 
    
    for (int i=n1; i<n2; i++)
    {
        int sum = ((str2[i]-'0')+carry);
        str.push_back(sum%10 + '0');
        carry = sum/10;
    }
 
    
    if (carry)
        str.push_back(carry+'0');
 
    
    reverse(str.begin(), str.end());
 
    return str;
}
bool isSmaller(string str1, string str2)
{

    int n1 = str1.length(), n2 = str2.length();
 
    if (n1 < n2)
        return true;
    if (n2 < n1)
        return false;
 
    for (int i = 0; i < n1; i++)
        if (str1[i] < str2[i])
            return true;
        else if (str1[i] > str2[i])
            return false;
 
    return false;
}
 

string findDiff(string str1, string str2)
{
   
    if (isSmaller(str1, str2))
        swap(str1, str2);
 
    
    string str = "";
 
    
    int n1 = str1.length(), n2 = str2.length();
 
  
    reverse(str1.begin(), str1.end());
    reverse(str2.begin(), str2.end());
 
    int carry = 0;
 
   
    for (int i = 0; i < n2; i++) {
       
 
        int sub
            = ((str1[i] - '0') - (str2[i] - '0') - carry);
 
       
        if (sub < 0) {
            sub = sub + 10;
            carry = 1;
        }
        else
            carry = 0;
 
        str.push_back(sub + '0');
    }
 
    
    for (int i = n2; i < n1; i++) {
        int sub = ((str1[i] - '0') - carry);
 
        
        if (sub < 0) {
            sub = sub + 10;
            carry = 1;
        }
        else
            carry = 0;
 
        str.push_back(sub + '0');
    }
 
    reverse(str.begin(), str.end());
 
    return str;
}
int main(void)
{
    string s1,s2,s3,s4,tmp;
    cin >> s1 >> s2 >> s3 >> s4;
    if (s2=="AD" || s2=="BC")
    {
        tmp=s2;
        s2=s1;
        s1=tmp;
    }
    if (s4=="AD" || s4=="BC")
    {
        tmp=s4;
        s4=s3;
        s3=tmp;
    }
    tmp=findDiff(s2,s4);
    if (s1==s3){
    for (int i=0,j=0; i<tmp.size(); i++ )
    {
        if (tmp[i]!='0') j++;
        if (j!=0) cout<< tmp[i];
    }
    }

    else 
    cout <<findDiff(findSum(s2,s4),"1");

   return 0;

}