package com.company;

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader reader =
                   new BufferedReader(new InputStreamReader(System.in));

        int inputCounter = Integer.valueOf(reader.readLine());
        List<Integer> inps = new ArrayList<>();
        for (int i = 0; i < inputCounter; i++)
            inps.add(Integer.valueOf(reader.readLine()));

        List<Integer> comprimes=new ArrayList<>();

        for (int k = 0; k < inps.size(); k++) {
            int input = inps.get(k);
            for (int i = 1; i < input - 1; i++) {
                if(areCoprime(i,input)){
                    comprimes.add(i);
                }
            }

            if(comprimes.size()%2==0){
                System.out.println(comprimes.get(comprimes.size()/2-1));
            }else{
                System.out.println(comprimes.get((comprimes.size()+1)/2-1));
            }

            comprimes.clear();

        }
        reader.close();

    }

    private static boolean areCoprime(Integer a, Integer b) {
        return (gcd(a, b) == 1);
    }

    private static int gcd(int p, int q) {
        if (q == 0) {
            return p;
        }
        return gcd(q, p % q);
    }

}
