#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
typedef long long ll;
typedef long double ld;
using namespace std;
mt19937 rnd(time(NULL));
#define fs first
#define sc second
const int maxn = 1e6 + 100;
const double eps = 1e-9;
const int mod = 1e9 + 7;
const int inf =1e9;


vector<int> g[maxn];
pair<int, int> a[maxn];
int color[maxn];
map<string, int> v2i;
vector<int> pr[150];
int gsize = 0;
char u[maxn];
vector<int> order;

void find_cycles(int v) {
    u[v] = 1;
    for (int to : g[v]) {
        if (u[to] == 0) {
            find_cycles(to);
        } else if (u[to] == 1) {
            cout << "No";
            exit(0);
        }
    }
    u[v] = 2;
}


void dfs(int v) {
    u[v] = 1;
    for (int to : g[v]) {
        if (!u[to]) dfs(to);
    }
    order.push_back(v);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
//    freopen("../output.txt", "w", stdout);
#endif

    int t;
    cin>>t;
    for (int i = 0; i < t; ++i) {
        int n;
        cin>>n;
        int last = 0;
        for (int j = 0; j < n; ++j) {
            string s;
            cin>>s;
            int sep;
            for (sep = 0; sep < s.size(); ++sep) {
                if (s[sep] == '=') break;
            }
            string name = s.substr(0, sep);
            if (v2i.find(name) == v2i.end()) {
                v2i[name] = v2i.size();
            }
            int var = v2i[name];
            int k = stoi(s.substr(sep+1, s.size()-sep-1));
            int v = gsize++;
            a[v] = {var, k};
            if (j) g[v].push_back(pr[i].back());
            pr[i].push_back(v);
//            cerr << v << " " << i << endl;
            color[v] = i;
        }
    }
//    for (int x = 0; x < gsize; ++x) {
//        cout << x << ": " << a[x].fs << " " << a[x].sc;
//        cout<<endl;
//    }

    int q;
    cin>>q;
    for (int i = 0; i < q; ++i) {
        string name;
        int k;
        cin>>name>>k;
        int var = v2i[name];
        vector<int> f1, f2;
        for (int j = 0; j < t; ++j) {
            bool first = 1;
            for (int cur = pr[j].size() - 1; cur >= 0; cur--) {
                if (a[pr[j][cur]].fs == var) {
                    if (first) {
                        if (a[pr[j][cur]].sc == k) {
                            f1.push_back(pr[j][cur]);
                        } else {
                            f2.push_back(pr[j][cur]);
                        }
                        first = 0;
                    } else {
                        f2.push_back(pr[j][cur]);
                    }
                }
            }
        }

        if (f1.empty()) {
            cout << "No";
            return 0;
        }
        for (int x1 : f1) {
            for (int x2 : f2) {
                g[x1].push_back(x2);
            }
            g[gsize].push_back(x1);
        }
    }

    find_cycles(gsize);
    for (int i = 0; i <= gsize; ++i) u[i] = 0;
    dfs(gsize);
    cout << "Yes\n";
    for (int i : order) {
        if (i == gsize) continue;
        cout << color[i] + 1 << " ";
    }

    return 0;
}