#define _CRT_SECURE_NO_WARNINGS

#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize(/*"Ofast",*/"O3","omit-frame-pointer")
//#pragma GCC target("sse","sse2",/*"sse3","ssse3","sse4","popcnt"*/,"abm",/*"mmx","avx",*/"tune=native","arch=native"")

#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <stdlib.h>
#include <iostream>
#include <time.h>
#include <algorithm>
#include <math.h>
#include <numeric>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <string>
#include <cstring>
#include <cassert>
#include <fstream>
#include <map>
#include <unordered_map>
#include <deque>
#include <unordered_set>
#include <functional>

using namespace std;

#define sqr(x) ((x)*(x))

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int inf = 1'000'000'007;
const ll llinf = 1'000'000'000'000'000'007LL;
const ld eps = 1e-9;
const ld pi = acos(-1.);

void solve() {
	int n, m;
	cin >> n >> m;
	vector <string> arr(n);
	for (auto& i : arr) {
		cin >> i;
	}

	int Q = 0, F = 0;
	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			if (arr[i][j] != '#') {
				continue;
			}
			if (i + 4 < n && arr[i + 1][j] == '#' && arr[i + 2][j] == '#' && arr[i + 3][j] == '#' && arr[i + 4][j] == '#') {
				F++;
				arr[i][j] = '.';
				arr[i][j + 1] = '.';
				arr[i][j + 2] = '.';
				arr[i + 1][j] = '.';
				arr[i + 2][j] = '.';
				arr[i + 2][j + 1] = '.';
				arr[i + 3][j] = '.';
				arr[i + 4][j] = '.';
			}
			if (i + 4 < n && arr[i + 1][j] == '#' && arr[i + 2][j] == '#') {
				Q++;
				arr[i][j] = '.';
				arr[i][j + 1] = '.';
				arr[i][j + 2] = '.';
				arr[i + 1][j] = '.';
				arr[i + 1][j + 2] = '.';
				arr[i + 2][j] = '.';
				arr[i + 2][j + 1] = '.';
				arr[i + 2][j + 2] = '.';
				arr[i + 3][j + 2] = '.';
				arr[i + 4][j + 2] = '.';
			}
		}
	}
	cout << Q << " " << F << "\n";
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	srand(time(0));
	cout.precision(10);

	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
	}

	return 0;
}