#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct var {
    string name;
    int value;
};

var parseVar(string s) {
    auto idx = s.find('=');
    auto name = s.substr(0, idx);
    auto strValue = s.substr(idx + 1);
    int value = stoi(strValue);
//    cout << name << " " << value << endl;
    return {name, value};
}


int main() {
#ifdef DEBUG
    freopen("in.txt", "r", stdin);
#endif
    int t;
    int countOperations = 0;
    cin >> t;
    vector<vector<var>> a(t);
    for (int i = 0; i < t; i++) {
        int n;
        cin >> n;
        countOperations += n;
        a[i].resize(n);
        for (int j = 0; j < n; j++) {
            string s;
            cin >> s;
            a[i][j] = parseVar(s);
//            parseVar(s);
        }
    }
    vector<int> ans;
    vector<int> state(t);
    for (int i = 0; i < t; i++) {
        state[i] = (int) a[i].size() - 1;
    }
    int k;
    cin >> k;
    map<string, int> require;
    map<string, char> used;
    for (int i = 0; i < k; i++) {
        string s;
        int x;
        cin >> s >> x;
        require[s] = x;
    }
    for (int i = 0; i < countOperations; i++) {
        bool update = false;
        for (int j = 0; j < t; j++) {
            if (state[j] < 0) continue;
            auto cur = a[j][state[j]];
            if (cur.value == require[cur.name]) {
                ans.push_back(j + 1);
                state[j]--;
                update = true;
                used[cur.name] = true;
                break;
            }
        }
        if (update) continue;
        for (int j = 0; j < t; j++) {
            if (state[j] < 0) continue;
            auto cur = a[j][state[j]];
            if (used[cur.name]) {
                ans.push_back(j + 1);
                state[j]--;
                update = true;
                break;
            }
        }
        if (!update) {
            cout << "No";
            return 0;
        }
    }
    cout << "Yes\n";
    for (int i = (int) ans.size() - 1; i >= 0; i--) {
        cout << ans[i] << " ";
    }
    return 0;
}
