#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

const ll maxn = 2e5 + 123, inf = 1e9 + 1, mod = 1e9 + 7, MOD = 3e11;
const ll INF = 1e18;

int n, m, a[maxn], b[maxn], c[maxn], t[4 * maxn], d[4 * maxn];

void build(int v, int tl, int tr) {
	if (tl == tr) {
		t[v] = c[tl];
		d[v] = c[tl];
		return;
	}
	int tm = (tl + tr) >> 1;
	build(v * 2, tl, tm);
	build(v * 2 + 1, tm + 1, tr);
	t[v] = max(t[v * 2], t[v * 2 + 1]);
	d[v] = min(d[v * 2], d[v * 2 + 1]);
}

int mx(int v, int tl, int tr, int l, int r) {
	if (l > r || tr < l || r < tl)
		return 0;
	if (tl >= l && tr <= r)
		return t[v];
	int tm = (tl + tr) >> 1;
	int x = mx(v * 2, tl, tm, l, r);
	int y = mx(v * 2 + 1, tm + 1, tr, l, r);
	return max(x, y);
}

int mn(int v, int tl, int tr, int l, int r) {
	if (l > r || tr < l || r < tl)
		return 1e9 + 1;
	if (tl >= l && tr <= r)
		return d[v];
	int tm = (tl + tr) >> 1;
	int x = mn(v * 2, tl, tm, l, r);
	int y = mn(v * 2 + 1, tm + 1, tr, l, r);
	return min(x, y);
}

void solve() {
	cin >> n >> m;

	for (int i = 1; i <= n; i++) {
		a[i] = 0;
		b[i] = -1;
		c[i] = -1;	
	}

	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		b[i] = a[i] / m;
	}

	b[n + 1] = -1;

	for (int i = n; i >= 1; i--) {
		c[i] = (b[i] + 1) * m - a[i];
		//if (b[i] == b[i + 1])
			//c[i] = min(c[i], c[i + 1]);
	}

	/*for (int i = 1; i <= n; i++)
		cout << c[i] << " ";

	cout << "\n";
	*/
	build(1, 1, n);

	int l = 1, r = 1;
	vector <pii> v;

	for (int i = 2; i <= n; i++) {
		if (b[i] - b[i - 1] == 1) {
			r++;
		}
		else {
			v.pb(mp(l, r));
			l = i;
			r = i;
		}
	}

	v.pb(mp(l, r));

	int ans = 0, pos;

	for (int i = 0; i < v.size(); i++) {
		pii p = v[i];
		int Mn = mn(1, 1, n, p.f, p.s);
		int Mx = mx(1, 1, n, p.f, p.s);
		int len1 = 0, len2 = 0;
		//cout << p.f << " " << p.s << " " << Mx << endl;
		if (i > 0) {
			int l = v[i - 1].f, r = v[i - 1].s;
			while (l <= r) {
				int mid = (l + r) >> 1;
				if (mx(1, 1, n, mid, p.f - 1) > Mn) {
					r = mid - 1;
					len1 = p.f - mid;
				}
				else
					l = mid + 1;
			}
		}
		if (i + 1 != v.size()) {
			int l = v[i + 1].f, r = v[i + 1].s;
			while (l <= r) {
				int mid = (l + r) >> 1;
				if (mn(1, 1, n, p.s + 1, mid) > Mx) {
					l = mid + 1;
					len2 = mid - p.s;
				}
				else
					r = mid - 1;
			}
		}
		//cout << p.f << " " << p.s << " " << len1 << " " << len2 << " " << Mn << endl;
		int x = p.s - p.f + 1 + len1 + len2;
		if (x > ans) {
			ans = x;
			pos = Mn;
		}
	}

	cout << ans << " " << pos << endl;
}        

int main() {
    //ios_base::sync_with_stdio(false);
	//cin.tie(NULL);
	//freopen("e.in", "r", stdin);
	//freopen("e.out", "w", stdout);

    int t = 1;
    cin >> t;
    while (t--) {
    	solve();
    }
}