import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) {
        FastReader scan = new FastReader();
        PrintWriter out = new PrintWriter(System.out);
        Solution solve = new Solution();
        int t = 1;
        //t = scan.nextInt();
        for (int qq = 0; qq < t; qq++) {
            solve.solve(scan, out);
            out.println();
        }
        out.close();
    }

    static class Solution {
        /*
         * think and coding
         */
        static long MOD = (long) (1e9 + 7);

        public void solve(FastReader scan, PrintWriter out) {
            long n = scan.nextLong(), m = scan.nextLong(), c = scan.nextLong();

            if (n % m == 0) {
                out.println("0 " + n / m);
                return;
            } else if (n % c == 0) {
                out.println(n / c + " 0");
                return;
            }
            if (n < m || n < c) {
                if (Math.abs(m - n) > Math.abs(c - n)) {
                    out.print("0 1");
                } else {
                    out.print("1 0");
                }
                return;
            }
            long res1 = n % m;
            long res2 = n % c;
            long res3 = (n - c) % m;
            long res4 = (n - m) % c;
            long res = Math.min(res1, Math.min(res2, Math.min(res3, res4)));
            if (res == res1) {
                out.println(n / m + " 0");
            } else if (res == res2) {
                out.println("0 " + n / c);
            } else if (res == res3) {
                out.println((n - c) / m + " 1");
            } else {
                out.println("1 " + (n - m) / c);
            }
        }
    }

    static class FastReader {
        private final BufferedReader br;
        private StringTokenizer st;

        public FastReader() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        public FastReader(String s) throws FileNotFoundException {
            br = new BufferedReader(new FileReader(new File(s)));
        }

        String next() {
            while (st == null || !st.hasMoreElements()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }

        String nextLine() {
            String str = "";
            try {
                str = br.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }
    }
}

