#include <bits/stdc++.h>

#define eb emplace_back
#define pb push_back
#define ll long long
#define ld long double
#define mp make_pair
#define ull unsigned long long
#define all(s) s.begin(), s.end()
#define sz(a) (int)a.size()
const int INF = (int)1e9 + 7;
const int N = (int)1e5 + 22;
const int MAXN = (int)3e6 + 228;
const double eps = (double)1e-9;
const int mod = (int)1e9 + 7;

using namespace std;

struct Node {
  int nxt[30];
  int cnt;

  Node() {
    cnt = 0;
    for (int i = 0; i < 30; ++i) {
      nxt[i] = -1;
    }
  }
} trie[N * 3];

int n, k, sz;

void add(string &s) {
  int v = 0;
  trie[v].cnt++;

  for (auto &c : s) {
    if (trie[v].nxt[c - 'a'] == -1) {
      trie[v].nxt[c - 'a'] = ++sz;
    }
    v = trie[v].nxt[c - 'a'];
    trie[v].cnt++;
  }
}
int res = 0;
int dfs(int v) {
  if (trie[v].cnt <= k) {
    res++;
    int cc = trie[v].cnt;
    trie[v].cnt = 0;
    return cc;
  }
  int mx = -1, child;
  for (int i = 0; i < 26; ++i) {
    if (trie[v].nxt[i] != -1) {
      int c = trie[v].nxt[i];
      if (trie[c].cnt > mx) {
        mx = trie[c].cnt;
        child = c;
      }
    }
  }
  int cc = dfs(child);
  trie[v].cnt -= cc;
  return cc;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);

#ifdef Local
  freopen(".in", "r", stdin);
  // freopen("res.out", "w", stdout);
#else
  // freopen("sum.in", "r", stdin);
  // freopen("sum.out", "w", stdout);
#endif
  cin >> n >> k;

  for (int i = 0; i < n; ++i) {
    string s;
    cin >> s;
    add(s);
  }
  while (trie[0].cnt > 0) {
    dfs(0);
  }

  cout << res << endl;

  return 0;
}