/*
 _    _    _______   _    _
| |  / /  |  _____| | |  / /
| | / /   | |       | | / /
| |/ /    | |_____  | |/ /
| |\ \    |  _____| | |\ \
| | \ \   | |       | | \ \
| |  \ \  | |_____  | |  \ \
|_|   \_\ |_______| |_|   \_\

*/
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <vector>
#include <cstring>
#include <string>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <assert.h>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef double ld;
typedef pair <int, int> PII;
typedef pair <ll, ll> PLL;

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define forn(x, a, b) for (int x = a; x <= b; ++x)
#define for1(x, a, b) for (int x = a; x >= b; --x)
#define mkp make_pair
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define y1 kekekek

const ll ool = 1e18 + 9;
const int oo = 1e9 + 9, base = 1e9 + 7;
const ld eps = 1e-7;
const int N = 1e4 + 6, T = 111;

int t, n;
vector < pair <string, string> > vec[T];
vector < int > ans;

map < string, string > lastval;
map < string, bool > u;

int main() {
	ios_base :: sync_with_stdio(0), cin.tie(0), cout.tie(0);

    // freopen("input.txt", "r", stdin);

    cin >> t;
    forn(i, 1, t) {
        int sz;
        cin >> sz;
        forn(j, 1, sz) {
            string command;
            cin >> command;
            int pos = 0;
            while (command[pos] != '=') ++pos;
            
            vec[i].eb(command.substr(0, pos), command.substr(pos + 1));            
        }
    }

    cin >> n;
    forn(i, 1, n) {
        string var, val;
        cin >> var >> val;
        lastval[var] = val;
    }

    vector < int > ans;
    while (true) {
        bool found = 0;
        bool allempty = 1;
        forn(i, 1, t) {
            while (sz(vec[i]) && u[vec[i].back().F]) {
                ans.eb(i);
                vec[i].pop_back();
            }

            if (!sz(vec[i])) continue;

            allempty = 0;

            if (lastval[vec[i].back().F] == vec[i].back().S) {
                ans.eb(i);
                u[vec[i].back().F] = 1;
                vec[i].pop_back();
                found = 1;
                break;
            }
        }

        if (allempty) break;

        if (!found) {
            cout << "No\n";
            return 0;
        }
    }

    reverse(all(ans));

    cout << "Yes\n";
    for (int x : ans) cout << x << " ";
    cout << "\n";
    
	return 0;
}
