#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<set>
#include<stack>
#include<deque>
#include<queue>
#include<iomanip>
#include<map>

#define x first
#define y second
#define pb push_back
#define mp make_pair
#define sz(v) v.size()
#define up_b upper_bound
#define low_b lower_bound
#define all(v) v.begin(),v.end()

using namespace std;

typedef long long ll;
typedef long double ld;

const int N=101;
const ll mod=1e9+7;
const int inf=2e9;
const ll INF=1e18;
const int dx[4]={0,0,1,-1};
const int dy[4]={1,-1,0,0};

int a[N];
int group[N*N];
string var[N][N];
int val[N][N];
int b[N*N],c[N*N],lst[N*N];
vector<int>ver[N*N];
int used[N*N];

int edg[N*N];
vector<int>g[N];

void addEdge(int u,int v){
	g[u].pb(v);
	edg[v]++;
}

void solve(){
	int t;
	cin>>t;
	for(int i=1;i<=t;i++){
		cin>>a[i];
		for(int j=1;j<=a[i];j++){
			string s;
			cin>>s;
			var[i][j]="";
			val[i][j]=0;
			int w=0;
			for(int k=0;k<sz(s);k++){
				if(s[k]=='='){
					w=1;
				}
				else if(w){
					val[i][j]*=10;
					val[i][j]+=s[k]-'0';
				}
				else{
					var[i][j]+=s[k];
				}
			}
		}
	}
	int k;
	cin>>k;
	map<string,int>id;
	for(int i=1;i<=k;i++){
		string s;
		int x;
		cin>>s>>x;
		id[s]=i;
		b[i]=x;
	}
	int cur=0;
	for(int i=1;i<=t;i++){
		for(int j=1;j<=a[i];j++){
			cur++;
			group[cur]=i;
			if(j>1){
				addEdge(cur-1,cur);
			}
			c[id[var[i][j]]]=val[i][j];
			lst[id[var[i][j]]]=cur;
			ver[id[var[i][j]]].pb(cur);
		}
		for(int j=1;j<=k;j++){
			if(c[j]==b[j]){
				used[lst[j]]=1;
			}
			c[j]=0;
		}
	}
	for(int i=1;i<=k;i++){
		vector<int>comp1,comp2;
		for(int j=0;j<sz(ver[i]);j++){
			if(used[ver[i][j]])comp1.pb(ver[i][j]);
			else comp2.pb(ver[i][j]);
		}
		if(sz(comp1)==0){
			cout<<"No";
			return ;
		}
		for(int u:comp1){
			for(int v:comp2){
				addEdge(v,u);
			}
		}
	}
	set<pair<int,int>>q;
	for(int i=1;i<=cur;i++){
		used[i]=0;
		q.insert(mp(edg[i],i));
	}
	vector<int>ans;
	while(!q.empty()){
		pair<int,int>p=*q.begin();
		q.erase(p);
		if(p.x!=0){
			cout<<"No";
			return ;
		}
		int v=p.y;
		used[v]=1;
		ans.pb(group[v]);
		for(int to:g[v]){
			if(used[to]){
				cout<<"No";
				return ;
			}
			q.erase(mp(edg[to],to));
			edg[to]--;
			q.insert(mp(edg[to],to));
		}
	}
	cout<<"Yes\n";
	for(int i=0;i<sz(ans);i++){
		cout<<ans[i]<<" ";
	}

}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0),cout.tie(0);
	int T=1;
//	cin>>T;
	while(T--){
		solve();
		cout<<endl;
	}
}

