#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <queue>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

struct vertice
{
    int v, mn, mx;
    vector <int> path;
};

const int N = int(1e5) + 7;

vector < pair < int, int > > g[N];
queue <vertice> q; // {val, {dist, {min, max}}}
vector < int > dist(N, 1e9);

int main() {
    int n, m;
    cin >> n >> m;
    for (int i = 1, x, y, c; i <= m; i++) {
        cin >> x >> y >> c;
        g[x].emplace_back(y, c);
        g[y].emplace_back(x, c);
    }
//    for(int i = 1; i <= n; i++){
//        for(auto j : g[i]){
//            cout << j.first << ' ' << j.second << '\n';
//        }
//        cout << '\n';
//    }

    /*for (int i = 1; i <= n; i++) {
        ans[i] = {INT_MAX}; // {dist, {min, max}}
    }*/
    vector <int> prr = {1};
    q.push({1, INT_MAX, INT_MIN, prr});
    dist[1] = 0;
    //used[1] = true;
    //pr[1] = -1;
    int anss = -1;
    vector <int> anspath;

    while (!q.empty()) {
        int v = q.front().v;
        int mn = q.front().mn;
        int mx = q.front().mx;
        //cout << v << " " << q.front().pr << "\n";
        vector <int> prpath = q.front().path;
        /*for (auto it:prpath)
            cout << it << " ";
        cout << "\n";*/
        if (v == n)
        {
            //cout << mx << " " << mn << "\n";
            if (mx - mn > anss)
            {
                anss = mx - mn;
                anspath = prpath;
            }
        }
        q.pop();
        for (auto i: g[v]) {
            int to = i.first;
            int color = i.second;
            /*if (ans[to].first > ans[v].first + 1) {
                q.erase({to, ans[to]});
                ans[to] = {ans[v].first + 1, {min(color, ans[v].second.first), max(color, ans[v].second.second)}};
                q.insert({to, ans[to]});
                pr[to] = v;
            } else*/ if (dist[to] >= dist[v] + 1) {
                //int mn = min(ans[v].second.first, color);
                //int mx = max(ans[v].second.second, color);
                //if (mx - mn > ans[to].second.second - ans[to].second.first) {
                    //q.erase({to, ans[to]});
                    dist[to] = dist[v] + 1;
                    prpath.push_back(to);
                    q.push({to, min(color, mn), max(color, mx), prpath});
                    prpath.pop_back();
                    //pr[to] = v;
                //}
            }
        }
    }
    /*while (!q.empty())
    {
        int v = q.begin()->first;
        q.erase(q.begin());
        anss = max(ans[v].second.second - ans[v].second.first);
    }*/
    cout << anspath.size() - 1 << "\n";
    for (auto it:anspath)
        cout << it << " ";

    /*vector < int > res;
    res.clear();
    int v = n;
    while(true){
        if(v == -1){
            break;
        }
//        cout << v << ' ';
        res.push_back(v);
        v = pr[v];
    }
    reverse(res.begin(), res.end());
    cout << int(res.size()) - 1 << '\n';
    for(auto i : res){
        cout << i << ' ';*/

    /* 6 8
1 5 2
5 2 5
3 5 4
1 3 10
3 4 6
4 5 7
4 6 1
2 6 1
*/

/*
6 9
1 2 2
2 5 3
1 4 1
4 3 9
2 3 5
5 3 7
5 6 10
3 6 2
4 5 2
*/

/*
6 8
1 2 0
2 4 1
4 5 100
1 4 10
5 6 2
4 6 9
1 3 7
3 6 8
*/

//    for (int i = 1; i <= n; i++) {
//        cout << i << " : " << ans[i].first << ' ' << ans[i].second.first << ' ' << ans[i].second.second << '\n';
//    }

//    while(!q.empty()){
//        int v = q.front();
//        q.pop();
//        for(auto i : g[v]){
//            int to = i.first;
//            int color = i.second;
//            if(used[to]){
//                continue;
//            }
//            int mn = min(ans[v].second.first, color);
//            int mx = max(ans[v].second.second, color);
//            ans[to] = {ans[v].first + 1, {mn, mx}};
//            q.push(to);
//            used[to] = true;
//        }
//    }
}
