#include <iostream>
#include <iostream>
#include <ostream>
#include <numeric>
#include <string>
#include <list>
#include <functional>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <ios>
#include <cmath>
#include <algorithm>
#include <fstream>
#include <unordered_map>
#include <unordered_set>

using namespace std;
   
#define READ(t) ll t; cin >> t;
#define PRINT(t) cout << t << endl
  
#define vool vector<bool>
#define vint vector<int>
#define vong vector<long long>
#define var vector<char>
#define ving vector<string>
   
#define sint set<int>
#define song set<long long>
#define sar set<char>
#define sing set<string>
   
#define mint set<int>
#define mong set<long long>
#define mar set<char>
   
   
#define ll long long
#define ull unsigned long long
#define ld long double
#define db double
 
#define EXIST(x, s) s.find(x) != s.end()
#define rep(i, a, b) for (ll i = (a); i <= ll(b); i++)

#define pll pair<long long, long long>

#define fr first
#define sc second

class Node{
public:
    ll count;
    
    Node(){
        count = 0;
    }
    Node(ll count){
        this->count = count;
    }
    unordered_map<char, Node> children;
};

void put(Node &node, string &str, int depth){
    if(depth == str.size()){
        node.count++;
        return;
    }
    
    put(node.children[str.at(depth)], str, depth+1);
}

ll calc(Node &node, ll k, ll &ans){
    ll sum = node.count;
    vector<ll> els;
    els.reserve(node.children.size());
    for(pair<char, Node> child: node.children){
        ll newVal = calc(child.second, k, ans);
        
        sum += newVal;
        els.push_back(newVal);
    }
    
    sort(els.begin(), els.end());
    
    while(sum > k){
        sum -= els.back();
        els.pop_back();
        ans++;
    }
    
    return sum;
}
void solve(ll t){
    ll n, k;
    cin >> n >> k;
    
    Node node(0);
    
    
    for(ll i = 0; i < n; i++){
        string s;
        cin >> s;
        
        put(node, s, 0);
    }
    
    ll ans = 0;
    cout << calc(node, k, ans) << "\n";
}

void test(){
    ll T;
    cin >> T;
    for(int t = 0; t < T; t++){
        solve(t);
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    solve(0);
}
