#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

template <typename T>
int sz(T &x) {
  return (int)(x.size());
}

int power(int x, int y, int mod) {
  if (y == 0) {
    return 1;
  }
  int z = power(x, y >> 1, mod);
  z = z * 1ll * z % mod;
  if (y & 1) {
    z = z * 1ll * x % mod;
  }
  return z;
}

const int mod = 998244353;
const int inf = 1000000007;

int toInt(string x) {
  int ans = 0;
  for (char i : x) {
    ans = ans * 10 + (i - '0');
  }
  return ans;
}

pii get(string x) {
  int pos = find(x.begin(), x.end(), ' ') - x.begin();
  if (isdigit(x[pos - 1])){
    return make_pair(toInt(x.substr(0, pos)), x[pos + 1] == 'A');
  } else {
    return make_pair(toInt(x.substr(pos + 1, sz(x) - pos)), x[0] == 'A');
  }
}

void solve() {
  string a, b;
  getline(cin, a);
  getline(cin, b);

  pii f = get(a);
  pii s = get(b);

  if (f.second > s.second || (f.second == s.second && f.first > s.first))  {
    swap(f, s);
  }


  if (f.second == s.second) {
    cout << s.first - f.first << "\n";
  } else {
    cout << s.first + f.first - 1 << "\n";
  }
}

int main() {
  #ifndef LOCAL58
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
  #endif

  int t = 1;
  //cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
