#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")

#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define F first
#define S second
#define pii pair <int , int>
#define pll pair <ll ,ll >
#define all(x) x.begin(),x.end()
#define sz(x) (int)(x.size())

using namespace std;

const int maxn = (int)1e5 + 7;
const ll linf = (ll)1e18 + 7;
const int INF = (int)1e9 + 7;
const double pi = 3.14159265359;
const double eps = 1e-6;
const int base = 1000 * 1000 * 1000;
const ll P = 37;
const int block = 100;

void boost(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n;

vector < int > g[maxn], parent[maxn];

map < pii, int > we;

vector < int > ans, curvec;

int curans = 0;

void findpath(int v, int mn, int mx){
    if(v == 1){
        if(curans < abs(mx - mn)){
            /*for(int i : curvec){
                cout << i << " ";
            }
            cout << endl;
            cout << mx << " " << mn << endl;
            */ans = curvec;
            curans = abs(mx - mn);
        }
        return;
    }
    for(int i : parent[v]){
        curvec.pb(i);
        findpath(i, min(mn, we[{min(i, v), max(i, v)}]), max(mx, we[{min(i, v), max(i, v)}]));
        curvec.pop_back();
    }
}

void solve(){
    int m;
    cin >> n >> m;
    for(int i = 1; i <= m; ++i){
        int x, y, w;
        cin >> x >> y >> w;
        g[y].pb(x);
        g[x].pb(y);
        if(x > y){
            swap(x, y);
        }
        we[{x, y}] = w;
    }
    vector < int > dist(n + 1);
    for(int i = 1; i <= n; ++i){
        dist[i] = INF;
    }
    queue < int > q;
    dist[1] = 0;
    q.push(1);
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(int i : g[v]){
            if(dist[i] > dist[v] + 1){
                dist[i] = dist[v] + 1;
                q.push(i);
                parent[i].clear();
                parent[i].pb(v);
            }
            else if(dist[i] == dist[v] + 1){
                parent[i].pb(v);
            }
        }
    }
    curvec.push_back(n);
    findpath(n, INF, 0);
    cout << dist[n] << endl;
    reverse(all(ans));
    for(int i : ans){
        cout << i << " ";
    }
}

signed main() {
    boost();
    int t = 1;
    //cin >> t;
    for(int i = 1; i <= t; ++i){
        solve();
    }
}
