#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <sstream>
#include <set>
#include <map>
#include <iomanip>

#define ll long long

using namespace std;

void _() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    // cout.tie(0);
}

bool is_f(vector<vector<char> >& a, int i, int j, int n, int m) {
    j -= 2;
    if (j < 0) {
        return false;
    }
    // if (
    //     a[i + 1][j + 2] == '#'
    //     || a[i + 2][j + 2] == '#'
    //     || a[i + 3][j + 2] == '#'
    //     || a[i + 4][j + 2] == '#'
    // ) {
    //     return false;
    // }
    int dx[] = {0, 0, 0, 1, 2, 2, 3, 4};
    int dy[] = {0, 1, 2, 0, 0, 1, 0, 0};
    if (
        a[i][j] == '#'
        && a[i][j + 1] == '#'
        && a[i][j + 2] == '#'
        && a[i + 1][j] == '#'
        && a[i + 2][j] == '#'
        && a[i + 2][j + 1] == '#'
        && a[i + 3][j] == '#'
        && a[i + 4][j] == '#') {
        for (int x = 0; x < 8; ++x) {
            a[i + dx[x]][j + dy[x]] = '.';
        }
        return true;
    }
    return false;
}

bool is_q(vector<vector<char> >& a, int i, int j, int n, int m) {
    if (a[i][j] == '#'
        && a[i + 1][j] == '#'
        && a[i + 2][j] == '#'
        && a[i + 2][j + 1] == '#'
        && a[i][j + 1] == '#'
        && a[i][j + 2] == '#'
        && a[i + 1][j + 2] == '#'
        && a[i + 2][j + 2] == '#'
        && a[i + 3][j + 2] == '#'
        && a[i + 4][j + 2] == '#') {
        return true;
    }
    return false;
}


// Turgyn Darkhan pidor
int main() {
    _();
    
    int n, m;
    cin >> n >> m;
    vector<vector<char> > a(n + 10, vector<char>(m + 10));
    int ans_f = 0, ans_q = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    for (int j = m - 1; j >= 0; --j) {
        for (int i = n - 1; i >= 0; --i) {
            if (is_f(a, i, j, n, m)) {
                // cout << i << ' ' << j << endl;
                ans_f++;
            }
        }
    }
    // for (int i = 0; i < n; ++i) {
    //     for (int j = 0; j < m; ++j) {
    //         cout << a[i][j] << ' ';
    //     }
    //     cout << endl;
    // }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (is_q(a, i, j, n, m)) {
                ans_q++;
            }
        }
    }
    cout << ans_q <<  ' ' << ans_f << endl;

}
