package com.company;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

public class Main {

    public static void main(String[] args) throws IOException {

        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));

        ArrayList<Integer> ints = new ArrayList<>();

        int t = Integer.parseInt(reader.readLine());
        int n;

        if (t < 1 || t > 1000)
            return;

        for (int i = 0; i < t; i++) {
            n = Integer.parseInt(reader.readLine());
            if (n < 2 || n > Math.pow(10, 18))
                return;
            ints.add(n);
        }

        for (Integer integer : ints
        ) {
            System.out.println(getMedian(getCoprimeInts(integer)));
        }
    }


    public static Integer getMedian(ArrayList<Integer> listOfCoprimeIntegers) {
        Integer median = 0;
        if (listOfCoprimeIntegers.size() % 2 == 0) {
            median = listOfCoprimeIntegers.get((listOfCoprimeIntegers.size() / 2) - 1);
        } else {
            median = listOfCoprimeIntegers.get(((listOfCoprimeIntegers.size() + 1) / 2) - 1);
        }
        return median;
    }

    public static ArrayList<Integer> getCoprimeInts(Integer integer) {
        ArrayList<Integer> coprimeInts = new ArrayList<>();

        for (int i = 1; i < integer; i++) {
            if (isCoprime(integer, i)) {
                coprimeInts.add(i);
            }
        }
        return coprimeInts;
    }


    public static boolean isCoprime(Integer x, Integer y) {
        while (x != 0 && y != 0) {
            if (x > y) x = x % y;
            else y = y % x;
        }
        if ((x + y) > 1)
            return false;
        else return true;
    }

}


