#include <iostream>
#include <vector>
#include <stdio.h>
#include <algorithm>
#include <iomanip>
#include <math.h>
#include <string>
#include <utility>
#include <map>
#include <string.h>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <list>
#include <fstream>
#include <sstream>
#include <stack>
#include <mutex>
#include <queue>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

bool a_smaller(pair<int, bool> a, pair<int, bool> b) {
	if (a.second == false && b.second == true)
		return true;
	if (a.second == true && b.second == false)
		return false;
	if (a.second == true && b.second == true)
		return (a.first < b.first);
	if (a.second == false && b.second == false)
		return (a.first > b.first);
}

ll absc(ll a) {
	if (a > 0)
		return a;
	return -a;
}

int n, m, c;

ll diff(int C, int M) {
	return absc(ll(n) - ll(M) * m - ll(C) * c);
}

bool pic[301][301];
int b_in_col[301];

void remove_q(int i, int j) {
	for (int k = 0; k < 5; k++)
		pic[i + k][j] = false;
	b_in_col[j] -= 5;
	
	pic[i][j - 1] = false;
	pic[i + 2][j - 1] = false;
	b_in_col[j - 1] -= 2;

	pic[i][j - 2] = false;
	pic[i+1][j - 2] = false;
	pic[i+2][j - 2] = false;
	b_in_col[j - 2] -= 3;
}

void remove_f(int i, int j) {
	for (int k = 0; k < 5; k++)
		pic[i + k][j-2] = false;
	b_in_col[j-2] -= 5;

	pic[i][j - 1] = false;
	pic[i + 2][j - 1] = false;
	b_in_col[j - 1] -= 2;

	pic[i][j] = false;
	b_in_col[j] -= 1;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

	int rows, cols;
	cin >> rows >> cols;

	for (int i = 0; i < rows; i++)
		for (int j = 0; j < cols; j++) {
			char c; cin >> c;
			if (c == '#') {
				pic[i][j] = true;
				b_in_col[j]++;
			}
		}

	int c_q = 0, c_f = 0;
	for (int j = cols-1; j >= 0; j--)
		if (b_in_col[j]) {
			for (int i = 0; i < rows; i++) {
				if (pic[i][j] && pic[i + 1][j]) {
					c_q++;
					remove_q(i, j);
				}
				if (pic[i][j] && !pic[i + 1][j]) {
					c_f++;
					remove_f(i, j);
				}
			}
		}

	cout << c_q << ' ' << c_f << endl;

	return 0;
}