#include <stdio.h>
#include <vector>
 
using namespace std;
 
int n, m;
int **a = new int*[100001];
bool used[100001];
int minRoads = 2147483647, maxDiff = 0;
vector <int> p;
vector <int> ans;
 
void dfs(int v, int cntRoads, int curMin, int curMax) {
    if(v == n && cntRoads == minRoads && (curMax - curMin) > maxDiff ) {
        maxDiff = curMax - curMin;
        ans = p;
        ans.push_back(v);
        return;
    }
     
    if(v == n && cntRoads < minRoads) {
        minRoads = cntRoads;
        maxDiff = curMax - curMin;
        ans = p;
        ans.push_back(v);
        return;     
    }
     
    if(v == n) {
        return;
    }
     
    used[v] = true;
    p.push_back(v);
    for(int i = 1; i <= n; i++) {
        if(a[v][i] != 0 && !used[i]) {
            dfs(i, cntRoads + 1, (a[v][i] < curMin ? a[v][i] : curMin), (a[v][i] > curMax ? a[v][i] : curMax));
        }
    }
     
    used[v] = false;
    p.pop_back();
    return;
}
 
int main()
{
    scanf("%d %d", &n, &m);
    for (int i = 0; i < m; i++) {
		a[i] = new int[n];
        int v, u, c;
        scanf("%d %d %d", &v, &u, &c);
        a[v][u] = c;
        a[u][v] = c;
    }
     
    dfs(1, 0, 2147483647, 0);
     
    printf("%d\n", minRoads);
    for(int i = 0; i < ans.size(); i++) {
        printf("%d ", ans[i]);
    }
 
    return 0;
}