#include <bits/stdc++.h>
using namespace std;
#define m_p make_pair
#define all(x) (x).begin(),(x).end()
#define sz(x) ((int)(x).size())
#define fi first
#define se second
typedef long long ll;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnf(2106);
const int N = 100005;
const ll INF = 1000000009000000009;

int n, m;
vector<pair<int, int> > g[N], gg[N];

int dd[N];
bool cc[N];
void bfs()
{
    queue<int> q;
    cc[1] = true;
    dd[1] = 0;
    q.push(1);
    while (!q.empty())
    {
        int x = q.front();
        q.pop();
        for (int i = 0; i < g[x].size(); ++i)
        {
            int h = g[x][i].fi;
            if (!cc[h])
            {
                cc[h] = true;
                dd[h] = dd[x] + 1;
                q.push(h);
            }
        }
    }
}

bool c[N][2][2];
ll d[N][2][2];

void dfs(int x, bool minu, bool maxu)
{
    if (c[x][minu][maxu])
        return;
    c[x][minu][maxu] = true;
    d[x][minu][maxu] = -INF;
    if (x == n && minu && maxu)
    {
        d[x][minu][maxu] = 0;
        return;
    }
    for (int i = 0; i < g[x].size(); ++i)
    {
        int h = g[x][i].fi;
        int dd = g[x][i].se;

        dfs(h, minu, maxu);
        d[x][minu][maxu] = max(d[x][minu][maxu], d[h][minu][maxu]);
        if (!minu)
        {
            dfs(h, true, maxu);
            d[x][minu][maxu] = max(d[x][minu][maxu], d[h][true][maxu] - dd);
        }
        if (!maxu)
        {
            dfs(h, minu, true);
            d[x][minu][maxu] = max(d[x][minu][maxu], d[h][minu][true] + dd);
        }
        if (!minu && !maxu)
        {
            dfs(h, true, true);
            d[x][minu][maxu] = max(d[x][minu][maxu], d[h][true][true]);
        }
    }
}

vector<int> ans;
void dfs1(int x, bool minu, bool maxu)
{
    ans.push_back(x);
    if (x == n && minu && maxu)
        return;
    for (int i = 0; i < g[x].size(); ++i)
    {
        int h = g[x][i].fi;
        int dd = g[x][i].se;

        if (d[h][minu][maxu] == d[x][minu][maxu])
        {
            dfs1(h, minu, maxu);
            return;
        }
        if (!minu && d[h][true][maxu] - dd == d[x][minu][maxu])
        {
            dfs1(h, true, maxu);
            return;
        }
        if (!maxu && d[h][minu][true] + dd == d[x][minu][maxu])
        {
            dfs1(h, minu, true);
            return;
        }
        if (!minu && !maxu && d[h][true][true] == d[x][minu][maxu])
        {
            dfs1(h, true, true);
            return;
        }
    }
}

void solv()
{
    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        int x, y, z;
        cin >> x >> y >> z;
        g[x].push_back(m_p(y, z));
        g[y].push_back(m_p(x, z));
    }

    bfs();
    for (int x = 1; x <= n; ++x)
    {
        for (int i = 0; i < g[x].size(); ++i)
        {
            if (dd[x] + 1 == dd[g[x][i].fi])
                gg[x].push_back(g[x][i]);
        }
    }
    for (int x = 1; x <= n; ++x)
        g[x] = gg[x];

    dfs(1, false, false);
    dfs1(1, false, false);

    cout << sz(ans) - 1 << "\n";
    for (int i = 0; i < sz(ans); ++i)
        cout << ans[i] << ' ';
    cout << "\n";
}

int main()
{
    #ifdef SOMETHING
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    #endif // SOMETHING
    ios_base::sync_with_stdio(false), cin.tie(0);

    int tt = 1;
    //cin >> tt;
    while (tt--)
    {
        solv();
    }
    return 0;
}
