#include <bits/stdc++.h>

using namespace std;

string to_string(string s) {
  return '"' + s + '"';
}
string to_string(const char* s) {
  return to_string((string) s);
}
string to_string(bool b) {
  return (b ? "true" : "false");
}
template <typename A, typename B>
string to_string(pair<A, B> p) {
  return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}
template <typename A>
string to_string(A v) {
  bool first = true;
  string res = "{";
  for (const auto &x : v) {
    if (!first) {
      res += ", ";
    }
    first = false;
    res += to_string(x);
  }
  res += "}";
  return res;
}
void debug_out() { cerr << endl; }
template <typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
  cerr << " " << to_string(H);
  debug_out(T...);
}
#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...) 42
#endif

int main() {
  cin.tie(0);
  ios_base::sync_with_stdio(false);
  int n, m;
  cin >> n >> m;
  vector<string> a(n);
  for (string &p : a) cin >> p;
  int q = 0, f = 0;
  while (17) {
    int ii = -1, jj = -1;
    for (int j = m - 1; ~j && ii == -1; --j) {
      for (int i = 0; i < n && ii == -1; ++i) {
        if (a[i][j] == '#') {
          ii = i;
          jj = j;
        }
      }
    }
    if (ii == -1) {
      cout << q << ' ' << f << '\n';
      return 0;
    }
    if (ii + 4 >= n || jj - 2 < 0) continue;
    if (a[ii + 1][jj] == '.') {
      ++f;
      a[ii][jj] = '.';
      a[ii][jj - 1] = '.';
      a[ii + 2][jj - 1] = '.';
      for (int k = 0; k < 5; ++k) {
        a[ii + k][jj - 2] = '.';
      }
      continue;
    }
    ++q;
    a[ii][jj - 1] = '.';
    a[ii + 2][jj - 1] = '.';
    a[ii][jj - 2] = '.';
    a[ii + 2][jj - 2] = '.';
    a[ii + 1][jj - 2] = '.';
    for (int k = 0; k < 5; ++k) {
      a[ii + k][jj] = '.';
    }
  }
  return 0;
}

