#ifdef ONPC
    #define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define sz(a) ((int)((a).size()))
#define char unsigned char

using namespace std;
// mt19937 rnd(239);
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;

int solve() {
    int n, m;
    if (!(cin >> n >> m)) {
        return 1;
    }
    const int INF = 1e9 + 7;
    vector<int> d(n, INF);
    vector<vector<pair<int, ll>>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        ll c;
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    queue<int> q;
    d[0] = 0;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : g[v]) {
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;
                q.push(u);
            }
        }
    }
    vector<ll> mxl(n, -INF), mnl(n, INF), mxr(n, -INF), mnr(n, INF);
    vector<int> pmxl(n, -1), pmnl(n, -1), pmxr(n, -1), pmnr(n, -1);
    vector<int> used(n, 0);
    q.push(0);
    used[0] = 1;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : g[v]) {
            if (d[u] == d[v] + 1) {
                if (mxl[u] < max(mxl[v], w)) {
                    mxl[u] = max(mxl[u], max(mxl[v], w));
                    pmxl[u] = v;
                }
                if (mnl[u] > min(mnl[v], w)) {
                    mnl[u] = min(mnl[u], min(mnl[v], w));
                    pmnl[u] = v;
                }
                if (!used[u]) {
                    used[u] = 1;
                    q.push(u);
                }
            }
        }
    }
    used.assign(n, 0);
    q.push(n - 1);
    used[n - 1] = 1;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : g[v]) {
            if (d[u] == d[v] - 1) {
                if (mxr[u] < max(mxr[v], w)) {
                    mxr[u] = max(mxr[u], max(mxr[v], w));
                    pmxr[u] = v;
                }
                if (mnr[u] > min(mnr[v], w)) {
                    mnr[u] = min(mnr[u], min(mnr[v], w));
                    pmnr[u] = v;
                }
                if (!used[u]) {
                    used[u] = 1;
                    q.push(u);
                }
            }
        }
    }
    ll ans = 0, opt = 0;
    for (int i = 0; i < n; i++) {
        ll val = max(mxr[i] - mnl[i], mxl[i] - mnr[i]);
        if (val > ans) {
            ans = val;
            opt = i;
        }
    }
    vector<int> pl, pr;
    int i = opt;
    if (mxr[i] - mnl[i] == ans) {
        int v = i;
        while (v != 0) {
            pl.push_back(v);
            v = pmnl[v];
        }
        pl.push_back(0);
        v = i;
        while (v != n - 1) {
            v = pmxr[v];
            pr.push_back(v);
        }
    } else {
        int v = i;
        while (v != 0) {
            pl.push_back(v);
            v = pmxl[v];
        }
        pl.push_back(0);
        v = i;
        while (v != n - 1) {
            v = pmnr[v];
            pr.push_back(v);
        }
    }
    reverse(pl.begin(), pl.end());
    for (int v : pr) {
        pl.push_back(v);
    }
    cout << sz(pl) - 1 << '\n';
    for (int v : pl) {
        cout << v + 1 << ' ';
    }
    cout << '\n';
    return 0;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int TET = 1e9;
    //cin >> TET;
    for (int i = 1; i <= TET; i++) {
        if (solve()) {
            break;
        }
        #ifdef ONPC
            cout << "__________________________" << endl;
        #endif
    }
    #ifdef ONPC
        cerr << endl << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
    #endif
}
