#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <cstddef>
#include <cstring>
#include <bitset>
#include <random>
#include <memory>
#include <iomanip>

typedef long long ll;
typedef long double ld;

using namespace std;

const int MX = 307;
char a[MX][MX];

void rem_q(int i, int j) {
    a[i][j] = '-';
    a[i + 1][j] = '-';
    a[i + 2][j] = '-';
    a[i + 3][j] = '-';
    a[i + 4][j] = '-';
    a[i][j - 1] = '-';
    a[i][j - 2] = '-';
    a[i + 1][j - 2] = '-';
    a[i + 2][j - 1] = '-';
    a[i + 2][j - 2] = '-';
}

void rem_f(int i, int j) {
    a[i][j] = '-';
    a[i][j - 1] = '-';
    a[i][j - 2] = '-';
    a[i + 1][j - 2] = '-';
    a[i + 2][j - 1] = '-';
    a[i + 2][j - 2] = '-';
    a[i + 3][j - 2] = '-';
    a[i + 4][j - 2] = '-';
}

int main() {

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> a[i][j];

    int aa = 0, b = 0;
    for (int j = m - 1; j >= 0; j--) {
        for (int i = 0; i + 1 < n; i++) {
            if (a[i][j] == '#') {
                if (a[i + 1][j] == '#') b++, rem_q(i, j);
                else aa++, rem_f(i, j);
            }
        }
    }

    cout << b << ' ' << aa << '\n';



    return 0;
}
