#include <bits/stdc++.h>
using namespace std;

// #define constexpr(...) (__VA_ARGS__)  
using ll = long long;
using ld = long double;
const ld eps = 1e-8;
// for matching the kactl notes
#define sz(x) ((int)x.size())
#define rep(i,a,b) for (int i = (int)(a); i < (int)(b); ++i) 
#define all(a) (a).begin(), (a).end()
#define print_op(...) ostream& operator<<(ostream& out, const __VA_ARGS__& u)
// DEBUGING TEMPLETE ////////////////////////////////////////////////////////////////////////{{{
// What? You wanted to see how this template works?  Check this out:
// https://quangloc99.github.io/2021/07/30/my-CP-debugging-template.html
#define db(val) "["#val" = "<<(val)<<"] "
#define CONCAT_(x, y) x##y
#define CONCAT(x, y) CONCAT_(x, y)
#ifdef LOCAL_DEBUG   
#   define clog cerr << setw(__db_level * 2) << setfill(' ') << "" << setw(0)
#   define DB() debug_block CONCAT(dbbl, __LINE__)
    int __db_level = 0;
    struct debug_block {
        debug_block() { clog << "{" << endl; ++__db_level; }
        ~debug_block() { --__db_level; clog << "}" << endl; }
    };
#else
#   define clog if (0) cerr
#   define DB(...)
#endif

template<class U, class V> print_op(pair<U, V>) {
    return out << "(" << u.first << ", " << u.second << ")";
}
template<class Con, class = decltype(begin(declval<Con>()))>
typename enable_if<!is_same<Con, string>::value, ostream&>::type
operator<<(ostream& out, const Con& con) { 
    out << "{";
    for (auto beg = con.begin(), it = beg; it != con.end(); ++it)
        out << (it == beg ? "" : ", ") << *it;
    return out << "}";
}
template<size_t i, class T> ostream& print_tuple_utils(ostream& out, const T& tup) {
    if constexpr(i == tuple_size<T>::value) return out << ")"; 
    else return print_tuple_utils<i + 1, T>(out << (i ? ", " : "(") << get<i>(tup), tup); 
}
template<class ...U> print_op(tuple<U...>) {
    return print_tuple_utils<0, tuple<U...>>(out, u);
}
// ACTUAL SOLUTION START HERE ////////////////////////////////////////////////////////////////}}}

const int maxn = 301010;
int n, k;

struct Trie {
    bool is_term;
    Trie* child[26];
    Trie(): is_term(false), child{0} {}
    ~Trie() {
        rep(c, 0, 26) {
            if (child[c]) delete child[c];
        }
    }
};

void insert(Trie* root, const string& s) {
    for (auto ch: s) {
        auto c = ch - 'a';
        if (!root->child[c]) root->child[c] = new Trie();
        root = root->child[c];
    }
    root->is_term = 1;
}

int ans = 0;
int dfs(Trie* r) {
    if (!r) return 0;
    int sum = r->is_term;
    vector<int> lst;
    rep(c, 0, 26) {
        if (!r->child[c]) continue;
        lst.push_back(dfs(r->child[c]));
    }
    sort(all(lst));
    for (auto x: lst) sum += x;
    clog << r << ' ' << db(sum) << db(lst) << endl;
    while (sum > k) {
        ++ans;
        sum -= lst.back();
        lst.pop_back();
    }
    return sum;
}

int main() {
#ifdef LOCAL
    freopen("main.inp", "r", stdin); 
    freopen("main.out", "w", stdout);  
    freopen(".log", "w", stderr);
#endif
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> k;
    Trie * root = new Trie();
    rep(i, 0, n) {
        string s;
        cin >> s;
        insert(root, s);
    }
    
    auto t = dfs(root);
    ans += t > 0;
    cout << ans;
    delete root;
    
    return 0;
}

// vim: foldmethod=marker

