#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
#define int ll

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int T;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        vector<int> w(n + 1), b(n + 1);
        set<pair<int, int>> stw, stb;
        int s = 0, p_w = 0, p_b = 0;
        for (int i = 1; i <= n; i++) {
            cin >> w[i] >> b[i];
            if (w[i] > 0) {
                stw.insert({w[i], i});
            }
            if (b[i] > 0) {
                stb.insert({b[i], i});
            }
            s += w[i] + b[i];
            p_w += w[i];
            p_b += b[i];
        }
        if (s != 2 * (n - 1) || (p_w & 1) || (p_b & 1)) {
            cout << "No\n";
            continue;
        }
        bool ok = true;
        vector<pair<int, int>> white_edges, black_edges;
        while (!stw.empty()) {
            if (stw.begin()->F > 1) {
                ok = false;
                break;
            }
            int id = stw.begin()->S;
            stw.erase(stw.begin());
            int id2 = stw.rbegin()->S;
            stw.erase({w[id2], id2});
            w[id2]--;
            if (w[id2] > 0) stw.insert({w[id2], id2});
            white_edges.pb({id, id2});
        }
        while (!stb.empty()) {
            if (stb.begin()->F > 1) {
                ok = false;
                break;
            }
            int id = stb.begin()->S;
            stb.erase(stb.begin());
            int id2 = stb.rbegin()->S;
            stb.erase({b[id2], id2});
            b[id2]--;
            if (b[id2] > 0) stw.insert({b[id2], id2});
            black_edges.pb({id, id2});
        }
        if (!ok) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
            for (auto it : white_edges) {
                cout << it.F << ' ' << it.S << " W\n";
            }
            for (auto it : black_edges) {
                cout << it.F << ' ' << it.S << " B\n";
            }
        }
    }
}