#pragma GCC optimize("Ofast")

#include <map>
#include <set>
#include <vector>
#include <stack>
#include <deque>
#include <iostream>
#include <list>

using namespace std;


char f[500][500];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> f[i];
    }
    int ansf = 0;
    int ansq = 0;

    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n; i++) {
            if (f[i][j] != '#') continue;
            bool F = true;
            for (int k = 0; k < 5; k++) {
                if (f[i + k][j] != '#') {
                    F = false;
                }
            }
            if (F) {
                for (int k = 0; k < 5; k++) {
                    f[i + k][j] = '.';
                }
                for (int k = 0; k < 3; k++) {
                    f[i][j + k] = '.';
                }
                f[i + 2][j + 1] = '.';
                ansf++;
            } else {
                for (int k = 0; k < 5; k++) {
                    f[i + k][j + 2] = '.';
                }
                f[i][j + 1] = f[i + 2][j + 1] = '.';
                f[i][j] = f[i + 1][j] = f[i + 2][j] = '.';
                ansq++;
            }
        }
    }
    cout << ansq << " " << ansf << endl;
    return 0;
}

/*
5 3
###
#.#
###
..#
..#

5 3
###
#..
##.
#..
#..

 5 8
 ###..###
 #.#..#..
 ###..##.
 ..#..#..
 ..#..#..

 8 8
 .....###
 ###..#.#
 #.######
 ###.####
 #.###.##
 #.#.###.
 ..#...#.
 ......#.

 */