#include<bits/stdc++.h>

using namespace std;

int const maxn = 1e5 + 5;
vector < pair < int, int > > g[maxn];
pair < int, int > best[2][maxn];
int lst[2][maxn];
int inf = 1e9 + 7, n;

void solve(int start, int t) {
    for (int i = 1; i <= n; ++i) {
        best[t][i] = {inf, inf};
    }
    best[t][start] = {0, inf};
    set < pair < int, int > > Q;
    for (int i = 1; i <= n; ++i) {
        Q.insert({best[t][i].first, i});
    }
    while ((int)Q.size()) {
        auto p = (*Q.begin());
        Q.erase(p);
        for (auto u : g[p.second]) {
            pair < int, int > now = {p.first + 1, min(u.second, best[t][p.second].second)};
            if (now < best[t][u.first]) {
                Q.erase({best[t][u.first].first, u.first});
                best[t][u.first] = now;
                lst[t][u.first] = p.second;
                Q.insert({best[t][u.first].first, u.first});
            }
        }
    }
}

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m, u, v, c;
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        cin >> u >> v >> c;
        g[u].push_back({v, c});
        g[v].push_back({u, c});
    }
    solve(1, 0);
    solve(n, 1);
    int d = best[0][n].first;
    pair < int, int > bests = {-1, -1};
    int val = -1;
    for (int i = 1; i <= n; ++i) {
        for (auto key : g[i]) {
            if (best[0][i].first + best[1][key.first].first + 1 == d) {
                int imin = min({best[0][i].second, best[1][key.first].second, key.second});
                if (key.second - imin > val) {
                    val = key.second - imin;
                    bests = {i, key.first};
                }
            }
        }
    }
    vector < int > ans;
    int now = bests.first;
    while (now != 0) {
        ans.push_back(now);
        now = lst[0][now];
    }
    reverse(ans.begin(), ans.end());
    now = bests.second;
    while (now != 0) {
        ans.push_back(now);
        now = lst[1][now];
    }
    cout << ans.size() - 1 << '\n';
    for (auto key : ans) cout << key << " ";
    return 0;
}
