#include <cstdio>
#include <cassert>
#include <vector>
#include <iostream>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <cmath>
//#include "optimization.h"

#define all(a) a.begin(), a.end()
#define beg() begin()
#define srt(a) sort(all(a))
#define ll long long
#define ld long double
#define f first
#define s second
#define io cin.sync_with_stdio(false);cout.sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define EPS 1e-9
#define point pair<ll, ll>

using namespace std;

struct vert{
    int cnt = 0;
    vert* to[130];
    vert* p;
    vert() {
        fill(to, to + 30, nullptr);
    }
};

int n, k, ans = 0;

void dfs(vert* v) {
    if(v->cnt == 0)
        return;
    if(v->cnt <= k) {
        v->cnt = 0;
        ans++;
        return;
    }
    while(v->cnt > k) {
        int ma = -1;
        for(int i = 0; i < 30; i++) {
            if(v->to[i]) {
                if(ma == -1 || v->to[i]->cnt > v->to[ma]->cnt) {
                    ma = i;
                }
            }
        }
        v->cnt -= v->to[ma]->cnt;
        dfs(v->to[ma]);
        v->cnt += v->to[ma]->cnt;
    }
}

signed main() {
    io;
    cin >> n >> k;
    auto head = new vert();
    head->p = head;
    for(int i = 0; i < n; i++) {
        string s;
        cin >> s;
        auto cur = head;
        for(auto cc: s) {
            int c = cc - 'a';
            cur->cnt++;
            if(!cur->to[c]) {
                cur->to[c] = new vert();
                cur->to[c]->p = cur;
            }
            cur = cur->to[c];
        }
        cur->cnt++;
    }
    dfs(head);
    dfs(head);
    cout << ans;
}