#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <unordered_map>

#include <cassert>

using namespace std;

typedef long long ll;
vector<pair<string, int> > a[105];
vector<pair<int, int> > b[105];
int ptr[105];
int ans[(int) 1e4 + 10];
unordered_map<string, int> m;
int val[(int) 1e4 + 10];
bool used[(int) 1e4 + 10];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    int sum = 0;
    for (int i = 0; i < t; i++) {
        int len;
        cin >> len;
        for (int j = 0; j < len; j++) {
            string s;
            cin >> s;
            int pos = s.find("=");
            int n = stoi(s.substr(pos + 1));
            s = s.substr(0, pos);
            a[i].push_back({s, n});
        }
        ptr[i] = len - 1;
        sum += len;
    }
    int vars;
    cin >> vars;
    for (int i = 0; i < vars; i++) {
        string s;
        int n;
        cin >> s >> val[i];
        m[s] = i;
    }
    for (int i = 0; i < t; i++) {
        for (int j = 0; j < a[i].size(); j++) {
            b[i].push_back({m[a[i][j].first], a[i][j].second});
        }
    }
    for (int a = 0; a < sum; a++) {
        for (int i = 0; i < t; i++) {
            if (ptr[i] == -1) {
                if (i == t - 1) {
                    cout << "No\n";
                    return 0;
                }
                continue;
            }
            int var = b[i][ptr[i]].first;
            int n = b[i][ptr[i]].second;
            if (used[var] || n == val[var]) {
                used[var] = 1;
                ptr[i]--;
                ans[sum - 1 - a] = i;
                break;
            }
            if (i == t - 1) {
                cout << "No\n";
                return 0;
            }
        }
    }
    cout << "Yes\n";
    for (int a = 0; a < sum; a++) {
        cout << ans[a] + 1 << " \n"[a == sum - 1];
    }
}