#include <bits/stdc++.h>

using namespace std;

bool on_table(int i, int j, int n, int m) {
    return 0 <= i && i < n && 0 <= j && j <= m;
}

int black_around(int i, int j, int n, int m, vector<string> &table) {
    int count = 0;
    for (int u = -1; u <= 1; u++) {
        for (int v = -1; v <= 1; v++) {
            if (u == 0 && v == 0) {
                continue;
            }
            if (on_table(i + u, j + v, n, m) && table[i + u][j + v] == '#') {
                count++;
            }
        }
    }
    return count;
}

int main() {
    iostream::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<string> table(n);
    for (int i = 0; i < n; i++) {
        cin >> table[i];
    }

    int q = 0, f = 0;
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            // cout << i << " " << j << endl;
            if (table[i][j] == '.' && black_around(i, j, n, m, table) == 8) {
                // cout << i << " " << j << endl;
                q++;
                table[i - 1][j - 1] = table[i - 1][j] = table[i - 1][j + 1] =
                table[i][j - 1] = table[i][j + 1] =
                table[i + 1][j - 1] = table[i + 1][j] = table[i + 1][j + 1] =
                table[i + 2][j + 1] = table[i + 3][j + 1] = '.';
            } else if (j <= m - 2 && table[i][j] == '.' && table[i][j + 1] == '.'
                        && black_around(i, j, n, m, table) == 6) {
                f++;
                table[i - 1][j - 1] = table[i - 1][j] = table[i - 1][j + 1] =
                table[i][j - 1] =
                table[i + 1][j - 1] = table[i + 1][j] =
                table[i + 2][j - 1] = table[i + 3][j - 1] = '.';
            }
        }
    }

//    int count = 0;
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < m; j++) {
//            if (table[i][j] == '#') {
//                count++;
//            }
//        }
//    }
//    f = count / 8;

    cout << q << " " << f << endl;

    return 0;
}