#include <locale.h>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <numeric>
#include <iterator>
#include <sstream>
#include <map>
#include <math.h>
#include <stdio.h>
#include <stack>
#include <random>  
#include <ctime>  
#include <queue>
#include <set>
using namespace std;
using ld = long double;
using ll = long long;

ll mod = 1e9 + 7;
int const N = 3e5 + 100;

mt19937 rnd;

ll  random(ll  limit)
{
	uniform_int_distribution <ll > uniform_dist(0, limit);
	return uniform_dist(rnd);
}


ll bpow(ll a, ll p) {
	ll res = 1;
	while (p > 0) {
		if (p % 2) {
			res = res * a % mod;
		}
		a = a * a % mod;
		p /= 2;
	}
	return res;
} 


ll inv(ll a) {
	return bpow(a, mod - 2);
}


ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}


struct vertex {
	int next[28];
	int id;
	bool is_term;
	int a;
	int b;
};

vector<vertex>  t(1);

int cur_id = 1;

void add_string(const string& s) {
	int v = 0;
	for (int i = 0; i < s.length(); ++i) {
		char c = s[i] - 'a'; //    
		if (t[v].next[c] == -1) {
			vertex nv;
			nv.id = cur_id;
			cur_id++;
			nv.is_term = false;
			for (int l = 0; l < 28; l++) nv.next[l] = -1;

			t.push_back(nv);

			t[v].next[c] = nv.id;
			
		}
		v = t[v].next[c];
	}
	t[v].is_term = true;
}


int n, k;

void dfs(vertex &v) {
	for (int i = 0; i < 28; i++) {
		if (v.next[i] != -1) {
			dfs(t[v.next[i]]);
		}
	}

	vector<ll> xui;
	
	v.a = 0;
	v.b = 0;

	ll sum = 0;
	ll num = 0;

	for (int i = 0; i < 28; i++) {
		if (v.next[i] != -1) {
			vertex *w = &t[v.next[i]];
			v.a += w->a;
			xui.push_back(w->b);
			sum += w->b;
			num++;
		}
	}
	
	if (v.is_term)
	{
		num++;
		sum++;
		xui.push_back(1);
	}

	sort(xui.begin(), xui.end());

	if (v.id == 0) {
		int q = 1;
	}

	if (sum <= k) {
		v.b = sum;
	}

	else {
		int cursum = 0;
		int cur = 0;
		while (cur < xui.size() && cursum + xui[cur] <= k)
		{
			
			cursum += xui[cur];
			cur++;
		}

		v.b = cursum;
		v.a += (int)xui.size() - cur;

	}

	

}

void solve() {
	
	cin >> n >> k;
	
	vertex st;
	st.id = 0;
	st.is_term = false;
	for (int l = 0; l < 28; l++) st.next[l] = -1;
	t[0] = st;
	



	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		add_string(s);
	}

	dfs(t[0]);

	ll ans = t[0].a;
	if (t[0].b != 0) ans += 1;

	cout << ans << '\n';
	

}



int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	rnd = mt19937(956231);
	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}

}

/*

*/