#include <bits/stdc++.h>
typedef long long int ll;
typedef unsigned long long int ull;
typedef long double ld;

using namespace std;

const int MAXN = 1e2 + 1;
const ll MOD = 1e9 + 7;
const int INF = 2e9 + 1;
const ll INFLL = 1e18;

void solve() {
    set <pair <int, int>> streaks;
    multiset <int> days;
    multiset <int> lens;
    map <int, vector <int>> changes;

    auto erase = [&](int x) {
        days.erase(days.find(x));
        if (days.find(x) != days.end())
            return;
        auto seg = streaks.lower_bound({x + 1, 0});
        seg = prev(seg);
        int l = seg -> first, r = seg -> second;
        streaks.erase(seg);
        lens.erase(lens.find(r - l + 1));
        if (l != x)
            streaks.emplace(l, x - 1), lens.insert(x - l);
        if (r != x)
            streaks.emplace(x + 1, r), lens.insert(r - x);
    };

    auto add = [&](int x) {
        if (days.find(x) != days.end()) {
            days.insert(x);
            return;
        }
        days.insert(x);
        auto seg = streaks.lower_bound({x, 0});
        int l = -1, r = -1;
        if (seg != streaks.begin()) {
            seg = prev(seg);
            if (seg -> second == x - 1) {
                l = seg -> first;
                streaks.erase(seg);
                lens.erase(lens.find(x - l));
            }
        }
        auto seg1 = streaks.lower_bound({x + 1, 0});
        if (seg1 != streaks.end() && seg1 -> first == x + 1) {
            r = seg1 -> second;
            streaks.erase(seg1);
            lens.erase(lens.find(r - x));
        }
        if (l == -1 && r == -1) {
            streaks.emplace(x, x);
            lens.insert(1);
        } else if (l != -1 && r == -1) {
            streaks.emplace(l, x);
            lens.insert(x - l + 1);
        } else if (l == -1 && r != -1) {
            streaks.emplace(x, r);
            lens.insert(r - x + 1);
        } else {
            streaks.emplace(l, r);
            lens.insert(r - l + 1);
        }
    };
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        add(x / m);
        changes[m - x % m].push_back(x / m);
    }
    int ans = *lens.rbegin(), ansm = 0;
    for (auto &x : changes) {
        if (x.first == m)
            break;
        for (int i : x.second) {
            erase(i);
            add(i + 1);
        }
        if (ans < *lens.rbegin()) {
            ans = *lens.rbegin();
            ansm = x.first;
        }
    }
    cout << ans << " " << ansm << '\n';
}

int32_t main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    //freopen("brokeday.in","r",stdin);
    //freopen("richday.out","w",stdout);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}