#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <utility>
#include <unordered_map>

using namespace std;

typedef long long ll;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    vector<vector<pair<string, int>>> lines(t);
    int sl = 0;
    for (int i = 0; i < t; ++i) {
        int l;
        cin >> l;
        sl += l;
        lines[i].resize(l);
        for (int j = 0; j < l; ++j) {
            string s;
            cin >> s;
            auto ep = s.find('=');
            string var = s.substr(0, ep);
            int val = stoi(s.substr(ep + 1, s.size()));
            lines[i][j] = make_pair(var, val);
        }
    }
    unordered_map<string, vector<int>> vs;
    unordered_map<string, int> vv;
    unordered_map<string, int> vc;
    unordered_map<string, vector<int>> vg;
    int k;
    cin >> k;
    for (int i = 0; i < k; ++i) {
        string var;
        int val;
        cin >> var;
        cin >> val;
        vv[var] = val;
        vs[var] = vector<int>(t, -1);
        vc[var] = 0;
        vg[var] = vector<int>(t, sl);
    }
    for (int i = 0; i < t; ++i) {
        for (int j = 0; j < lines[i].size(); ++j) {
            string var = lines[i][j].first;
            int val = lines[i][j].second;
            if (val != vv[var]) {
                if (vs[var][i] == -1) {
                    vc[var] += 1;
                }
                vs[var][i] = j;
                vg[var][i] = sl;
            } else {
                vg[var][i] = j;
            }
        }
    }
    vector<int> cl(t);
    vector<int> ans(sl, -1);
    for (int i = 0; i < sl; ++i) {
        for (int j = 0; j < t; ++j) {
            if (lines[j].size() <= cl[j]) {
                continue;
            }
            string var = lines[j][cl[j]].first;
            int val = lines[j][cl[j]].second;
            if (val != vv[var] || (vg[var][j] > cl[j])) {
                if (cl[j] == vs[var][j]) {
                    vc[var] -= 1;
                }
                ans[i] = j;
                ++cl[j];
                break;
            } else if (vc[var] == 0) {
                ans[i] = j;
                ++cl[j];
                break;
            }
        }
        if (ans[i] == -1) {
            cout << "No";
            return 0;
        }
    }
    cout << "Yes\n";
    for (auto &x: ans) {
        cout << x + 1 << ' ';
    }
}
