﻿#define _CRT_SECURE_NO_WARNINGS
#pragma GCC Optimize("Ofast")
#include <string.h>
#include <iostream>
#include <vector>
#include <set>
#include <chrono>
#include <string>
#include <time.h>
#include <unordered_set>
#include <iomanip>
#include <cmath>
#include <map>
#include <queue>
#include <numeric>
#include <unordered_map>
#include <algorithm>
#include <fstream>
#include <sstream>
#include <cstddef>
#include <cstdio>
#include <memory>
#include <stdexcept>
#include <complex>
#include <array>

using namespace std;
typedef long long ll;

const int maxn = 1e2 + 14, lg = 15;

#define MAXN 500

#include <random>
mt19937 gener(1231512);
#define vec vector
#define vi vector<int>
#define pii pair<int, int>
//#define int long long

bool is_poly(vi& a) {
	for (int i = 0; i < a.size() / 2; ++i)
		if (a[i] != a[a.size() - 1 - i]) return false;
	return 1;
}

int popcount(int x) {
	int z = 0;
	while (x) z += x & 1, x >>= 1;
	return z;
}

const int PRIMEN = 1000000;
int lp[PRIMEN + 1];
vector<int> pr;
void sieve() {
	for (int i = 2; i <= PRIMEN; ++i) {
		if (!lp[i]) {
			lp[i] = i;
			pr.push_back(i);
		}
		for (int j = 0; j < (int)pr.size() && pr[j] <= lp[i] && i * pr[j] <= PRIMEN; ++j)
			lp[i * pr[j]] = pr[j];
	}
}
int n, k;
struct node {
	node* ch[26] = {};
	node* parent = (node*)0;
	int count = 0;
};

void add(node*& x, string& s) {
	if (!x) {
		x = new node();
	}
	node* u = x;
	for (auto& e : s) {
		if (!u->ch[e - 'a']) {
			u->ch[e - 'a'] = new node();
			u->ch[e - 'a']->parent = u;
		}
		u = u->ch[e - 'a'];
	}
	++u->count;
	while (u->parent) {
		u = u->parent;
		u->count++;
	}
}
set<pair<int, node*>> w;
set<node*> par;
map<node*, vec<pair<int, node*>>> ch;
void go(node* s) {
	if (s->count <= k) {
		par.insert(s);
		w.insert({ s->count, s });
	}
	else {
		for (int i = 0; i < 26; ++i) {
			if (s->ch[i]) {
				go(s->ch[i]);
			}
		}
	}
}
signed main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);
	cin >> n >> k;
	node* x = 0;
	while (n--) {
		string s;
		cin >> s;
		add(x, s);
	}
	go(x);
	int cnt = 0;
	while (w.size()) {
		auto mx = *w.rbegin();
		node* cur = mx.second;
		node* parent = mx.second->parent;
		if (par.count(parent)) {
			w.erase({ parent->count, parent });
			par.erase(parent);
		}
		if (!parent) {
			++cnt;
			break;
		}
		par.erase(mx.second);
		w.erase(mx);
		node* tt = parent;
		parent->count -= cur->count;
		while (parent&& parent->count <= k) {
			for (int i = 0; i < 26; ++i) {
				if (parent->ch[i] && par.count(parent->ch[i])) {
					par.erase(parent->ch[i]);
					w.erase({ parent->ch[i]->count, parent->ch[i] });
				}
			}
			tt = parent;
			parent = parent->parent;
			if (parent) {
				parent->count -= cur->count;
			}
		}
		parent = tt;
		if (parent->count <= k) {
			par.insert(parent);
			w.insert({ parent->count, parent });
		}
		++cnt;

	}
	cout << cnt;
}
