﻿#define _CRT_SECURE_NO_WARNINGS
#pragma GCC Optimize("Ofast")
#include <string.h>
#include <iostream>
#include <vector>
#include <set>
#include <chrono>
#include <string>
#include <time.h>
#include <unordered_set>
#include <iomanip>
#include <cmath>
#include <map>
#include <queue>
#include <numeric>
#include <unordered_map>
#include <algorithm>
#include <fstream>
#include <sstream>
#include <cstddef>
#include <cstdio>
#include <memory>
#include <stdexcept>
#include <complex>
#include <array>

using namespace std;
typedef long long ll;

const int maxn = 1e2 + 14, lg = 15;

#define MAXN 500

#include <random>
mt19937 gener(1231512);
#define vec vector
#define vi vector<int>
#define pii pair<int, int>
//#define int long long

bool is_poly(vi& a) {
	for (int i = 0; i < a.size() / 2; ++i)
		if (a[i] != a[a.size() - 1 - i]) return false;
	return 1;
}

int popcount(int x) {
	int z = 0;
	while (x) z += x & 1, x >>= 1;
	return z;
}

const int PRIMEN = 1000000;
int lp[PRIMEN + 1];
vector<int> pr;
void sieve() {
	for (int i = 2; i <= PRIMEN; ++i) {
		if (!lp[i]) {
			lp[i] = i;
			pr.push_back(i);
		}
		for (int j = 0; j < (int)pr.size() && pr[j] <= lp[i] && i * pr[j] <= PRIMEN; ++j)
			lp[i * pr[j]] = pr[j];
	}
}

bool check(int i, int j, vec<pii>& let, vec<string>& a) {
	for (auto& e : let) {
		int ni = i + e.first, nj = j + e.second;
		if (ni < a.size() && nj < a[0].size()) {
			if (a[ni][nj] != '#') {
				return false;
			}
		}
		else return false;
	}
	return true;
}

vec<vi> g;
vector<char> cl;
vector<int> p;
int cycle_st, cycle_end;
vi path;
bool dfs(int v) {
	cl[v] = 1;
	for (size_t i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (cl[to] == 0) {
			p[to] = v;
			if (dfs(to))  return true;
		}
		else if (cl[to] == 1) {
			cycle_end = v;
			cycle_st = to;
			return true;
		}
	}
	cl[v] = 2;
	return false;
}

vector<int> ans;
bool used[20000];

void dfs1(int v) {
	used[v] = true;
	for (size_t i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (!used[to])
			dfs1(to);
	}
	ans.push_back(v);
}

void topological_sort() {
	ans.clear();
	for (int i = 0; i < g.size(); ++i)
		if (!used[i])
			dfs1(i);
	reverse(ans.begin(), ans.end());
}


signed main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);
	int t;
	cin >> t;
	set<string> x;
	vec<vec<pair<string, int>>> z;
	vec<unordered_map<string, pii>> lst;
	vi cnt;
	int r = 0;
	while (t--) {
		int c;
		cin >> c;
		vec<pair<string, int>> w;
		unordered_map<string, pii> last;
		while (c--) {
			string s;
			cin >> s;
			string name = s.substr(0, s.find('='));
			int val = stoi(s.substr(s.find('=') + 1));
			x.insert(name);
			w.push_back({ name, val });
			last[name] = { val, r };
			++r;
		}
		cnt.push_back(r);
		lst.push_back(last);
		z.push_back(w);
	}
	int c;
	cin >> c;
	vec<pair<string, int>> res;
	g.resize(r);
	while (c--) {
		string x;
		int val;
		cin >> x >> val;
		res.push_back({ x, val });
		vi ok, neok;
		for (int i = 0; i < lst.size(); ++i) {
			if (lst[i].count(x)) {
				auto& u = lst[i][x];
				if (u.first == val) ok.push_back(u.second);
				else neok.push_back(u.second);
			}
		}
		if (!ok.size()) {
			cout << "No\n";
			return 0;
		}
		for (auto& e : ok) {
			for (auto& t : neok) {
				g[t].push_back(e);
			}
		}
	}
	int prev = 0;
	for (auto& e : cnt) {
		for (int i = prev + 1; i < e; ++i) {
			g[i - 1].push_back(i);
		}
		prev = e;
	}
	p.assign(r, -1);
	cl.assign(r, 0);
	cycle_st = -1;
	for (int i = 0; i < r; ++i)
		if (dfs(i))
			break;
	/*if (cycle_st != -1) {
		cout << "No";
		return 0;
	}*/
	topological_sort();
	unordered_map<string, int> rs;
	vi pos(cnt.size());
	for (auto& e : ans) {
		int x = lower_bound(cnt.begin(), cnt.end(), e + 1) - cnt.begin();
		int u = pos[x];
		rs[z[x][u].first] = z[x][u].second;
		pos[x]++;
	}
	for (auto& e : res) {
		if (rs[e.first] != e.second) {
			cout << "No\n";
			return 0;
		}
	}
	cout << "Yes\n";
	for (auto& e : ans) {
		int x = lower_bound(cnt.begin(), cnt.end(), e + 1) - cnt.begin();
		cout << x + 1 << " ";
	}
}
