#include <bits/stdc++.h>
       
using namespace std;
       
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
       
#define size(s) (ll)(s).size()
#define all(s) (s).begin(), s.end()
#define rall(s) (s).rbegin(), s.rend()
       
const ll INF = 2e9 + 1;
const ll MOD = 1e9 + 7;
const ll MAXN = 2e6 + 42;
const ld EPS = 1e-12;
const ld PI = acos(-1);
const ll XX[] = {0, 0, 1, -1};
const ll YY[] = {1, -1, 0, 0};
const ll ALPH = 31;
 
mt19937 gen(time(NULL));

void bye() {
    cout << "\n";
    exit(0);
}

struct Edge {
    ll u, v, w;
};

struct Data {
    ll w, mx, mn, idx;
};


struct Solution {

    ll sign(ll val) {
        return ((val > 0) ? 2 : (val < 0) ? 1 : 0);
    }

    ll g[20][20];

    ll get(ll x, ll y) {
        return g[x + 10][y + 10];
    }

    void set(ll x, ll y, ll val) {
        g[x + 10][y + 10] = val;
    }

    ll func(ll x, ll y) {
        return ((x-5)*(x-5)*(x+5)*(x+5)+(y-5)*(y-5)*(y+5)*(y+5))*x*x*y*y;
    }

    bool is_min(ll x, ll y) {
        ll val = get(x, y);
        return val < get(x + 1, y) && val < get(x, y + 1) && val < get(x - 1, y) && val < get(x, y - 1); 
    }

    bool is_max(ll x, ll y) {
        ll val = get(x, y);
        return val > get(x + 1, y) && val > get(x, y + 1) && val > get(x - 1, y) && val > get(x, y - 1); 
    }

    bool is_plat(ll x, ll y) {
        ll val = get(x, y);
        return val == get(x + 1, y) && val == get(x, y + 1) && val == get(x - 1, y) && val == get(x, y - 1); 
    }

    void init() {
        for (ll x = -10; x <= 10; x++) {
            for (ll y = -10; y <= 10; y++) {
                ll val = func(x, y);
                set(x, y, val);
            }
        }

        for (ll x = -9; x <= 9; x++) {
            for (ll y = -9; y <= 9; y++) {
                if (is_min(x, y)) {
                    cout << "m";
                } else if (is_max(x, y)) {
                    cout << "M";
                } else if (is_plat(x, y)) {
                    cout << "p";
                } else {
                    cout << ".";
                }
            }
            cout << "\n";
        }
    }

    void solve() {
        // init();

        string a;
        for (ll i = 0; i < 4; i++) {
            cin >> a;
        }
        string b;

        for (ll i = 0; i < 4; i++) {
            cin >> b;
        }
        string c;
        cin >> c;
        cin >> c;

        string ans[8] = {"x 3 - 4 ^ y -5 + 2 ^ +",
            "1", 
            "x 5 - x 5 - * x 5 + * x 5 + * y 5 - y 5 - * y 5 + * y 5 + * +", 
            "x 5 - x 5 - * x 5 + * x 5 + * y 5 - y 5 - * y 5 + * y 5 + * + x * x * y * y *",
            "0 x 5 - x 5 - * x 5 + * x 5 + * y 5 - y 5 - * y 5 + * y 5 + * + -",
            "0 x 5 - x 5 - * x 5 + * x 5 + * y 5 - y 5 - * y 5 + * y 5 + * + x * x * y * y * -",
            "x 5 - x 5 - * x 5 + * x 5 + * y 5 - y 5 - * y 5 + * y 5 + * + x *",
            "x 5 - x 5 - * x 5 + * x 5 + * y 5 - y 5 - * y 5 + * y 5 + * + x * y *"
            };
        ll idx;
        if (a[0] == 'Y') {
            idx += 4;
        }
        if (b[0] == 'Y') {
            idx += 2;
        }
        if (c[0] == 'Y') {
            idx += 1;
        }
        cout << ans[idx];
    }

};
 
signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll TEST_COUNT = 1;
    // cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}