#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long double ld;
typedef complex<double> cld;

const int inf = 1e18;
const ld eps = 1e-9;
const ld pi = atan2(0, -1);
const int mod = 1e9+7;

/// Code  part ///

struct Solver {
    Solver() {

    }

    int stupid(int n) {
        vector<int> a;
        for(int i = 1; i < n; ++i) {
            if(__gcd(i, n) == 1) {
                a.push_back(i);
            }
        }

        if(a.size() % 2)
            return a[a.size()/2];
        else
            return a[a.size()/2 - 1];
    }

    int smart(int n) {
        int k = n/2;
        while(__gcd(k, n) != 1) k--;
        return k;
    }
    
    void solve() {
        int n;
        cin >> n;
        cout << smart(n) << "\n";
    }
};

/// Code part ///
int file_io = 0, debug = 0;

int32_t main() {
    file_io = 1;

    // if(file_io) freopen("inp.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int tests = (debug ? 1000 : 1);
    cin >> tests;

    for(int test = 0; test < tests; ++test) {
        if(!debug) {
            /// Main part ///

            Solver solver;
            solver.solve();

            /// Main part ///
        } else {}
    }

    return 0;
}

/**

*/
