#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <stack>
#include <cmath>
#include <complex>
#include <queue>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <cstdio>

#define ll long long
#define ld long double
#define pll pair<ll,ll>
#define pii pair<ll,ll>
#define X first
#define Y second
#define int ll

using namespace std;

vector<set<int>> mn(30);

int gcd(int a, int b) {
    if (a < b)
        swap(a,b);
    while (b) {
        a %= b;
        swap(a,b);
    }
    return a;
}

int phi (int fixed) {
    int result = fixed;
    for (int i = 0; i < mn.size(); i++) {
        for (ll item : mn[i]) {
            if (!(i % 2))
                result -= fixed/item;
            else
                result += fixed/item;
        }
    }
    return result;
}

void brute(int n) {
    int cur = 0;
    for (int i = 1; i <= n; i++) {
        if (gcd(i, n) == 1) {
            cur++;
            cout << cur << " " << i << " " << phi(i) << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    map<string, int> ans;
    map<string, bool> used;
    vector<vector<pair<string, int>>> tab(n);
    vector<int> ptrs(n);
    int mm = 0;
    int szs = 0;
    for (int i = 0; i < n; i++) {
        int sz;
        cin >> sz;
        ptrs[i] = sz - 1;
        szs += sz;
        mm = max(sz, mm);
        for (int j = 0; j < sz;j++) {
            string s;
            cin >> s;
            int t = 0;
            for (; t < s.size(); t++) {
                if (s[t] == '=')
                    break;
            }
            tab[i].push_back({s.substr(0, t), stoi(s.substr(t + 1))});
        }
    }
    int k;
    cin >> k;
    for (int i = 0; i < k; i++) {
        string s;
        cin >> s;
        int val;
        cin >> val;
        ans[s] = val;
    }
    vector<int> ans2(szs--);
    bool fl = 1;
    while (fl) {
        fl = 0;
        for (int i = 0; i < n; i++) {
            if (ptrs[i] >= 0 && ans[tab[i][ptrs[i]].X] == tab[i][ptrs[i]].Y) {
                ans2[szs--] = i + 1;
                used[tab[i][ptrs[i]].X] = true;
                ptrs[i]--;
                fl = 1;
                continue;
            }
            if (ptrs[i] >= 0 && used[tab[i][ptrs[i]].X]) {
                ans2[szs--] = i + 1;
                ptrs[i]--;
                fl = 1;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (ptrs[i] != -1) {
            cout << "No" << endl;
            return 0;
        }
    }
    cout << "Yes" << endl;
    for (int i = 0; i < ans2.size(); i++) {
        cout << ans2[i] << " ";
    }
    cout << endl;
}