#include <bits/stdc++.h>
using namespace std;


void run() {
    int number_threads;
    cin >> number_threads;
    vector<vector<pair<string, int>>> threads(number_threads);
    int check_sum = 0;
    for (auto &thread : threads) {
        int cnt;
        cin >> cnt;
        for (int i = 0; i < cnt; i++, check_sum++) {
            string s;
            cin >> s;
            string name = s.substr(0, s.find('='));
            string value_str = s.substr(s.find('=') + 1);
            int value = stoi(value_str);
            thread.emplace_back(name, value);
        }
    }
    int number_vars;
    cin >> number_vars;
    map<string, int> final_variables;
    for (int i = 0; i < number_vars; i++) {
        string name;
        cin >> name;
        int value;
        cin >> value;
        final_variables[name] = value;
    }


    vector<int> answer;
    map<string, bool> can_modify;

    bool flag = false;
    do {
        flag = false;
        for (int i = 0; i < threads.size(); i++) {
            auto &thread = threads[i];
            if (thread.empty()) {
                continue;
            }
            auto last = thread.back();
            if (can_modify[last.first] || last.second == final_variables[last.first]) {
                can_modify[last.first] = true;
                thread.pop_back();
                answer.push_back(i);
                flag = true;
            }
        }
    } while (flag);

    if (answer.size() == check_sum) {
        cout << "Yes\n";
        reverse(answer.begin(), answer.end());
        for (int i : answer) {
            cout << i + 1 << " ";
        }
    } else {
        cout << "No\n";
    }

}

signed main() {
#ifdef LOCAL
    freopen("data", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(16);
    run();
    return 0;
}