#include <bits/stdc++.h>
using namespace std;

#define FASTIO

// #define FILEINPUT
// #define FILEOUTPUT

// #define MULTITEST

#define int long long

const int inf = 2e9 + 5;
const int mod = 1e9 + 7;
const double eps = 1e-12;

struct node{
	map<char, node*> children;
	node *parent;
	int sz = 0;
	string deb = "";
	int kek = 0;
};

node startNode;

bool isGo(node *cur, char c){
	return cur -> children.count(c);
}

void go(node *&cur, char c){
	cur = cur -> children[c];
}

void addNode(node *cur, char c){
	cur -> children[c] = new node;
	cur -> children[c] -> parent = cur;
}

void addWord(string s){

	node *cur = &startNode;

	string deb = "";

	for (char c : s){
		deb += c;
		cur -> sz++;
		cur -> kek++;
		if (!isGo(cur, c)){
			addNode(cur, c);
		}
		go(cur, c);
		cur -> deb = deb;
	}

	cur -> sz++;
	cur -> kek++;

}

int ans = 0;
int k;

int dfs(node *cur){
	// cout << cur -> deb << '\n';
	if (cur -> sz <= k){
		return cur -> sz;
	}

	vector<int> kek;

	for (auto e : cur -> children){
		kek.push_back(dfs(e.second));
		cur -> sz -= e.second -> kek - e.second -> sz;
	}

	sort(kek.begin(), kek.end());

	// cout << cur -> deb << ' ';
	// for (int e : kek ){
	// 	cout << e << ' ';
	// }
	// cout << '\n';

	int i = kek.size() - 1;

	while(cur -> sz > k){
		// cout << cur -> deb << ' ' << kek[i] << '\n';
		ans++;
		cur -> sz -= kek[i--];
	}

	return cur -> sz;
}

void solve(int numTest = 1, int cntTests = 1){

	int n;
	cin >> n >> k;

	for (int i = 0; i < n; i++){
		string s;
		cin >> s;
		addWord(s);
	}

	dfs(&startNode);

	cout << ans + 1;

}

signed main(){

	srand(time(NULL));
	cout << setprecision(10) << fixed;

	#ifdef FASTIO
		ios_base::sync_with_stdio(NULL);
		cin.tie(NULL);
		cout.tie(NULL);
	#endif

	#ifdef FILEINPUT
		freopen("main.in", "r", stdin);
	#endif
	#ifdef FILEOUTPUT
		freopen("main.out", "w", stdout);
	#endif

	#ifdef MULTITEST
		int cntTests;
		cin >> cntTests;
		for (int numTest = 1; numTest <= cntTests; numTest++){
			solve(numTest, cntTests);
			cout << '\n';
		}
	#else
		solve();
	#endif

}