#include <iostream>
#include <set>
#include <vector>
#include <unordered_map>

using namespace std;

int n, k;


struct vertex {
    vector<int> next = vector<int>(26, -1);
    bool flag = false;
    int d = 0;
    int virtual_d = 0;
    int par = -1;
};
vector<vertex> all;
set<pair<int, int>> candidates;


auto add_string(const string &s) {
    int v = 0;
    for (char i: s) {
        int x = i - 'a';
        if (all[v].next[x] == -1) {
            all.emplace_back(vertex());
            all[v].next[x] = int(all.size()) - 1;
            all[all.size() - 1].par = v;
        }
        v = all[v].next[x];
    }
    all[v].flag = true;


}

void dfs(int v) {
    if (all[v].flag) {
        all[v].d = 1;
    }
    for (int i = 0; i < 26; i++) {
        if (all[v].next[i] != -1) {
            dfs(all[v].next[i]);
            all[v].d += all[all[v].next[i]].d;
        }
    }
    all[v].virtual_d = all[v].d;

}

void dfs3(int v){

        for (int i = 0;i < 26;i++) {
            if (all[v].next[i] != -1) {
                dfs3(all[v].next[i]);

            }
        }
    if (all[v].d <= k && (all[v].par == -1 || all[all[v].par].d > k)) {
        candidates.insert({all[v].d, v});
    }

};


void dfs2(int v) {
    for (int i = 0; i < 26; i++) {
        if (all[v].next[i] != -1) {
            dfs2(all[v].next[i]);
            all[v].next[i] = -1;
        }
    }
    candidates.erase({all[v].virtual_d, v});

}


int main() {
    cin >> n >> k;
    all.emplace_back(vertex());
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;

        add_string(s);

    }
    int cnt = 0;
    dfs(0);
    dfs3(0);
    /*for (auto x: candidates) {
        cout << x.first << " " << x.second << endl;
    }*/

    while(!candidates.empty()) {
        auto candidate = candidates.rbegin();
        int num = candidate->first;
        int v = candidate->second;
        cnt++;
        //cout << v;
        int high = v;

        if (all[v].par != -1) {
            all[all[v].par].virtual_d -= all[v].virtual_d;
            if (all[all[v].par].virtual_d <= k) {
                high = all[v].par;
            }
            else {
                high = -1;
            }
        }
        else {
            high = -1;
        }
       // cout << high;
        while (high != -1 && all[high].par != - 1 && all[all[high].par].virtual_d - (all[high].d - all[high].virtual_d) <= k) {
            all[all[high].par].virtual_d -= (all[high].d - all[high].virtual_d);
            high = all[high].par;
        }
        if (high != -1 && all[high].par != -1) {
            all[all[high].par].virtual_d -= all[high].d - all[high].virtual_d; }
       // cout << high;
        candidates.erase(*candidate);
        if (high != -1) {
            dfs2(high);
            candidates.insert({all[high].d - num, high});
            //cout << all[high].d - num << " " << high << endl;
        }
      //  cout << candidates.size();

    }
    cout << cnt;

}
