#include <iostream>
#include <fstream>
#include <chrono>
#include <algorithm>
#include <numeric>
#include <map>
#include <set>
#include <vector>
#include <map>
#include <cmath>
#include <queue>
#include <cstring>
#include <functional>
#include <unordered_map>

int main() {
#ifdef local
std::freopen("in", "r", stdin);
std::freopen("out", "w", stdout);
#endif
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);

    int n, m;
    std::cin >> n >> m;
    int a, b;
    long long w;
    std::vector<std::vector<std::pair<int, long long>>> g(n);
    for (int i = 0; i < m; ++i) {
        std::cin >> a >> b >> w;
        g[--a].push_back({--b, w});
        g[b].push_back({a, w});
    }
    std::vector<long long> d(n, 1e17);
    d[0] = 0;
    std::priority_queue<std::pair<long long, int>> q;
    q.push({0, 0});
    std::vector<bool> used(n);
    std::vector<std::pair<long long, long long>> minmax(n, {-1, -1});
    std::vector<int> p(n, -1);
    while (true) {
        while (q.size() && used[q.top().second])
            q.pop();
        if (q.size() == 0)
            break;
        int v = q.top().second;
        used[v] = true;
        q.pop();
        for (auto [to, w] : g[v]) {
            if (d[v] + 1 < d[to]) {
                d[to] = d[v] + 1;
                q.push({-d[to], to});
                p[to] = v;
                minmax[to] = {std::min(minmax[v].first, w), std::max(minmax[v].second, w)};
                if (minmax[to].first == -1)
                    minmax[to].first = w;
            } else if (d[v] + 1 == d[to]) {
                std::pair<long long, long long> newmm = {std::min(minmax[v].first, w), std::max(minmax[v].second, w)};
                if (newmm.second - newmm.first > minmax[to].second - minmax[to].first) {
                    minmax[to] = newmm;
                    p[to] = v;
                }
            }
        }
    }
    std::vector<int> ans;
    int cur = n - 1;
    while (cur != -1) {
        ans.push_back(cur);
        cur = p[cur];
    }
    std::cout << ans.size() - 1 << '\n';
    for (int i = ans.size() - 1; i >= 0; --i)
        std::cout << ans[i] + 1 << ' ';
}