﻿#define _CRT_SECURE_NO_WARNINGS
#define pb(e) push_back(e);
#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const int MAXN = 300000;

vector<pair<ll,ll>> g[MAXN];

vector< pair<pair<ll, ll> ,ll > > edges;


int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll n, m,l,r,c;

    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        cin >> l >> r >> c;
        edges.push_back({ {l,r},c });
        g[l].push_back({ r,c } );
        g[r].push_back({ l,c });
    }

    map<ll, ll> minleft, maxleft,
        minright, maxright
        , dleft, dright
        , lminpath,lmaxpath,rmaxpath, rminpath
        ,usedl,usedr;

    for (int i = 2; i < n; i++) {
        dleft[i] = dright[i] = INT_MAX;
    }
    dleft[n] = INT_MAX;
    dright[1] = INT_MAX;


    for (int i = 1; i <= n; i++) {
        minleft[i] = INT_MAX;
        minright[i] = INT_MAX;
    }
    queue<ll> q;
    q.push(1);




    while (q.size()) {
        ll v = q.front();
        usedl[v] = 1;
        q.pop();
        for (auto w : g[v]) {
            if (dleft[v] + 1 <= dleft[w.first]) {
                dleft[w.first] = dleft[v] + 1;
                if (minleft[w.first] >= min(minleft[v], w.second)) {
                    minleft[w.first] = min(minleft[v], w.second);
                    lminpath[w.first] = v;
                }
                if (maxleft[w.first] <= max(maxleft[v], w.second)) {
                    maxleft[w.first] = max(maxleft[v], w.second);
                    lmaxpath[w.first] = v;
                }
            }
            if (!usedl[w.first])q.push(w.first);
        }
        
    }
    
    q.push(n);

    while (q.size()) {
        ll v = q.front();
        usedr[v] = 1;
        q.pop();
        for (auto w : g[v]) {
            if (dright[v] + 1 <= dright[w.first]) {

                dright[w.first] = dright[v] + 1;

                if (minright[w.first] >= min(minright[v], w.second)) {
                    minright[w.first] = min(minright[v], w.second);
                    rminpath[w.first] = v;
                }
                if (maxright[w.first] <= max(maxright[v], w.second)) {
                    maxright[w.first] = max(maxright[v], w.second);
                    rmaxpath[w.first] = v;
                }
            }
            if (!usedr[w.first])q.push(w.first);
        }
    }
    
    ll delta = 0, minlen = INT_MAX;
   

    pair<ll, ll> ans;


    for (auto e : edges) {
        l = e.first.first;
        r = e.first.second;
        c = e.second;

        if (dleft[l] + dright[r] + 1 <= minlen) {
            //cout << l << ' ' << r << " ok\n";
            ll mn = min(c, min(minleft[l], minright[r]) );
            ll mx = max(c, max(maxleft[l], maxright[r]) );
            if (abs(mx - mn) >= delta) {
                delta = abs(mx - mn);
                ans = { l,r };
            }
            minlen = dleft[l] + dright[r] + 1;
        }

        swap(l, r);
        if (dleft[l] + dright[r] + 1 <= minlen) {
            //cout<<
           // cout << l << ' ' << r << " ok\n";
            ll mn = min(c, min(minleft[l], minright[r]));
            ll mx = max(c, max(maxleft[l], maxright[r]));
            if (abs(mx - mn) >= delta) {
                delta = abs(mx - mn);
                ans = { l,r };
            }
            minlen = dleft[l] + dright[r] + 1;
        }
    }
   
    vector<ll> pl,pr;

    l = ans.first; r = ans.second;

    ll f = 20;

    rmaxpath[n] = rminpath[n] = n;
    lmaxpath[1] = lminpath[1] = 0;

    //cout << l << ' ' << r << '\n';

    for (int i = l; i > 1;) {
        pl.push_back(i);
        i = lminpath[i];
        
    }
 
   for (int i = r; i < n;) {
        pr.push_back(i);
        i = rmaxpath[i];
     
    }

   cout << 1 + pl.size() + pr.size() << '\n';
    cout << 1 << ' ';
    for (int i = pl.size() - 1; i >= 0; i--)cout << pl[i] << ' ';
    for (int i = 0; i < pr.size(); i++)cout << pr[i] << ' ';
    cout << n;
}