﻿#define _CRT_SECURE_NO_WARNINGS
#define pb(e) push_back(e);
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#include <unordered_map>
typedef long long ll;
using namespace std;
const int MAXN = 100001;

vector<pair<int, int>> g[2*MAXN];

vector< pair<pair<int, int>, int > > edges;

int minleft[MAXN], maxleft[MAXN],
minright[MAXN], maxright[MAXN]
, dleft[MAXN], dright[MAXN]
, lminpath[MAXN], lmaxpath[MAXN], rmaxpath[MAXN], rminpath[MAXN]
, usedl[MAXN], usedr[MAXN];

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, l, r, c;

    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        cin >> l >> r >> c;
        edges.push_back({ {l,r},c });
        g[l].push_back({ r,c });
        g[r].push_back({ l,c });
    }

    

    for (int i = 1; i <= n; i++) {
        dleft[i] = dright[i] = 2000000000;
    }
    dleft[1] = 0;
    dright[n] = 0;


    for (int i = 1; i <= n; i++) {
        minleft[i] = 2000000000;
        minright[i] = 2000000000;
    }
    queue<int> q;
    q.push(1);
    q.push(n);

    unordered_map<int, int> delta;
    int minlen = 2000000000;


    unordered_map<int, pair<int, int>> ans;


    while (q.size()) {
        int v = q.front();
        usedl[v] = 1;
        q.pop();
        for (auto w : g[v]) {
            if (usedl[w.first])continue;
            if (dleft[v] + 1 <= dleft[w.first]) {

                dleft[w.first] = dleft[v] + 1;
                if (minleft[w.first] >= min(minleft[v], w.second)) {
                    minleft[w.first] = min(minleft[v], w.second);
                    lminpath[w.first] = v;
                }
                if (maxleft[w.first] <= max(maxleft[v], w.second)) {
                    maxleft[w.first] = max(maxleft[v], w.second);
                    lmaxpath[w.first] = v;
                }
            }
            if (!usedl[w.first])q.push(w.first);
        }
    }

    q.push(n);

    while (q.size()) {
        int v = q.front();
        usedr[v] = 1;
        q.pop();
        for (auto w : g[v]) {
            if (usedr[w.first])continue;
            if (dright[v] + 1 <= dright[w.first]) {

                dright[w.first] = dright[v] + 1;

                if (minright[w.first] >= min(minright[v], w.second)) {
                    minright[w.first] = min(minright[v], w.second);
                    rminpath[w.first] = v;


                }
                if (maxright[w.first] <= max(maxright[v], w.second)) {
                    maxright[w.first] = max(maxright[v], w.second);
                    rmaxpath[w.first] = v;
                }
            }
            if (!usedr[w.first])q.push(w.first);

            l = v;
            r = w.first;
            c = w.second;
            
             if (dleft[l] + dright[r] + 1 <= minlen) {
                  minlen = dleft[l] + dright[r] + 1;
                  //cout << l << ' ' << r << " ok\n";
                  int mn = min(c, min(minleft[l], minright[r]));
                 int mx = max(c, max(maxleft[l], maxright[r]));
                 if (abs(mx - mn) >= delta[minlen]) {
                    delta[minlen] = abs(mx - mn);
                   ans[minlen] = { l,r };
                }
                 //cout << mn << ' ' << mx << ' ' << minlen << ' ' << delta[minlen] << '\n';
             }
                swap(l, r);
                if (dleft[l] + dright[r] + 1 <= minlen) {
             
                 minlen = dleft[l] + dright[r] + 1;
                //  cout << l << ' ' << r << " ok\n";
                      int mn = min(c, min(minleft[l], minright[r]));
                      int mx = max(c, max(maxleft[l], maxright[r]));
                      if (abs(mx - mn) >= delta[minlen]) {
                          delta[minlen] = abs(mx - mn);
                          ans[minlen] = { l,r };
                     
                      //cout << mn << ' ' << mx << ' ' << minlen << ' ' << delta[minlen] << '\n';
                  }
                minlen = dleft[l] + dright[r] + 1;
            }
            

        }
    }
    vector<int> pl, pr;

    l = ans[minlen].first; r = ans[minlen].second;

    rmaxpath[n] = rminpath[n] = n;
    lmaxpath[1] = lminpath[1] = 0;

    //cout << l << ' ' << r << '\n';
   // cout << minlen << ' ' << dleft[l] << ' ' << dright[r] << '\n';
    ll f = 20;
    for (int i = l; i > 1 && f;) {
        pl.push_back(i);
        i = lminpath[i];
        f--;
    }
    f = 20;
    for (int i = r; i < n && f;) {
        pr.push_back(i);
        i = rmaxpath[i];
        f--;
    }

    cout << 1 + pl.size() + pr.size() << '\n';
    cout << 1 << ' ';
    for (int i = pl.size() - 1; i >= 0; i--)cout << pl[i] << ' ';
    for (int i = 0; i < pr.size(); i++)cout << pr[i] << ' ';
    cout << n;
}