#include <iostream>
#include <math.h>

using namespace std;

int gcd(int a, int b) {
    if (!b) 
        return a;
    
    return gcd(b, a % b);
}

int euler(int n) {
    int amount = n;

    for (int i = 2; i * i <= n; ++i) {
        if (n % i == 0) {
            while (n % i == 0) {
                n /= i;
            }

            amount -= amount / i;
        }
    }

    if (n > 1) {
        amount -= amount / n;
    }

    return amount;
}

int main() {
    // ...
    ios::sync_with_stdio(false);
    unsigned long long k;
    cin >> k;

    while (k--) {
        int n;
        cin >> n;

        int j = 1;
        int b = 0;
        int m = euler(n);

        m = (m % 2 == 0 ? m / 2 : (m + 1) / 2);

        for (; b < m; j++) {
            if (gcd(n, j) == 1) {
                b++;
            }
        }

        cout << j-1 << '\n';
    }

    return 0;
}