#include<bits/stdc++.h>

using namespace std;

#define all(d) d.begin(), d.end()

using vint = vector < int >;
using vvint = vector < vint >;
using vpint = vector < pair < int, int > >;
using ll = long long;
const int INF = 1e9 + 7;

using niyqueue = priority_queue < pair < int, int > , vector < pair < int, int > >, greater < pair < int, int > > >;

struct pt{
    double x, y;
};

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector < vector < char > > v(n + 1, vector < char > (m + 1));

    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            cin >> v[i][j];
        }
    }

    ll f = 0, q = 0;

    for(int i = n - 1; i >= 0; i--){
        for(int j = m - 1; j >= 0; j--){
            if(v[i][j] == '#'){
                v[i][j] = '.';
                if(v[i - 2][j + 1] == '#'){
                    f++;
                    v[i - 1][j] = '.';
                    v[i - 2][j] = '.';
                    v[i - 3][j] = '.';
                    v[i - 4][j] = '.';
                    v[i - 2][j + 1] = '.';
                    v[i - 4][j + 1] = '.';
                    v[i - 4][j + 2] = '.';
                }else{
                    q++;
                    v[i - 1][j] = '.';
                    v[i - 2][j] = '.';
                    v[i - 3][j] = '.';
                    v[i - 4][j] = '.';
                    v[i - 2][j - 1] = '.';
                    v[i - 2][j - 2] = '.';
                    v[i - 3][j - 2] = '.';
                    v[i - 4][j - 1] = '.';
                    v[i - 4][j - 2] = '.';
                }
            }
        }
    }
    cout << q << " " << f;

    return 0;
}

/*

11 7
###....
#.###..
###....
#.#####
#.#.#.#
..#.###
..###.#
..#.#.#
..###..
....#..
....#..
    *. *****. *****. *****. *****. *   *. *****.     *. *****. *****. *****. *****.
   **.     *.     *. *   *.    * . *   *. *    .    * .    * . *   *. *   *. *   *.
  * *.     *.     *. *   *.   *  . *   *. *    .   *  .   *  . *   *. *   *. *   *.
 *  *.     *.     *. *   *.  *   . *   *. *    .  *   .  *   . *   *. *   *. *   *.
*   *.     *.     *. *****. *****. *****. *****. *****. *    . *****. *****. *   *.
    *.    * .    * . *   *.    * .     *.     *. *   *. *    . *   *.    * . *   *.
    *.   *  .   *  . *   *.   *  .     *.     *. *   *. *    . *   *.   *  . *   *.
    *.  *   .  *   . *   *.  *   .     *.     *. *   *. *    . *   *.  *   . *   *.
    *. *****. *****. *****. *    .     *. *****. *****. *    . *****. *    . *****.
  */
