﻿// Task.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
//#include <unordered_map>
//#include <map>
//#include <set>
#include <queue>
//#include <deque>
//#include <stack>
#include <list>
using namespace std;
/*const int K = 26;

struct Vertex {
    Vertex* to[K]={0};
    bool terminal = false;
    long long count = 0;
};
Vertex* root = new Vertex();
void add_string(string& s) {
    Vertex* v = root;
    for (char c : s) {
        c -= 'a'; // получаем число от 0 до 25
        if (!v->to[c]) {
            v->to[c] = new Vertex();
        }
        v = v->to[c];
        v->count++;
    }
    v->terminal = true;
}
void erase(string& s) {
    Vertex* v = root;
    for (char c : s) {
        v = v->to[c - 'a'];
        v->count--;
    }   
    v->terminal = false;
}
int Count_of_operations = 0;
int RM(Vertex* v, int k) {
    int count_to_rm = v->count;
    if (count_to_rm > k)
    {
        count_to_rm = 0;
        for (int i = 0; i < 26; i++) {
            if (v->to[i]) {
                if(v->to[i]->count)
                    count_to_rm = max(count_to_rm, RM(v->to[i], k));
            }
        }
    }
    else {
        v->count = 0;
        Count_of_operations++;
        return count_to_rm;
    }

}*/
struct min_max_pred_d {
    int min;
    int max;
    int pred;
    int d;
    min_max_pred_d() : min(1000000001), max(0), pred(-1), d(1000000001) {};
};
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, u, v, c;
    cin >> n >> m;
    vector<list<pair<int, int>>> g(n);
    vector<bool> used(n, false);
    vector<min_max_pred_d> p(n);
    queue<int> q;
    for (int i = 0; i < m; i++) {
        cin >> u >> v >> c;
        g[u - 1].push_back(pair<int, int>(v - 1, c));
        g[v - 1].push_back(pair<int, int>(u - 1, c));
    }
    q.push(0);
    used[0] = true;
    p[0] = min_max_pred_d{1000000001,0, -1, 0};
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto it = g[v].begin(); it != g[v].end(); it++) {
            int to = it->first;
            if (!used[to]) {
                used[to] = true;
                q.push(to);
                p[to] = min_max_pred_d{min(p[v].min, it->second), max(p[v].max, it->second), v, p[v].d + 1};
            }
            else if(p[to].d == p[v].d + 1) {
                if(max(p[v].max, it->second) - min(p[v].min, it->second) > p[to].max - p[to].min)
                    p[to] = min_max_pred_d{ min(p[v].min, it->second), max(p[v].max, it->second), v, p[v].d + 1 };
            }
        }
    }
    vector<int> path;
    path.reserve(n);
    for (int i = n - 1; i != -1; i = p[i].pred) {
        path.push_back(i);
    }
    reverse(path.begin(), path.end());
    cout << p[n - 1].d << endl;
    for (int i = 0; i < path.size(); i++)
        cout << path[i]+1 << ' ';
    return 0;
}
