#include <iostream>
#include <string>
#include <cmath>
#include <algorithm>
#include <numeric>

#define ll long long

using namespace std;

ll phi(ll n) {
    ll result = n;
    for (ll i = 2; i * i <= n; i++) {
        if (n % i == 0) {
            while (n % i == 0)
                n /= i;
            result -= result / i;
        }
    }
    if (n > 1)
        result -= result / n;
    return result;
}

bool coprime(ll a, ll b) {
     
    if (gcd(a, b) == 1)
        return 1;
    else
        return 0;
}

ll eval(ll n, ll all_c){

    ll ans = 0;
    ll counter = 1;

    ll st = (n/2 - 100) > 0 ? n/2 - 100 : 1;
    ll ed = n/2 + 100;

    // for (size_t i = st; i <= ed; i++)
    // {
    //     if(coprime(n, i)){
    //         ans = i;
    //         counter++;
    //     }
    //     if(counter >= (all_c / 2)) break;
    // }
    while (true)
    {
        ll a1 = n/2;
        ll a2 = a1 - counter;
        ll a3 = a1 + counter;
        if(coprime(n, a1)){
            ans = a1;
            break;
        }
        if(coprime(n, a2)){
            ans = a2;
            break;
        }
        if(coprime(n, a3)){
            ans = a3;
            break;
        }
        counter++; 
    }
    
    return ans;
}

int main()
{
    ll n, m, res, c = 0, all_c;
    cin>>n; 
    for (size_t i = 0; i < n; i++)
    {
        cin>>m;
        // all_c = phi(m);
        res = eval(m, 1);
        cout<<res<<endl;
    }
    
}
