#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

#define fastread  ios_base::sync_with_stdio(0);cin.tie(0);
using namespace std;

int main()
{
    fastread;

    int m, n;
    char c;
    cin >> n >> m;

    vector<vector<char>> v;
    v.resize(n);

    for (int i = 0; i < n; i++)
    {
        v[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            cin >> c;
            v[i][j] = c;
        }
    }

    int q = 0;
    int f = 0;

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (v[i][j] == '#')
            {
                // Check for 'q'
                if ((n - (i + 5) >= 0) && (m - (j + 3) >= 0))
                {
                    if (v[i][j + 1] == '#' && v[i][j + 2] == '#'
                        && v[i + 1][j] == '#' && v[i + 1][j + 2] == '#'
                        && v[i + 2][j] == '#' && v[i + 2][j + 1] == '#' && v[i + 2][j + 2] == '#'
                        && v[i + 3][j + 2] == '#' && v[i + 4][j + 2] == '#'
                        && !(v[i + 4][j + 1] == '.' && v[i + 3][j + 1] == '.' && v[i + 4][j] == '#' && v[i + 3][j] == '#')
                        )
                    {
                        q++;
                        v[i][j] = '.';
                        v[i][j + 1] = '.';
                        v[i][j + 2] = '.';
                        v[i + 1][j] = '.';
                        v[i + 1][j + 2] = '.';
                        v[i + 2][j] = '.';
                        v[i + 2][j + 1] = '.';
                        v[i + 2][j + 2] = '.';
                        v[i + 3][j + 2] = '.';
                        v[i + 4][j + 2] = '.';
                    }

                }

                // Check for 'f'
                if ((n - (i + 5) >= 0) && (m - (j + 3) >= 0))
                {
                    if (v[i][j + 1] == '#' && v[i][j + 2] == '#'
                        && v[i + 1][j] == '#'
                        && v[i + 2][j] == '#' && v[i + 2][j + 1] == '#'
                        && v[i + 3][j] == '#' && v[i + 4][j] == '#')
                    {
                        f++;
                        v[i][j] = '.';
                        v[i][j + 1] = '.';
                        v[i][j + 2] = '.';
                        v[i + 1][j] = '.';
                        v[i + 2][j] = '.';
                        v[i + 2][j + 1] = '.';
                        v[i + 3][j] = '.';
                        v[i + 4][j] = '.';
                    }
                }




                cout << endl << endl;
                for (int k = 0; k < n; k++)
                {
                    for (int t = 0; t < m; t++)
                    {
                        cout << v[k][t];
                    }
                    cout << endl;
                }
                cout << endl << endl;

            }
        }
    }
    cout << q << " " << f << endl;

    return 0;
}
