#include <bits/stdc++.h>
using namespace std;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
 
// int te;
 
int Fs, Qs;

void eraseQ(vector<vector<int>> &grid, int i, int j) {
    Qs++;
    grid[i][j] = 0;
    grid[i - 1][j] = 0;
    grid[i - 2][j] = 0;
    grid[i - 2][j - 1] = 0;
    grid[i - 2][j - 2] = 0;
    grid[i - 3][j] = 0;
    grid[i - 3][j - 2] = 0;
    grid[i - 4][j] = 0;
    grid[i - 4][j - 1] = 0;
    grid[i - 4][j - 2] = 0;
}

void eraseF(vector<vector<int>> &grid, int i, int j) {
    Fs++;
    grid[i][j] = 0;
    grid[i - 1][j] = 0;
    grid[i - 2][j] = 0;
    grid[i - 2][j + 1] = 0;
    grid[i - 3][j] = 0;
    grid[i - 4][j] = 0;
    grid[i - 4][j + 1] = 0;
    grid[i - 4][j + 2] = 0;
}

void solve() {
    int n, m;
    cin >> n >> m;
    Fs = 0, Qs = 0;
    vector<vector<int>> grid(n, vector<int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char ch;
            cin >> ch;
            if (ch == '#') grid[i][j] = 1;
        }
    }
    for (int j = 0; j < m; j++) {
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            if (grid[i][j]) cnt++;
            else if (cnt == 3) {
                eraseQ(grid, i + 1, j + 2);
                cnt = 0;
            }
            if (cnt == 5) {
                eraseF(grid, i, j);
                cnt = 0;
            }
        }
    }
    cout << Qs << ' ' << Fs;
}
 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    // gen_primes();
    // gen_factorials((int)3e5 + 5);
    cout << fixed << setprecision(8);
    // cin >> t;
    // te = 0;
    while (t--){
        // te++;
        // cout << "Case #" << te << ": ";
        solve();
    }
}