package com.company;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) {

        Scanner sc = new Scanner(System.in);
        long t = sc.nextInt();
        ArrayList  list = new ArrayList();

        while (t >= 1) {
            long n = sc.nextInt();
            if (n >= 2 && n <= Math.pow(10, 18)) {

                for (int i = 1; i <= n - 1; i++) {
                    if (coPrime(i, n) == 1) {
                        list.add(i);
                    }
                }

                System.out.println(getMedian(list, list.size()));

                list.clear();
                --t;
            }
        }
    }

    public static int getMedian(ArrayList a, int size) {

        if (size % 2 == 0) {
            return (int) a.get((size / 2) - 1);
        }
        return (int) a.get(((size + 1) / 2) - 1);
    }

    public static long coPrime(long index, long currentNum) {
        if (index == 0 || currentNum == 0)
            return 0;

        if (index == currentNum)
            return index;

        if (index > currentNum)
            return coPrime(index - currentNum, currentNum);

        return coPrime(index, currentNum - index);
    }

}