﻿#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize ("O3")

#include <bits/stdc++.h>

#define int long long
#define uint unsigned int

using namespace std;

int n, k;

struct node
{
	int c = 0;
	node* to[26];
} root;

void append(string& s)
{
	node* v = &root;
	for (int i = 0; i < s.length(); i++)
	{
		if (v->to[s[i] - 'a'] == nullptr)
			v->to[s[i] - 'a'] = new node();
		v = v->to[s[i] - 'a'];
	}
	v->c++;
}

pair<int, int> dfs(node* v)
{
	int r = 0;
	vector<int> dp(26, 0);
	for (int i = 0; i < 26; i++)
	{
		pair<int, int> t = { 0 ,0 };
		if (v->to[i] != nullptr)
			t = dfs(v->to[i]);
		r += t.first;
		dp[i] = t.second;
	}

	int s = v->c;
	sort(dp.begin(), dp.end());
	for (int i = 0; i < 26; i++)
	{
		if (s + dp[i] <= k)
			s += dp[i];
		else
		{
			r += 26 - i;
			break;
		}
	}

	return { r , s };
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
//#ifndef ONLINE_JUDGE
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
//#endif
	
	cin >> n >> k;
	string s;
	for (int i = 0; i < n; i++)
	{
		cin >> s;
		append(s);
	}

	pair<int, int> ans = dfs(&root);
	if (ans.second > 0)
		ans.first++;
	cout << ans.first << '\n';

	return 0;
}