﻿#define _USE_MATH_DEFINES

#include<iostream>
#include<fstream>
#include<string>
#include<vector>
#include<utility>
#include<algorithm>
#include<climits>
#include<set>
#include<map>
#include<cmath>
#include<iomanip>
#include<iterator>
#include<queue>
#include<stack>
#include<cctype>
#include<deque>
#include<time.h>
#include<bitset>
#include<random>
#include<unordered_set>
#include<unordered_map>
#include<sstream>
#include<random>
#include<numeric>
#include <assert.h>

#pragma warning(disable : 4996)

#pragma comment(linker, "/STACK:16777216")

#define en "\n"
#define for0(i, n) for(int i = 0; i < n; i++)
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define pb push_back
#define pii pair<int, int>
#pragma warning(disable : 4996)
#define fst first
#define snd second
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;


template<typename T> void print(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(deque<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
	{
		for (int j = 0; j < a[i].size(); j++)
			cout << a[i][j];
		cout << en;
	}
}

template <typename T> void input(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(deque<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
		for (int j = 0; j < a[i].size(); j++)
			cin >> a[i][j];
}

const ll INF = 1e9 + 5;
const ll MOD = 1e9 + 7;
const int NMAX = 400;
double EPS = 1e-5;
const int MAX_LOGN = 18;

char mx[NMAX][NMAX];

vector<pii> q_c = { {0,0},{-1,0},{-2,0},{-3,0},{-4,0},{-4,-1},{-4,-2},{-3,-2},{-2,-2},{-2,-1} };
vector<pii> q_empty = { {0,-1},{0,-2},{-1,-1},{-1,-2},{-3,-1} };
vector<pii> f_c = { {0,0},{-1,0},{-2,0},{-3,0},{-4,0},{-4,1},{-4,2},{-2,1} };
vector<pii> f_empty = { {0,1},{0,2},{-1,1},{-1,2},{-2,2},{-3,1},{-3,2} };

int get(int x, int y)
{
	bool is_q = true;
	bool is_f = true;
	for (auto p : q_c)
	{
		if (mx[x + p.first][y + p.second] != '#')
			is_q &= 0;
	}

	for (auto p : q_empty)
	{
		if (mx[x + p.first][y + p.second] != '.')
			is_q &= 0;
	}

	for (auto p : f_c)
	{
		if (mx[x + p.first][y + p.second] != '#')
			is_f &= 0;
	}

	for (auto p : f_empty)
	{
		if (mx[x + p.first][y + p.second] != '.')
			is_f &= 0;
	}
	
	if (is_f)
	{
		for (auto p : f_c)
		{
			mx[x + p.first][y + p.second] = '.';
		}
		return 1;
	}
	if (is_q)
	{
		for (auto p : q_c)
		{
			mx[x + p.first][y + p.second] = '.';
		}
		return 2;
	}
	return 0;
}

void solve()
{
	int n, m; cin >> n >> m;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			cin >> mx[i][j];
		}

	}
	int q = 0;
	int f = 0;


	
	for (int i = n - 1; i >= 0; i--)
	{
		for (int j = m - 1; j >= 0; j--)
		{
			if (mx[i][j] == '#')
			{
				int t = get(i, j);
				if (t == 1)
					f++;
				else
					q++;

				
			}
		}
	}

	cout << q << " " << f << en;

	/*
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			cout << mx[i][j];
		}
		cout << en;
	}*/

}

int main() {

	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(12); //anagrams.in
	//freopen("little.in", "r", stdin);
	//freopen("little.out", "w", stdout);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}