﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Transactions;
using System.Xml.Xsl;

namespace ACM
{
    class Program
    {
        static void Main(string[] args)
        {
            var n = int.Parse(Console.ReadLine());
            var m = int.Parse(Console.ReadLine());
            var c = int.Parse(Console.ReadLine());
            (int mCount, int cCount)[] arr = Enumerable.Repeat((-1, -1), n + 1).ToArray();
            arr[0] = (0, 0);
            int mMove, cMove;
            for (int i = 0; i < n; i++)
            {
                if (arr[i].mCount >= 0)
                {
                    mMove = (i + m) < arr.Length ? (i + m) : arr.Length - (i + m - arr.Length);
                    if (mMove > 0 && mMove < arr.Length && arr[mMove].mCount < 0)
                    {
                        arr[mMove] = (mCount: arr[i].mCount + 1, cCount: arr[i].cCount);
                    }

                    cMove = (i + c) < arr.Length ? (i + c) : arr.Length - (i + c - arr.Length);
                    if (cMove > 0 && cMove < arr.Length && arr[cMove].mCount < 0)
                    {
                        arr[cMove] = (mCount: arr[i].mCount, cCount: arr[i].cCount + 1);
                    }
                }
            }

            var result = arr.Last(x => x.mCount >= 0);
            Console.WriteLine($"{result.mCount} {result.cCount}");
        }
    }
}