﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Transactions;
using System.Xml.Xsl;

namespace ACM
{
    class Program
    {
        static void Main(string[] args)
        {
            var n = int.Parse(Console.ReadLine());
            var m = int.Parse(Console.ReadLine());
            var c = int.Parse(Console.ReadLine());

            var M = -1;
            var C = -1;
            var dist = int.MaxValue;
            for (int i = 0; i <= n / m + 1; i++)
            {
                var cCount = (n - m * i) / (float)c;
                var cCountRounded = (int)Math.Round(cCount);

                var res = Math.Abs((m * i + cCountRounded * c) - n);
                if (res < dist)
                {
                    M = i;
                    C = cCountRounded;
                    dist = res;
                }
            }
            Console.WriteLine($"{M} {C}");
        }
    }
    // static void Main(string[] args)
    // {
    //     var n = int.Parse(Console.ReadLine());
    //     var m = int.Parse(Console.ReadLine());
    //     var c = int.Parse(Console.ReadLine());
    //     (int mCount, int cCount)[] arr = Enumerable.Repeat((-1, -1), n + 1).ToArray();
    //     arr[0] = (0, 0);
    //     int mMove, cMove;
    //     for (int i = 0; i < n; i++)
    //     {
    //         if (arr[i].mCount >= 0)
    //         {
    //             mMove = (i + m) < n ? (i + m) : n - (i + m - n);
    //             if (mMove > i && mMove > 0 && mMove < arr.Length && arr[mMove].mCount < 0)
    //                 arr[mMove] = (mCount: arr[i].mCount + 1, cCount: arr[i].cCount);
    //
    //             cMove = (i + c) < n ? (i + c) : n - (i + c - n);
    //             if (cMove > i && cMove > 0 && cMove < arr.Length && arr[cMove].mCount < 0)
    //                 arr[cMove] = (mCount: arr[i].mCount, cCount: arr[i].cCount + 1);
    //
    //             if (mMove == n || cMove == n)
    //                 break;
    //         }
    //     }
    //
    //     var result = arr.Last(x => x.mCount >= 0);
    //     Console.WriteLine($"{result.mCount} {result.cCount}");
    // }
}