from sys import stdin, setrecursionlimit
from collections import deque


def dfs(v, path, visited, min_val, max_val):
    global best_path, best_val
    if len(path) == max_l:
        if v == n:
            if max_val-min_val > best_val:
                best_path = path
                best_val = max_val-min_val
        return
    for u in g[v]:
        u_v, u_c = u
        if u_v not in visited:
            dfs(u_v, path+[u_v], visited | {v}, min(min_val, u_c), max(max_val, u_c))


def solve():
    dfs(1, [], set(), float('inf'), -1)
    print(len(best_path))
    print(' '.join(str(s) for s in ([1]+best_path)))


if __name__ == '__main__':
    setrecursionlimit(300005)
    g = {}
    n, m = [int(s) for s in stdin.readline().split()]

    for i in range(m):
        v, u, c = [int(s) for s in stdin.readline().split()]
        g[v] = g.get(v, []) + [(u, c)]
        g[u] = g.get(u, []) + [(v, c)]

    q = deque([1])
    d = [0] * (n + 1)
    used = [False] * (n + 1)

    used[1] = True

    while q:
        v = q.popleft()
        for u in g[v]:
            v_u = u[0]
            if not used[v_u]:
                q.append(v_u)
                used[v_u] = True
                d[v_u] = d[v] + 1

    max_l = d[n]
    best_path = []
    best_val = -1
    solve()
