#include <bits/stdc++.h>

using namespace std;

void solve()
{
    int t;
    cin >> t;
    vector<vector<pair<string, string>>> programs(t, vector<pair<string, string>>());
    vector<int> ptrs(t);
    int total = 0;
    for (auto i = 0; i < t; ++i)
    {
        int l;
        cin >> l;
        for (auto j = 0; j < l; ++j)
        {
            string cur;
            cin >> cur;
            int index = cur.find('=');
            programs[i].push_back(make_pair(cur.substr(0, index), cur.substr(index + 1)));
        }
        ptrs[i] = l - 1;
        total += l;
    }
    unordered_map<string, string> results;
    int k;
    cin >> k;
    for (auto i = 0; i < k; ++i)
    {
        string var, res;
        cin >> var >> res;
        results[var] = res;
    }
    unordered_set<string> used;
    vector<int> operations;
    while (operations.size() < total)
    {
        auto found = false;
        for (auto i = 0; i < t; ++i)
        {
            if (ptrs[i] < 0)
                continue;
            auto cur = programs[i][ptrs[i]];
            if (used.count(cur.first) || (results.count(cur.first) && results[cur.first] == cur.second))
            {
                operations.push_back(i + 1);
                if (!used.count(cur.first))
                    used.emplace(cur.first);
                found = true;
                ptrs[i]--;
                break;
            }
        }
        if (!found)
        {
            cout << "No" << endl;
            return;
        }
    }
    if (used.size() != results.size())
    {
        cout << "No" << endl;
        return;
    }
    reverse(operations.begin(), operations.end());
    cout << "Yes" << endl;
    for (auto i = 0; i < total; ++i)
        cout << operations[i] << " ";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    solve();

    return 0;
}
