#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
using namespace std;

char greed[305][305];
bool used[300][300];
int m,n;
int f=0, q=0;

void fu(int i,int j)
{
    if(used[i][j] != 0) return;
    if(i==n || j==m) return;
    if(greed[i+4][j] == 0 ||
       greed[i][j+2] == 0) return;
    if(greed[i][j] == '#' &&
       greed[i][j+1] == '#' &&
       greed[i][j+2] == '#' &&
       greed[i+1][j] == '#' &&
       greed[i+2][j] == '#' &&
       greed[i+2][j+1] == '#' &&
       greed[i+3][j] == '#' &&
       greed[i+4][j] == '#')
       {
            f++;
            used[i][j] = true;
            used[i][j+1] = true;
            used[i][j+2] = true;
            used[i+1][j] = true;
            used[i+2][j] = true;
            used[i+2][j+1] = true;
            used[i+3][j] = true;
            used[i+4][j] = true;
       }
}

void qu( int i, int j)
{
    if(used[i][j] != 0) return;
    if(i==n || j==m) return;
    if(greed[i+4][j] == 0 ||
       greed[i][j+2] == 0) return;
    if(greed[i][j] == '#' &&
       greed[i][j+1] == '#' &&
       greed[i][j+2] == '#' &&
       greed[i+1][j+2] == '#' &&
       greed[i+1][j] == '#' &&
       greed[i+2][j] == '#' &&
       greed[i+2][j+1] == '#' &&
       greed[i+2][j+2] == '#' &&
       greed[i+3][j+2] == '#' &&
       greed[i+4][j+2] == '#')
       {
          if(greed[i+3][j] == '#' &&
               greed[i+4][j] == '#' &&
               greed[i+4][j+1] == '#' ||
               greed[i+3][j] == '#' &&
               greed[i+4][j] == '#' &&
               greed[i+5][j] == '.' ||
               greed[i+3][j+3] != greed[i+2][j+3])
            {
               f++;
            used[i][j] = true;
            used[i][j+1] = true;
            used[i][j+2] = true;
            used[i+1][j] = true;
            used[i+2][j] = true;
            used[i+2][j+1] = true;
            used[i+3][j] = true;
            used[i+4][j] = true;
               return;
            }
            q++;
            used[i][j] = true;
            used[i][j+1] = true;
            used[i][j+2] = true;
            used[i+1][j] = true;
            used[i+1][j+2] = true;
            used[i+2][j] = true;
            used[i+2][j+1] = true;
            used[i+2][j+2] = true;
            used[i+3][j+2] = true;
            used[i+4][j+2] = true;
       }
}

/*int jopa(i, j)
{
    if(used[i][g] != 0) return;
    if(i==n || j==m) return;
    if(greed[i+4][j] == 0 ||
       greed[i][j+2] == 0) return;
    if(greed[i][j] == '#' &&
       greed[i][j+1] == '#' &&
       greed[i][j+2] == '#' &&
       greed[i+1][j+2] == '#' &&
       greed[i+1][j] == '#' &&
       greed[i+2][j] == '#' &&
       greed[i+2][j+1] == '#' &&
       greed[i+2][j+2] == '#' &&
       greed[i+3][j+2] == '#' &&
       greed[i+4][j+2] == '#')
       {
            q++;
            used[i][j] = true;
            used[i][j+1] = true;
            used[i][j+2] = true;
            used[i+1][j] = true;
            used[i+1][j+2] = true;
            used[i+2][j] = true;
            used[i+2][j+1] = true;
            used[i+2][j+2] = true;
            used[i+3][j+2] = true;
            used[i+4][j+2] = true;
       }
}*/

int main()
{
   for(int i = 0; i<305; i++)
      for(int j = 0; j<305; j++)
         greed[i][j] = 0;
      
   for(int i = 0; i<300; i++)
      for(int j = 0; j<300; j++)
         used[i][j] = false;
   
    cin>>n>>m;
    for(int i = 0; i<n; i++)
    {
        for(int j = 0; j<m; j++)
        {
            cin>>greed[i][j];
        }
    }
    for(int i = 0; i<n; i++)
    {
        for(int j = 0; j<m; j++)
        {
            qu(i, j);
            fu(i, j);
        }
    }
    cout<<q<<" "<<f;
}
