﻿using System;

namespace ICPC_11._12._21__CSharp_
{
    class Program
    {

        static void Main(string[] args)
        {
            string[] S = Console.ReadLine().Split();
            int n = Int32.Parse(S[0]);
            int m = Int32.Parse(S[1]);
            string In;

            int nF = 0, nQ = 0;

            bool[,] G = new bool[n, m];


            for (int i = 0; i < n; i++)
            {
                In = Console.ReadLine();
                for (int j = 0; j < m; j++)
                    if (In[j] == '#') G[i, j] = true;
                    else G[i, j] = false;
            }

            for (int j = 0; j < m; j++)
            {
                for (int i = n - 1; i >= 2; i--)
                {
                    if (G[i, j])
                        if (i >= 4 && checkF(G, i, j))
                        {
                            nF++;
                            ClearF(G, i, j);
                        }
                        else
                        {
                            nQ++;
                            ClearQ(G, i, j);
                        }
                }
            }
            Console.WriteLine(nQ + " " + nF);
        }

        static bool checkQ(bool[,] G, int i, int j)
        {
            if (G[i, j] && G[i, j + 1] && G[i, j + 2] && G[i + 1, j] && G[i + 2, j] && G[i + 2, j + 1] && G[i + 2, j + 2] && G[i + 3, j + 2] && G[i + 4, j + 2])
                return true;
            else return false;
        }

        static void ClearF(bool[,] G, int i, int j)
        {
            G[i, j] = false;
            G[i - 1, j] = false;
            G[i - 2, j] = false;
            G[i - 3, j] = false;
            G[i - 4, j] = false;
            G[i - 2, j + 1] = false;
            G[i - 4, j + 1] = false;
            G[i - 4, j + 2] = false;
        }

        static bool checkF(bool[,] G, int i, int j)
        {
            if (G[i, j] && G[i - 1, j] && G[i - 2, j] && G[i - 3, j] && G[i - 4, j] && G[i - 2, j + 1] && G[i - 4, j + 1] && G[i - 4, j + 2])
                return true;
            else return false;
        }

        static void ClearQ(bool[,] G, int i, int j)
        {
            G[i - 2, j + 2] = false;
            G[i - 1, j + 2] = false;
            G[i, j + 2] = false;
            G[i + 1, j + 2] = false;
            G[i + 2, j + 2] = false;
            G[i, j + 1] = false;
            G[i - 2, j + 1] = false;
            G[i, j] = false;
            G[i - 1, j] = false;
            G[i - 2, j] = false;
        }
    }
}
