import java.util.ArrayList;
import java.util.Comparator;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = Integer.parseInt(scanner.nextLine());
        int m = Integer.parseInt(scanner.nextLine());
        int c = Integer.parseInt(scanner.nextLine());

        ArrayList<Item> items = new ArrayList<>();

        int M = 0;
        while (true) {
            int C = getC(M, n, m, c);
            if (C < 0)
                break;
            items.add(new Item(M, C, f(M, m, C, c, n)));
            M++;
        }

        Item min = items.stream().min(Comparator.comparingInt(o -> o.result)).get();
        System.out.printf("%d %d", min.M, min.C);
    }

    private static int f(int M, int m, int C, int c, int n) {
        return Math.abs(M * m + C * c - n);
    }

    private static int getC(int M, int n, int m, int c) {
        return (n - m * M) / c;
    }

    private static class Item {
        public int M;
        public int C;
        public int result;

        public Item(int M, int C, int result) {
            this.C = C;
            this.M = M;
            this.result = result;
        }
    }
}