import java.util.*


fun main() {
    val scanner = Scanner(System.`in`)

    var median: Int

    repeat(scanner.nextInt()) {
        scanner.nextInt().let {
            median =
                it / 2
            for (i in median downTo 1) {
                if (coprime(i, it)) {
                    println(i)
                    break
                }
            }
        }
    }
}

fun gcd(a: Int, b: Int): Int {
    return if (b == 0) {
        a
    } else gcd(b, a % b)
}

fun coprime(a: Int, b: Int): Boolean {
    return (gcd(a, b) == 1)
}