#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#include <stack>

using namespace std;

typedef long long ll;
typedef long double ld;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie();
	cout.tie();

	int n, m;
	cin >> n >> m;

	vector<vector<char> > vec(n, vector<char>(m));
	int sum = 0;
	for (int i = 0; i < n; ++i)
	{
		string s;
		cin >> s;
		for (int j = 0; j < s.size(); ++j)
		{
			vec[i][j] = s[j];
			if (s[j] == '#')
				sum++;
		}
	}

	int sumq = 0;
	int sumf = 0;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			if (vec[i][j] != '.')
			{
				if (i >= 0 && i < n - 4 && j < m - 2 && vec[i][j] == '#' 
					&& vec[i + 1][j] == '#' && vec[i + 2][j] == '#'
					&& vec[i+3][j] == '#' && vec[i+4][j] == '#' && vec[i+2][j+1] == '#'
					&& vec[i][j+1] == '#' && vec[i][j+2] == '#')
				{
					sumf++;
					vec[i][j] = vec[i + 1][j] = vec[i + 2][j] = vec[i + 3][j]
						= vec[i + 4][j] = vec[i + 2][j + 1] = 
						vec[i][j+1] = vec[i][j+2] = '.';

					sum -= 8;
				}
			}
		}
	}

	sumq = sum / 10;
	cout << sumq << " " << sumf << endl;
}