def build_groups(prefix_len=1):
    groups = {}
    str_index = 0
    n_str = len(strings)
    while True:
        if str_index >= n_str:
            break
        if len(strings[str_index]) >= prefix_len:
            prefix = strings[str_index][:prefix_len]
            groups[prefix] = 1
            str_index += 1
            if str_index >= n_str:
                break
            while strings[str_index][:prefix_len] == prefix:
                if len(strings[str_index]) >= prefix_len:
                    groups[prefix] += 1
                str_index += 1
                if str_index >= n_str:
                    break
        else:
            str_index += 1

    return groups


def find_prefix():
    if len(strings) <= k:
        return '*'
    groups_list = []
    max_len = max((len(s) for s in strings))
    for prefix_len in range(1, max_len + 1):
        groups = build_groups(prefix_len)
        for key, val in groups.items():
            if val == k:
                return key
            if val < k:
                groups_list.append((val, key))
    return max(groups_list)[1]


def delete_strings(prefix):
    if prefix == '*':
        strings.clear()
        return []
    prefix_len = len(prefix)
    strings_remaining = []
    for i in range(len(strings)):
        if len(strings[i]) >= prefix_len and strings[i][:prefix_len] == prefix:
            pass
        else:
            strings_remaining.append(strings[i])
    return strings_remaining


def main_loop():
    n_rm = 0
    global strings
    while True:
        if len(strings) == 0:
            break
        n_rm += 1
        prefix = find_prefix()
        strings = delete_strings(prefix)
    return n_rm


n, k = map(int, input().split())
strings = sorted([input() for i in range(n)])
print(main_loop())
