#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <numeric>
#include <string>
#include <vector>

using namespace std;

char a[300][300];

bool check(int i, int j, int n, int m) {
	return 0 <= i && i < n && 0 <= j && j < m && a[i][j] == '#';
}

int main() {
	int n, m;
	cin >> n >> m;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}

	int c1 = 0, c2 = 0;

	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			bool f2 = true;
			f2 &= check(i, j, n, m);
			f2 &= check(i, j + 1, n, m);
			f2 &= check(i, j + 2, n, m);
			f2 &= check(i + 1, j, n, m);
			f2 &= check(i + 2, j, n, m);
			f2 &= check(i + 2, j + 1, n, m);
			f2 &= check(i + 3, j, n, m);
			f2 &= check(i + 4, j, n, m);

			c2 += f2;

			if (f2) {
				a[i][j] = '.';
				a[i][j + 1] = '.';
				a[i][j + 2] = '.';
				a[i + 1][j] = '.';
				a[i + 2][j] = '.';
				a[i + 2][j + 1] = '.';
				a[i + 3][j] = '.';
				a[i + 4][j] = '.';
			}
		}

		for (int i = 0; i < n; i++) {
			bool f1 = true;
			f1 &= check(i, j, n, m);
			f1 &= check(i, j + 1, n, m);
			f1 &= check(i, j + 2, n, m);
			f1 &= check(i + 1, j + 2, n, m);
			f1 &= check(i + 2, j + 2, n, m);
			f1 &= check(i + 2, j + 1, n, m);
			f1 &= check(i + 2, j, n, m);
			f1 &= check(i + 1, j, n, m);
			f1 &= check(i + 3, j + 2, n, m);
			f1 &= check(i + 4, j + 2, n, m);

			c1 += f1;

			if (f1) {
				a[i][j] = '.';
				a[i][j + 1] = '.';
				a[i][j + 2] = '.';
				a[i + 1][j + 2] = '.';
				a[i + 2][j + 2] = '.';
				a[i + 2][j + 1] = '.';
				a[i + 2][j] = '.';
				a[i + 1][j] = '.';
				a[i + 3][j + 2] = '.';
				a[i + 4][j + 2] = '.';
			}
		}
	}

	std::cout << c1 << " " << c2 << std::endl;

	return 0;
}
