#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#define ll long long

using namespace std;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;

	vector <string> field(n);
	vector <vector <int> > used(n, vector <int>(m));

	for (int i = 0; i < n; i++)
		cin >> field[i];

	vector <string> f_field = { "###", "#..", "##.", "#..", "#.." };
	vector <vector <int> > f_used = { {1, 1, 1}, {1, 1, 0}, {1, 1, 0}, {1, 0, 0}, {1, 0, 0} };

	vector <string> q_field = { "###", "#.#", "###", "..#", "..#" };
	vector <vector <int> > q_used = { {1, 1, 1}, {1, 1, 1}, {1, 1, 1}, {0, 0, 1}, {0, 0, 1} };

	int cnt[2] = {};

	for (int i = n - q_field.size(); i >= 0; i--)
		for (int j = 0; j + q_field[0].size() <= m; j++)
		{
			int flag = 1;

			for (int row = 0; row < q_field.size(); row++)
				for (int col = 0; col < q_field[0].size(); col++)
					if (q_used[row][col] && (used[i + row][j + col] || field[i + row][j + col] != q_field[row][col]))
						flag = 0;

			if (flag)
			{
				cnt[0] += 1;

				for (int row = 0; row < q_field.size(); row++)
					for (int col = 0; col < q_field[0].size(); col++)
						if (q_used[row][col])
							used[i+row][j+col] = 1;
			}

			flag = 1;

			for (int row = 0; row < f_field.size(); row++)
				for (int col = 0; col < f_field[0].size(); col++)
					if (f_used[row][col] && (used[i + row][j + col] || field[i + row][j + col] != f_field[row][col]))
						flag = 0;

			if (flag)
			{
				cnt[1] += 1;

				for (int row = 0; row < f_field.size(); row++)
					for (int col = 0; col < f_field[0].size(); col++)
						if (f_used[row][col])
							used[i+row][j+col] = 1;
			}
		}

	cout << cnt[0] << " " << cnt[1] << endl;
}