﻿#include <iostream>
#include <vector>

using namespace std;

long long int n, k, ans;

struct vertex {
    int sum;
    vector <vertex*> ch;
};

vertex null;

void build(string* s, int i, vertex* ver) {
    ver->sum++;

    if (i < s->size()) {
        int ind = (*s)[i] - 'a';
        if (ver->ch[ind] == NULL) {
            ver->ch[ind] = new vertex();
            ver->ch[ind]->sum = 0;
            ver->ch[ind]->ch.resize(26);
            for (int j = 0; j < 26; j++) {
                ver->ch[ind]->ch[i] = NULL;
            }
        }
        build(s, i + 1, ver->ch[ind]);
    }
}

int cut(vertex* ver) {
    int cur = ver->sum;

    while (ver->sum > k) {
        vertex* m = &null;

        m->sum = 0;

        for (int i = 0; i < 26; i++) {
            if (ver->ch[i] != NULL && m->sum < ver->ch[i]->sum) m = ver->ch[i];
        }

        if (m->sum > k) {
            ver->sum -= cut(m);
        }
        else {
            ans++;
            ver->sum -= m->sum;
            m->sum = 0;
        }
    }

    return cur - ver->sum;
}

int main()
{
    cin >> n >> k;

    null.sum = 0;
    vertex* empty = new vertex();
    empty->sum = 0;
    empty->ch.resize(26);
    for (int i = 0; i < n; i++) {
        empty->ch[i] = NULL;
    }

    for (int i = 0; i < n; i++) {
        string s;

        cin >> s;

        build(&s, 0, empty);
    }

    cut(empty);

    if (empty->sum != 0) {
        ans++;
    }

    cout << ans;
}

