#define F first
#define S second

#include <bits/stdc++.h>

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef long double ld;

using namespace std;


mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    auto starttime = chrono::steady_clock::now();
#else
    //     freopen("input.in", "r", stdin);
//     freopen("output.out", "w", stdout);
#endif
    string f[5] = {"###", "#..", "##.", "#..", "#.."};
    string q[5] = {"###", "#.#", "###", "..#", "..#"};
    int n, m;
    cin >> n >> m;
    char a[n][m];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    int fc = 0;
    int qc = 0;
    for (int j = 0; j + 2 < m; ++j) {
        for (int i = 0; i + 4 < n; ++i) {
            bool ok = 1;
            for (int u = 0; u < 5; ++u) {
                for (int v = 0; v < 3; ++v) {
                    if (f[u][v] == '#' && a[i + u][j + v] != f[u][v]) {
                        ok = 0;
                        break;
                    }
                }
            }
            if (ok) {
                ++fc;
                for (int u = 0; u < 5; ++u) {
                    for (int v = 0; v < 3; ++v) {
                        if (f[u][v] == '#') {
                            a[i + u][j + v] = '.';
                        }
                    }
                }
            }
            ok = 1;
            for (int u = 0; u < 5; ++u) {
                for (int v = 0; v < 3; ++v) {
                    if (q[u][v] == '#' && a[i + u][j + v] != q[u][v]) {
                        ok = 0;
                        break;
                    }
                }
            }
            if (ok) {
                ++qc;
                for (int u = 0; u < 5; ++u) {
                    for (int v = 0; v < 3; ++v) {
                        if (q[u][v] == '#') {
                            a[i + u][j + v] = '.';
                        }
                    }
                }
            }
        }
    }
//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < m; ++j) {
//            cerr << a[i][j];
//        }
//        cerr << '\n';
//    }
    cout << qc << ' ' << fc << '\n';
#ifdef LOCAL
    auto endtime = chrono::steady_clock::now();
    printf("\n[Finished in %.3lfs]\n", 1e-6*(ll)chrono::duration_cast
            <chrono::microseconds>(endtime-starttime).count());
#endif
    return 0;
}