//
//  main.cpp
//  olympiad
//
//  Created by Kirill Benderskii on 29.11.2021.
//

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <cstdio>
#include <cstdlib>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <algorithm>
#include <string>
#include <fstream>
#include <assert.h>
#include <list>
#include <cstring>
#include <queue>
#include <iomanip>
#include <stack>
#include <stdio.h>
#include <ctime>
#include <chrono>
#include <numeric>
using namespace std;

typedef unsigned long long ull;
typedef long long ll;
#define ever ;;
#define forn(i, k) for(int i = 0; i < k; i++)
#define forin(i,l,u) for(int (i)=(int)(l);(i)<=(int)(u);(i)++)
#define forun(i,l,u) for(int (i)=(int)(l);(i)>=(int)(u);(i)--)
#define forall(i, v) for( typeof(v.begin()) i = v.begin(); i != v.end() ; i++ )
#define vi vector < int >
#define vll vector < ll >
#define pr pair < int, int >
#define vvi vector < vector < int > >
#define vvll vector < vector < long long > >
#define ios ios_base::sync_with_stdio(0);
#define mp(i,k) make_pair(i,k)
#define all(v) v.begin(),v.end()
#define pb push_back
#define sz(v) int(v.size())
#define belongs(x, c) (find((c).begin(), (c).end(), x) != (c).end())
#define FILE__ ""
#define elif else if

const ull p1 = 131;
const ull p2 = 129;
const double eps = 1e-8;
const double pi = acos(-1.0);
const int infi = 1e9;
const ll inf = 9223372036854775807;
const ll dd = 1e3 + 7;

ll binpow(ll a, ll b,ll m) {
    a %= m;
    ll res = 1;
    while (b > 0) {
        if (b & 1)
            res = res * a % m;
        a = a * a % m;
        b >>= 1;
    }
    return res;
}

std::string toBinary(int n)
{
    std::string r;
    while (n != 0) { r = (n % 2 == 0 ? "0" : "1") + r; n /= 2; }
    return r;
}
int ans = 0;
int sum = 0;
struct node
{
    int prefix_count;
    bool isEnd;
    struct node *child[26];
}*head;

void init()
{
    head = new node();
    head->isEnd = false;
    head->prefix_count = 0;
}

void insert(string word)
{
    node *current = head;
    current->prefix_count++;
    
    for(int i = 0 ; i < word.length(); ++i)
    {
        int letter = (int)word[i] - (int)'a';    //extrct first character of word
        if(current->child[letter] == NULL)
            current->child[letter] = new node();

        current->child[letter]->prefix_count++;
        current = current->child[letter];
    }
    current->isEnd = true;
}

bool search(string word)
{
    node *current = head;
    for(int i = 0 ; i < word.length(); ++i)
    {
        int letter = (int)word[i] - (int)'a';
        if(current->child[letter] == NULL)
            return false;        //not found
        current = current->child[letter];
    }
    return current->isEnd;
}

void words_with_prefix(int k)
{
    node *current = head;
    for(int i = 0; i < 26 ; ++i)
    {
        
        if(current->child[i] == NULL)
            continue;
        else {
            if((current->child[i])->prefix_count <= k){
                ans++;
                sum -= (current->child[i])->prefix_count;
                (current->child[i])->prefix_count = 0;
            }
            current = current->child[i];
        }
    }
}

int main() {
    ios;
    cin.tie(0);
    cout.tie(0);
    //примите пожалуйста
    
#if DEBUG
    ifstream cin("input.txt");
    //    ofstream cout("output.txt");
    auto timestamp = std::chrono::system_clock::now();

#endif
    int a,b;
    cin >> a >> b;
    init();
    forn(i,a){
        string s;
        cin >> s;
        insert(s);
    }
    words_with_prefix(b);
    node *current = head;
    sum = current->prefix_count;
    if(sum){
        ans += sum/b;
    }
    cout << ans;
    //cout.close();
#if DEBUG
    cout << endl << "Time elapsed: " << chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now() - timestamp).count() << " ms" << endl;
#endif
    return 0;
}
