#include <bits/stdc++.h>
using namespace std;

const int N = (int)3e5 + 123, inf = (int)1e9 + 123;

int n, m, ans;
vector <pair <int, int> > g[N];
pair <int, int> mn[2][N], mx[2][N];
int pmn[2][N], pmx[2][N];
queue <int> q;

int main(){
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(NULL);

	cin >> n >> m;
	for(int i = 1; i <= m; ++i){
		int x, y, c;
		cin >> x >> y >> c;
		g[x].push_back(make_pair(y, c));
		g[y].push_back(make_pair(x, c));
	}

	for(int i = 1; i <= n; ++i){
		mn[0][i] = make_pair(inf, 0), mx[0][i] = make_pair(inf, 0);
	}
	mn[0][1] = make_pair(0, inf); mx[0][1] = make_pair(0, -inf);
	q.push(1);
	while(!q.empty()){
		int x = q.front();
		q.pop();
		for(int i = 0; i < (int)g[x].size(); ++i){
			int to = g[x][i].first, c = g[x][i].second;
			if(mn[0][to].first > mn[0][x].first + 1){
				pmn[0][to] = x;
				mn[0][to] = make_pair(mn[0][x].first + 1, min(mn[0][x].second, c));
				q.push(to);
			}else if(mn[0][to].first == mn[0][x].first + 1 && mn[0][to].second > min(mn[0][to].second, c)){
				pmn[0][to] = x;
				mn[0][to] = make_pair(mn[0][x].first + 1, min(mn[0][x].second, c));
			}
		}
	}
	q.push(1);
	while(!q.empty()){
		int x = q.front();
		q.pop();
		for(int i = 0; i < (int)g[x].size(); ++i){
			int to = g[x][i].first, c = g[x][i].second;
			if(mx[0][to].first > mx[0][x].first + 1){
				pmx[0][to] = x;
				mx[0][to] = make_pair(mx[0][x].first + 1, max(mx[0][x].second, c));
				q.push(to);
			}else if(mx[0][to].first == mx[0][x].first + 1 && mx[0][to].second < max(mx[0][to].second, c)){
				pmx[0][to] = x;
				mx[0][to] = make_pair(mx[0][x].first + 1, max(mx[0][x].second, c));
			}
		}
	}
	if(mn[0][n].first == 1){
		cout << 1 << endl;
		cout << 1 << " " << n;
		return 0;   
	}
	for(int i = 1; i <= n; ++i){
		mn[1][i] = make_pair(inf, 0), mx[1][i] = make_pair(inf, 0);
	}
	mn[1][n] = make_pair(0, inf); mx[1][n] = make_pair(0, -inf);
	q.push(n);
	while(!q.empty()){
		int x = q.front();
		q.pop();
		for(int i = 0; i < (int)g[x].size(); ++i){
			int to = g[x][i].first, c = g[x][i].second;
			if(mn[1][to].first > mn[1][x].first + 1){
				mn[1][to] = make_pair(mn[1][x].first + 1, min(mn[1][x].second, c));
				pmn[1][to] = x;
				q.push(to);
			}else if(mn[1][to].first == mn[1][x].first + 1 && mn[1][to].second > min(mn[1][to].second, c)){
				pmn[1][to] = x;
				mn[1][to] = make_pair(mn[1][x].first + 1, min(mn[1][x].second, c));
			}
		}
	}
	q.push(n);
	while(!q.empty()){
		int x = q.front();
		q.pop();
		for(int i = 0; i < (int)g[x].size(); ++i){
			int to = g[x][i].first, c = g[x][i].second;
			if(mx[1][to].first > mx[1][x].first + 1){
				pmx[1][to] = x;
				mx[1][to] = make_pair(mx[1][x].first + 1, max(mx[1][x].second, c));
				q.push(to);
			}else if(mx[1][to].first == mx[1][x].first + 1 && mx[1][to].second < max(mx[1][to].second, c)){
				pmx[1][to] = x;
				mx[1][to] = make_pair(mx[1][x].first + 1, max(mx[1][x].second, c));
			}
		}
	}
	
	vector <int> v;
	int dmn = mn[0][n].first;
	ans = -inf;
	for(int i = 2; i < n; ++i){
		if(mn[0][i].first + mx[1][i].first == dmn) 
			ans = max(ans, max(mx[1][i].second, mn[0][i].second) - min(mx[1][i].second, mn[0][i].second));
		if(mn[1][i].first + mx[0][i].first == dmn)
			ans = max(ans, max(mx[0][i].second, mn[1][i].second) - min(mx[0][i].second, mn[1][i].second));
	}	
	for(int i = 2; i < n; ++i){
		if(mn[0][i].first + mx[1][i].first == dmn && ans == max(mx[1][i].second, mn[0][i].second) - min(mx[1][i].second, mn[0][i].second)){
			int x = i;
			while(x){
				v.push_back(x);
				x = pmn[0][x];
			} 
			reverse(v.begin(), v.end());
			x = pmx[1][i];
			while(x){
				v.push_back(x);
				x = pmx[1][x];
			}
			break;
		}
		if(mn[1][i].first + mx[0][i].first == dmn && ans == max(mx[0][i].second, mn[1][i].second) - min(mx[0][i].second, mn[1][i].second)){
			int x = i;
			while(x){
				v.push_back(x);
				x = pmx[0][i];
			}
			reverse(v.begin(), v.end());
			x = pmn[1][i];
			while(x){
				v.push_back(x);
				x = pmn[1][x];
			}
			break;
		}
	}
	cout << v.size() - 1 << endl;
	for(int i : v)
		cout << i << " ";
	
	return 0;
}