/*
	Faster Faster Faster!!!
*/
#pragma comment(linker, "/STACK:534217728")
#pragma GCC optimize("fast-maths")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma,tune=native")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <bitset>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <climits>
#include <ctime>
#include <random>
using namespace std;

#define forx(name, from, to, value) for (int name = from; name < to; name += value)
#define rforx(name, from, to, value) for (int name = from; name > to; name -= value)
#define all(_STL_NAME) _STL_NAME.begin(), _STL_NAME.end()
#define rall(_STL_NAME) _STL_NAME.rbegin(), _STL_NAME.rend()
#define mp(_FIRST,_SECOND) make_pair(_FIRST,_SECOND)

typedef long long ll;
typedef unsigned long long llu;
typedef long double ld;
const ld eps = 1e-6;
mt19937 rndm;

void start() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(5); cout.setf(ios::fixed);
	string FILENAME = "n3v3r_g0|\|na_g1v3_u_up";
	rndm.seed(time(0));
#ifdef _DEBUG
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	//freopen((FILENAME + ".in").c_str(), "rt", stdin);
	//freopen((FILENAME + ".out").c_str(), "wt", stdout);
#endif
}

inline int FastIn() {
	int val = 0;
	char c = ' ';
	bool mns = false;
	while (!isdigit(c)) {
		mns = c == '-';
		c = _getchar_nolock(); // getchar_unlocked() in Clang
	}
	while (isdigit(c)) {
		val *= 10;
		val += c - '0';
		c = _getchar_nolock();
	}
	return (mns ? -val : val);
}

inline void FastOut(int val) {
	if (val < 0) {
		_putchar_nolock('-');
		val = -val;
	}
	bool fst = true;
	const int degree = 1000000000;
	//const ll degree = 10000000000000000ll;
	for (int i = degree; i > 0; i /= 10) {
		int dl = val / i;
		if (dl || !fst) {
			_putchar_nolock('0' + dl); // putchar_unlocked() in Clang
			fst = false;
		}
		val %= i;
	}
	if (fst)
		_putchar_nolock('0');
}

struct STnode {
	int l, r;
	STnode* lv = nullptr, * rv = nullptr;
	bool isset = 0;
	int mx = 0;
	int inc = 0;
	int wh;
	void push() {
		if (isset) {
			if (lv != nullptr) {
				lv->isset = 1;
				lv->mx = 0;
				lv->inc = 0;
			}
			if (rv != nullptr) {
				rv->isset = 1;
				rv->mx = 0;
				rv->inc = 0;
			}
		}
		if (inc) {
			if (lv != nullptr) {
				lv->inc += inc;
				lv->mx += inc;
			}
			if (rv != nullptr) {
				rv->inc += inc;
				rv->mx += inc;
			}
		}
		isset = 0;
		inc = 0;
	}
	STnode(int _l, int _r, int _val = 0) {
		l = _l;
		r = _r;
		mx = _val;
		wh = l;
	}

	pair<int, int> setzero(int tl, int tr) {
		push();
		if (r < tl || l > tr) return mp(mx, wh);
		if (l == tl && r == tr) {
			isset = 1;
			mx = 0;
			inc = 0;
			wh = l;
			return mp(mx, wh);
		}
		int mid = (l + r) >> 1;
		if (lv == nullptr)
			lv = new STnode(l, mid, mx);
		if (rv == nullptr)
			rv = new STnode(mid + 1, r, mx);
		auto lre = lv->setzero(tl, min(mid, tr));
		auto rre = rv->setzero(max(tl, mid + 1), tr);
		tie(mx, wh) = max(lre, rre);
		return max(lre, rre);
	}

	pair<int, int> incc(int tl, int tr) {
		push();
		if (r < tl || l > tr) return mp(mx, wh);
		if (l == tl && r == tr) {
			mx++;
			inc = 1;
			return mp(mx, wh);
		}
		int mid = (l + r) >> 1;
		if (lv == nullptr)
			lv = new STnode(l, mid);
		if (rv == nullptr)
			rv = new STnode(mid + 1, r);
		auto lre = lv->incc(tl, min(mid, tr));
		auto rre = rv->incc(max(tl, mid + 1), tr);
		tie(mx, wh) = max(lre, rre);
		return max(lre, rre);
	}

	pair<int, int> getmax(int tl, int tr) {
		push();
		if (tr < l || tl > r) return mp(-1, 0);
		if (l == tl && r == tr) return mp(mx, wh);
		int mid = (l + r) >> 1;
		if (lv == nullptr)
			lv = new STnode(l, mid);
		if (rv == nullptr)
			rv = new STnode(mid + 1, r);
		auto lre = lv->getmax(tl, min(mid, tr));
		auto rre = lv->getmax(max(tl, mid + 1), tr);
		return max(lre, rre);
	}
};


int main() {
	start();
	int tt, n, m;
	cin >> tt;
	while (tt--) {
		cin >> n >> m;
		STnode* root = new STnode(0, m - 1);
		vector<int>v(n);
		for (int i = 0; i < n; ++i)
			cin >> v[i];
		map<int, int> mpleft;
		map<int, int> mpright;
		for (int i = 0; i < n; ++i) {
			int d = m - (v[i] % m);
			mpleft[v[i] / m] = max(mpleft[v[i] / m], d - 1);
			if (d != m) {
				if (mpright.count(v[i] / m + 1))
					mpright[v[i] / m + 1] = min(mpright[v[i] / m + 1], d);
				else
					mpright[v[i] / m + 1] = d;
			}
		}
		set<int> used;
		for (auto i : mpleft)
			used.insert(i.first);
		for (auto i : mpright)
			used.insert(i.first);
		int last = -2;
		int ans = -1, wh = 0;
		for (auto i : used) {
			if (i != last + 1)
				root->setzero(0, m - 1);
			last = i;
			int mxL, mnR;
			if (mpleft.count(i))
				mxL = mpleft[i];
			else
				mxL = -1;
			if (mpright.count(i))
				mnR = mpright[i];
			else
				mnR = -1;
			if (mxL != -1 && mnR != -1) {
				if (mxL < mnR - 1) {
					root->setzero(mxL + 1, mnR - 1);
					root->incc(0, mxL);
					root->incc(mnR, m - 1);
				}
				else
					root->incc(0, m - 1);
			}
			else if (mxL == -1) {
				if (mnR != 0)
					root->setzero(0, mnR - 1);
				root->incc(mnR, m - 1);
			}
			else {
				if (mxL + 1 != m)
					root->setzero(mxL + 1, m - 1);
				root->incc(0, mxL);
			}

			auto kk = root->getmax(0, m - 1);
			if (kk.first > ans)
				ans = kk.first, wh = kk.second;
		}
		cout << ans << ' ' << wh << '\n';
	}
#ifdef _DEBUG
	cout << "\nTime: " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}