#pragma comment(linker, "/STACK:534217728")
//#pragma GCC optimize("fast-maths")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma,tune=native")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <bitset>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <climits>
#include <ctime>
#include <random>
using namespace std;

#define forx(name, from, to, value) for (int name = from; name < to; name += value)
#define rforx(name, from, to, value) for (int name = from; name > to; name -= value)
#define all(_STL_NAME) _STL_NAME.begin(), _STL_NAME.end()
#define rall(_STL_NAME) _STL_NAME.rbegin(), _STL_NAME.rend()
#define mp(_FIRST,_SECOND) make_pair(_FIRST,_SECOND)

typedef long long ll;
typedef unsigned long long llu;
typedef long double ld;
const ld eps = 1e-6;
mt19937 rndm;

void start() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(5); cout.setf(ios::fixed);
	string FILENAME = "n3v3r_g0|\|na_g1v3_u_up";
	rndm.seed(time(0));
#ifdef _DEBUG
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	//freopen((FILENAME + ".in").c_str(), "rt", stdin);
	//freopen((FILENAME + ".out").c_str(), "wt", stdout);
#endif
}

inline int FastIn() {
	int val = 0;
	char c = ' ';
	bool mns = false;
	while (!isdigit(c)) {
		mns = c == '-';
		c = _getchar_nolock(); // getchar_unlocked() in Clang
	}
	while (isdigit(c)) {
		val *= 10;
		val += c - '0';
		c = _getchar_nolock();
	}
	return (mns ? -val : val);
}

inline void FastOut(int val) {
	if (val < 0) {
		_putchar_nolock('-');
		val = -val;
	}
	bool fst = true;
	const int degree = 1000000000;
	//const ll degree = 10000000000000000ll;
	for (int i = degree; i > 0; i /= 10) {
		int dl = val / i;
		if (dl || !fst) {
			_putchar_nolock('0' + dl); // putchar_unlocked() in Clang
			fst = false;
		}
		val %= i;
	}
	if (fst)
		_putchar_nolock('0');
}

const int maxn = 1e5 + 500;
vector<pair<int, int>> mt[maxn];

int mn[maxn];
int mx[maxn];
int len[maxn][2];
int par[maxn][2];
int timer = 0;

void bfs(int v) {
	len[v][timer] = 1;
	queue<int> q;
	q.push(v);
	while (!q.empty()) {
		v = q.front();
		q.pop();
		for (auto [to, c] : mt[v]) {
			if (!len[to][timer]) {
				len[to][timer] = len[v][timer] + 1;
				q.push(to);
			}
			if (len[to][timer] == len[v][timer] + 1) {
				if (!timer) {
					if (mn[to] > min(mn[v], c)) {
						mn[to] = min(mn[v], c);
						par[to][timer] = v;
					}
				}
				else {
					if (mx[to] < max(mn[v], c)) {
						mx[to] = max(mn[v], c);
						par[to][timer] = v;
					}
				}
			}
		}
	}
	timer++;
}

int main() {
	start();
	fill(mn, mn + maxn, INT_MAX);
	fill(mx, mx + maxn, INT_MIN);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v, c;
		cin >> u >> v >> c;
		mt[u].emplace_back(mp(v, c));
		mt[v].emplace_back(mp(u, c));
	}
	bfs(1);
	int svlen = len[n][0];
	bfs(n);
	int mxdf1 = -1, mxdf2 = -1;
	for (int i = 2; i < n; ++i) {
		if (len[i][0] + len[i][1] - 1 == svlen)
			mxdf1 = max(mxdf1, mx[i] - mn[i]);
	}
	timer = 0;
	fill(mn, mn + maxn, INT_MAX);
	fill(mx, mx + maxn, INT_MIN);
	bfs(n);
	bfs(1);
	for (int i = 2; i < n; ++i) {
		if (len[i][0] + len[i][1] - 1 == svlen)
			mxdf2 = max(mxdf2, mx[i] - mn[i]);
	}
	timer = 0;
	fill(mn, mn + maxn, INT_MAX);
	fill(mx, mx + maxn, INT_MIN);
	if (mxdf1 < mxdf2) {
		bfs(n);
		bfs(1);
	}
	else {
		bfs(1);
		bfs(n);
	}
	int mxdf = -1, pp = 0;
	for (int i = 2; i < n; ++i) {
		if (len[i][0] + len[i][1] - 1 == svlen) {
			mxdf = max(mxdf, mx[i] - mn[i]);
			if (mxdf == mx[i] - mn[i])
				pp = i;
		}
	}
	if (mxdf == -1) {
		cout << "1\n1 " << n << '\n';
		return 0;
	}
	cout << svlen - 1 << '\n';
	vector<int> pbf;
	if (mxdf1 < mxdf2) {
		for (int p = pp; p; p = par[p][1])
			pbf.emplace_back(p);
	}
	else {
		for (int p = pp; p; p = par[p][0])
			pbf.emplace_back(p);
	}
	for (int i = (int)pbf.size() - 1; i >= 0; --i)
		cout << pbf[i] << ' ';
	if (mxdf1 < mxdf2) {
		for (int p = par[pp][0]; p; p = par[p][0])
			cout << p << ' ';
	}
	else {
		for (int p = par[pp][1]; p; p = par[p][1])
			cout << p << ' ';
	}
#ifdef _DEBUG
	cout << "\nTime: " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}