#pragma comment(linker, "/STACK:534217728")
//#pragma GCC optimize("fast-maths")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma,tune=native")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <bitset>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <climits>
#include <ctime>
#include <random>
using namespace std;

#define forx(name, from, to, value) for (int name = from; name < to; name += value)
#define rforx(name, from, to, value) for (int name = from; name > to; name -= value)
#define all(_STL_NAME) _STL_NAME.begin(), _STL_NAME.end()
#define rall(_STL_NAME) _STL_NAME.rbegin(), _STL_NAME.rend()
#define mp(_FIRST,_SECOND) make_pair(_FIRST,_SECOND)

typedef long long ll;
typedef unsigned long long llu;
typedef long double ld;
const ld eps = 1e-6;
mt19937 rndm;

void start() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(5); cout.setf(ios::fixed);
	string FILENAME = "n3v3r_g0|\|na_g1v3_u_up";
	rndm.seed(time(0));
#ifdef _DEBUG
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	//freopen((FILENAME + ".in").c_str(), "rt", stdin);
	//freopen((FILENAME + ".out").c_str(), "wt", stdout);
#endif
}

inline int FastIn() {
	int val = 0;
	char c = ' ';
	bool mns = false;
	while (!isdigit(c)) {
		mns = c == '-';
		c = _getchar_nolock(); // getchar_unlocked() in Clang
	}
	while (isdigit(c)) {
		val *= 10;
		val += c - '0';
		c = _getchar_nolock();
	}
	return (mns ? -val : val);
}

inline void FastOut(int val) {
	if (val < 0) {
		_putchar_nolock('-');
		val = -val;
	}
	bool fst = true;
	const int degree = 1000000000;
	//const ll degree = 10000000000000000ll;
	for (int i = degree; i > 0; i /= 10) {
		int dl = val / i;
		if (dl || !fst) {
			_putchar_nolock('0' + dl); // putchar_unlocked() in Clang
			fst = false;
		}
		val %= i;
	}
	if (fst)
		_putchar_nolock('0');
}

map<int, map<int, set<int>>> wht, blk;

void clear(int a, int b, int p) {
	wht[a][b].erase(p);
	blk[b][a].erase(p);
	if (wht[a][b].empty())
		wht[a].erase(b);
	if (blk[b][a].empty())
		blk[b].erase(a);
	if (wht[a].empty())
		wht.erase(a);
	if (blk[b].empty())
		blk.erase(b);
}

int main() {
	start();
	int tt;
	cin >> tt;
	while (tt--) {
		wht.clear();
		blk.clear();
		int n;
		cin >> n;

		map<int, set<int>> le;
		vector<pair<pair<int, int>, int>> e;
		vector<pair<int, int>> vl;
		vl.emplace_back(mp(0, 0));
		for (int i = 1; i <= n; ++i) {
			int w, b;
			cin >> w >> b;
			if (w + b == 1)
				le[b].insert(i);
			wht[w][b].insert(i);
			blk[b][w].insert(i);
			vl.emplace_back(mp(w, b));
		}
		while (!le.empty()) {
			int b = le.begin()->first;
			int id = *le.begin()->second.begin();
			le[b].erase(id);
			if (le[b].empty())
				le.erase(b);
			clear(!b, b, id);
			if (!b && (wht.empty() || (--wht.end())->first == 0))
				break;
			if (b && (blk.empty() || (--blk.end())->first == 0))
				break;
			int idx;
			if (!b)
				idx = *(--((--wht.end())->second.end()))->second.begin();
			else
				idx = *(--((--blk.end())->second.end()))->second.begin();
			wht[vl[idx].first][vl[idx].second].erase(idx);
			blk[vl[idx].second][vl[idx].first].erase(idx);
			clear(vl[idx].first, vl[idx].second, idx);
			e.emplace_back(mp(mp(id, idx), b));
			if (!b)
				vl[idx].first--;
			else
				vl[idx].second--;
			if (vl[idx].first + vl[idx].second == 0) {
				le[vl[idx].second].erase(idx);
				if (le[vl[idx].second].empty())
					le.erase(vl[idx].second);
			}
			else {
				if (vl[idx].first + vl[idx].second == 1)
					le[vl[idx].second].insert(idx);
				wht[vl[idx].first][vl[idx].second].insert(idx);
				blk[vl[idx].second][vl[idx].first].insert(idx);
			}
			if (!b)
				vl[id].first--;
			else
				vl[id].second--;
		}
		bool fuck = false;
		for (int i = 1; i <= n; ++i)
			if (vl[i] != mp(0, 0))
				fuck = 1;
		if (fuck || e.size() != n - 1)
			cout << "No\n";
		else {
			cout << "Yes\n";
			for (auto i : e) {
				cout << i.first.first << ' ' << i.first.second << ' ';
				if (i.second)
					cout << 'B';
				else
					cout << 'W';
				cout << '\n';
			}
		}
	}
#ifdef _DEBUG
	cout << "\nTime: " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}