import java.awt.image.AreaAveragingScaleFilter;
import java.io.*;
import java.sql.SQLOutput;
import java.util.*;

public class Main {
    static FastReader sc;
    static PrintWriter pw;

    //final static long M = 1000000007;

    public static void main(String[] args) throws Exception{
        sc = new FastReader();
        pw = new PrintWriter(System.out);

        //StringBuilder sb = new StringBuilder("");

        try{
            final String inp1 = sc.nextLine(), inp2 = sc.nextLine();
            final int year1, year2;

            if(inp1.charAt(0) == 'A') {
                year1 = Integer.parseInt(inp1.substring(3, inp1.length()));
                if(inp2.charAt(0) != 'A') {
                    year2 = Integer.parseInt(inp2.substring(0, inp2.indexOf('B') - 1));
                    pw.println(year1 + year2 - 1);
                }else{
                    year2 = Integer.parseInt(inp2.substring(3, inp2.length()));
                    pw.println(Math.abs(year1 - year2));
                }
            } else{
                year1 = Integer.parseInt(inp1.substring(0, inp1.indexOf('B') - 1));
                if(inp2.charAt(0) == 'A') {
                    year2 = Integer.parseInt(inp2.substring(3, inp2.length()));
                    pw.println(year1 + year2 - 1);
                }else{
                    year2 = Integer.parseInt(inp2.substring(0, inp2.indexOf('B') - 1));
                    pw.println(Math.abs(year1 - year2));
                }
            }



            //long endTime = System.nanoTime();
            //pw.println((endTime - startTime) / 1000000);

            }catch(Exception e){
                e.printStackTrace();
        }

        pw.close();
    }

    static class FastReader {
        BufferedReader br;
        StringTokenizer st;

        public FastReader(){
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next(){
            while (st == null || !st.hasMoreElements()) {
                try {
                    st = new StringTokenizer(br.readLine());
                }
                catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        double nextDouble(){
            return Double.parseDouble(next());
        }

        long nextLong() { return Long.parseLong(next()); }

        int[] getArray(int n) {
            int[] arr = new int[n + 1];
            for (int i = 1; i <= n; i++)
                arr[i] = nextInt();
            return arr;
        }

        long[] getLongArray(int n) {
            long[] arr = new long[n];
            for (int i = 0; i < n; i++)
                arr[i] = nextLong();
            return arr;
        }

        String nextLine() {
            String str = "";
            try {
                str = br.readLine();
            }
            catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }

    }

}