//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,sse3,sse4,popcnt,abm,mmx")

//#include <bits/stdc++.h>

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>

using namespace std;

const int N = 1e6;
const int inf = 1e9 + 7;
const int mod = 1e9 + 7;
const int INF = 1e9 + 13;
const int NN = 2e3;
const double epsilon = 1e-6;

#define sz(s) (int)(s.size())
#define all(x) x.begin(), x.end()
#define eb emplace_back
#define mkp make_pair
#define F first
#define S second
#define ll long long

void nfsmw() {
  ios_base::sync_with_stdio(false);
  cin.tie(0);
}

#define int ll

bool u[1000][1000];

char a[1000][1000];

bool checkf(int i, int j) {
  return a[i][j] == '#' and a[i + 1][j] == '#' and a[i + 2][j] == '#' and a[i + 3][j] == '#' and a[i + 4][j] == '#' and a[i][j + 1] == '#' and a[i][j + 2] == '#' and a[i + 2][j + 1] == '#'
          and !u[i][j] and !u[i + 1][j]  and !u[i + 2][j]  and !u[i + 3][j]  and !u[i + 4][j]  and !u[i][j + 1] and !u[i][j + 2] and !u[i + 2][j + 1];
}

bool checkq(int i, int j) {
  return a[i][j] == '#' and a[i][j + 1] == '#' and a[i][j + 2] == '#' and a[i + 1][j] == '#' and a[i + 1][j + 2] == '#' and a[i + 2][j] == '#' and a[i + 2][j + 1] == '#' and a[i + 2][j + 2] == '#' and a[i + 3][j + 2] == '#' and a[i + 4][j + 2] == '#'
        and !u[i][j] and !u[i][j + 1] and !u[i][j + 2] and !u[i + 1][j] and !u[i + 1][j + 2] and !u[i + 2][j] and !u[i + 2][j + 1] and !u[i + 2][j + 2] and !u[i + 3][j + 2] and !u[i + 3][j + 2] and !u[i + 4][j + 2];
}

void setq(int i, int j) {
  u[i][j]= true,u[i][j + 1]= true,u[i][j + 2]= true,u[i + 1][j]= true,u[i + 1][j + 2]= true,u[i + 2][j]= true,u[i + 2][j + 1]= true,u[i + 2][j + 2]= true,u[i + 3][j + 2] = true,u[i + 3][j + 2] = true, u[i + 4][j + 2] = true;
}

void setf(int i, int j) {
  u[i][j] = true, u[i + 1][j] = true, u[i + 2][j] = true, u[i + 3][j] = true, u[i + 4][j] = true, u[i][j + 1] = true, u[i][j + 2] = true, u[i + 2][j + 1] = true;
}

void unsetf(int i, int j) {
  u[i][j] = false, u[i + 1][j] = false, u[i + 2][j] = false, u[i + 3][j] = false, u[i + 4][j] = false, u[i][j + 1] = false, u[i][j + 2] = false, u[i + 2][j + 1] = false;
}

void unsetq(int i, int j) {
  u[i][j]= false,u[i][j + 1]= false,u[i][j + 2]= false,u[i + 1][j]= false,u[i + 1][j + 2]= false,u[i + 2][j]= false,u[i + 2][j + 1]= false,u[i + 2][j + 2]= false,u[i + 3][j + 2] = false,u[i + 3][j + 2] = false, u[i + 4][j + 2] = false;
}

int cntf, cntq;

int n, m;

int x, y;

int mx = -inf;

void rec(int i, int j) {
  if (checkf(i, j) and checkq(i, j)) {
    ++cntq;
    setq(i, j);
    if (i == n - 4 and j == m - 2) {
      if (mx < cntf + cntq) {
        mx = cntf + cntq;
        x = cntf, y = cntq;
      }
      return;
    }
    if (j == m - 2)
      rec(i + 1, 1);
    else
      rec(i, j + 1);
    --cntq;
    unsetq(i, j);

    ++cntf;
    setf(i, j);
    if (i == n - 4 and j == m - 2) {
      if (mx < cntf + cntq) {
        mx = cntf + cntq;
        x = cntf, y = cntq;
      }
      return;
    }
    if (j == m - 2)
      rec(i + 1, 1);
    else
      rec(i, j + 1);
    --cntf;
    unsetf(i, j);
  }
  if (checkf(i, j)) {
    ++cntf;
    setf(i, j);
    if (i == n - 4 and j == m - 2) {
      if (mx < cntf + cntq) {
        mx = cntf + cntq;
        x = cntf, y = cntq;
      }
      return;
    }
    if (j == m - 2)
      rec(i + 1, 1);
    else
      rec(i, j + 1);
    --cntf;
    unsetf(i, j);
  }
  if (checkq(i, j)) {
    ++cntq;
    setq(i, j);
    if (i == n - 4 and j == m - 2) {
      if (mx < cntf + cntq) {
        mx = cntf + cntq;
        x = cntf, y = cntq;
      }
      return;
    }
    if (j == m - 2)
      rec(i + 1, 1);
    else
      rec(i, j + 1);
    --cntq;
    unsetq(i, j);
  }
  if (i == n - 4 and j == m - 2) {
    if (mx < cntf + cntq) {
      mx = cntf + cntq;
      x = cntf, y = cntq;
    }
    return;
  }
  if (j == m - 2)
    rec(i + 1, 1);
  else
    rec(i, j + 1);
}

void solve() {
  cin >> n >> m;
  for (int i = 1; i <= n; ++ i)
    for (int j = 1; j <= m; ++ j)
      cin >> a[i][j];
  rec(1, 1);
  cout << y << ' ' << x << '\n';
  return;
}

#define int int

int main() {
  nfsmw();
  int tt = 1;

  while (tt--) {
    solve();
  }
  return 0;
}