import java.util.Scanner;
import java.util.Vector;

public class Median {

    static int getGcd(int a, int b)
    {
        if (a == 0 || b == 0)
            return 0;

        // base case
        if (a == b)
            return a;

        // a is greater
        if (a > b)
            return getGcd(a-b, b);

        return getGcd(a, b-a);
    }

    static boolean isCoPrime(int a, int b) {
        return getGcd(a, b) == 1;
    }

    public static void main(String[] args) {

        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();

        Vector<Integer> list = new Vector<>();

        for (int i = 1; i < n; i++) {
            if (isCoPrime(i, n)) {
                list.add(i);
            }
        }

        if (list.size() % 2 == 0) {
            System.out.println(((list.size()/2) + (list.size()/2 + 1))/2);
        } else {
            System.out.println((list.size()/2) + 1);
        }
    }
}
