#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

int n, m;
vector<pair<int, int>> g[100005];
pair<int, int> d[100005];
int pr[100005], ds[100005], mn[100005], mx[100005];

int dif(pair<int, int> x) {
	return x.second - x.first;
}

void bfs() {
	ds[1] = 0;

	queue<int> q;
	q.push(1);
	while (!q.empty()) {
		int cur = q.front();
//		cerr << cur << ' ' ;
		q.pop();

		for (auto to : g[cur]) {
			if (ds[to.first] == -1) {
				ds[to.first] = ds[cur] + 1;
				d[to.first] = d[cur];
				q.push(to.first);
			}
			if (ds[to.first] == ds[cur] + 1) {												
				if (0 > dif(d[to.first])) {
					d[to.first] = make_pair(to.second, to.second);
					pr[to.first] = cur;
				}
				if (dif(make_pair(mn[cur], to.second)) > dif(d[to.first])) {
					d[to.first] = make_pair(mn[cur], to.second);
					pr[to.first] = cur;
				}
				if (dif(make_pair(to.second, mx[cur])) > dif(d[to.first])) {
					d[to.first] = make_pair(to.second, mx[cur]);
					pr[to.first] = cur;
				}				
				mn[to.first] = min(min(mn[cur], to.second), mn[to.first]);
				mx[to.first] = max(max(mx[cur], to.second), mx[to.first]);
//				cout << cur << ' ' << to.first << ' ' << mn[cur] << ' ' << mx[cur] << ' ' << mn[to.first] << ' ' << mx[to.first] << "\n";
			}
		}
	}
}

int main() {
	#ifdef Madi
	freopen(".in", "r", stdin);
	freopen(".out", "w", stdout);
	#endif

	cin >> n >> m;
	for (int i = 1; i <= n; ++i) {
		mn[i] = INF;
		mx[i] = 0;
		d[i] = make_pair(INF, 0);
		ds[i] = -1;
	}

	for (int i = 1; i <= m; ++i) {
		int a, b, c;
		cin >> a >> b >> c;

		g[a].push_back(make_pair(b, c));
		g[b].push_back(make_pair(a, c));
	}

	bfs();	

	vector<int> res;
	while (n != 1) {
		res.push_back(n);
		n = pr[n];
	}
	res.push_back(1);
	reverse(res.begin(), res.end());
	
	cout << res.size() - 1 << "\n";
	for (auto it : res)
		cout << it << ' ';
	return 0;
}