#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

typedef long long ll;
const int maxn = (int) 4e6 + 1;


struct node{
    node *child[30];
    int cnt = 0;
};

node *get(){
    node *p=new node();
    p->cnt=0;
    for(int i=0;i<27;i++){
        p->child[i]=nullptr;
    }
    return p;
}

node *head;
void add(string s){
    node *cur=head;
    for(int i=0;i<s.size();i++){
        int p = s[i]-'a';
        if(cur->child[p]==nullptr){
            cur->child[p]=get();
        }
        cur=cur->child[p];
        cur->cnt++;
    }
}

int n,m;
int mx=0,mxp=0,mxd=0;
void search(node *root, int pr_cnt, int dp){
    if(root->cnt==0) return ;
    if(root->cnt<=m){
        if(mx < root->cnt){
            mx=root->cnt;
            mxd=dp;
            mxp=pr_cnt;
        }
        else if(root->cnt==mx){
            if(mxd < dp){
                mxd = dp;
                mxp=pr_cnt;
            }else if(mxd == dp){
                mxp = min(mxp,pr_cnt);
            }
        }
        return ;
    }
    for(int i=0;i<26;i++){
        if(root->child[i]!=nullptr){
            search(root->child[i],root->cnt,dp+1);
        }
    }
}

string s[maxn];

bool ok;
void upd(node *root, int pr_cnt, int dp){
    if(ok) return ;
    if(root->cnt==0) return ;
    if(root->cnt==mx && pr_cnt == mxp && mxd == dp){
        root->cnt = 0;
        ok = true;
        return ;
    }
    if(root->cnt <= m){
        return;
    }
    for(int i=0;i<26;i++){
        if(root->child[i]!=nullptr){
            upd(root->child[i], root->cnt, dp+1);
        }
    }
    if(ok)
        root->cnt-=mx;
}

int main(){
    cin>>n>>m;
    head = get();
    head->cnt = n;
    for(int i=1;i<=n;i++){
        cin>>s[i];
        add(s[i]);
    }
    if(n<=m){
        cout<<1;
        return 0;
    }
    int ans = 0;
    while(n>m){
        mx = 0, mxp =(ll)1e9+7, mxd = 0;
        ans++;
        search(head, 0, 0);
        n -= mx;
        ok = false;
        upd(head, 0, 0);
    }
    cout << ans+(n>0);
}
