#include <bits/stdc++.h>

#define file ""

#define all(x) x.begin(), x.end()

#define sc second
#define fr first

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const ll inf = 1e18 + 5;
const ll mod = 1e9 + 7;

const int dx[] = {+1, -1, 0, 0};
const int dy[] = {0, 0, +1, -1};

const int N = 3e5 + 5;

int n, m;
vector<pii> g[N], g1[N];
ll d[N][2][2], len[3][N];
pair<int, pair<int, int> > parent[N][2][2]; 
map<int, map<int, int> > was;	

struct line {
 	int x, y, c;
};

vector<line> all;

void bfs(int t, int s) {
 	queue<int> q;
 	for (int i = 1; i <= n; i++) 
 		len[t][i] = 1e9;
 	len[t][s] = 0;
 	q.push(s);
 	while (!q.empty()) {
 	 	int x = q.front();
 	 	q.pop();
 	 	for (auto to : g[x]) {
 	 	 	if (len[t][to.fr] > len[t][x] + 1) {
 	 	 		len[t][to.fr] = len[t][x] + 1;
 	 	 	 	q.push(to.fr);
 	 	 	}
 	 	}
 	}
}

void go() {
 	bfs(1, 1);
 	bfs(2, n);
}

void go(int x, int y) {
 	if (len[1][x] + len[2][y] + 1 == len[1][n] || len[1][y] + len[2][x] + 1 == len[1][n])
 		was[x][y] = was[y][x] = true;
 	else
 		was[x][y] = was[y][x] = false;
}

void rebuild() {
 	for (int i = 0; i < m; i++)	{
 	 	int x = all[i].x;
 	 	int y = all[i].y;
 	 	if (len[1][x] > len[1][y])
 	 		swap(x, y);
 	 	go(x, y);
 	 	int c = all[i].c;
 	 	if (was[x][y] == true) {
 	 	 	g1[x].pb({y, c});
 	 	}
 	}
 	swap(g, g1);
}

int main() {    
  ios_base :: sync_with_stdio(false);
  cin.tie(NULL);
  srand(time(NULL));
  cin >> n >> m;

  for (int i = 1; i <= m; i++) {
   	int x, y, c;
   	cin >> x >> y >> c;
   	was[x][y] = true;
   	g[x].pb({y, c});
   	g[y].pb({x, c});
   	all.pb({x, y, c});
  }

  for (int i = 0; i <= n; i++)
    for (int j = 0; j < 2; j++)
      for (int k = 0; k < 2; k++)
        d[i][j][k] = (ll)1e18;
  
  go();
  rebuild();
  
                         
  d[1][0][0] = 0;
  set<pair<ll, array<int, 3>>> q;
  q.insert({0, {1, 0, 0}});

  while (!q.empty()) {
    auto [v, mx, mn] = q.begin()->second;
    q.erase(q.begin());

    for (auto to : g[v]) {

    	int u = to.fr;
    	int w = to.sc;

    	for (int i = 0; i <= 1 - mx; i++)
    		for (int j = 0; j <= 1 - mn; j++) {

        	if (d[u][mx + i][mn + j] > d[v][mx][mn] - (i == 1) * w + (j == 1) * w) {
            
                q.erase({d[u][mx + i][mn + j], {u, mx + i, mn + j}});
                d[u][mx + i][mn + j] = d[v][mx][mn] - (i == 1) * w + (j == 1) * w;
                parent[u][mx + i][mn + j] = {v, {mx, mn}};
                q.insert({d[u][mx + i][mn + j], {u, mx + i, mn + j}});
        	
        	}

        }
    }
  }
  vector<int> path;
  int f = 1;
  int s = 1;
  do {
      path.pb(n);
      pair<int, pii> nxt = parent[n][f][s];
      n = nxt.fr;
      f = nxt.sc.fr;
      s = nxt.sc.sc;
  } while (n != 0);
  reverse(all(path));
  cout << path.size() - 1 << endl;
  for (int to : path)
    cout << to << " ";
 	return 0;
}